------------------------------------------------------------ Paladin ------------------------------------------------------------------------------------
function DUF_PaladinPowerBar_ToggleHolyRune(self, visible)
	if visible then
		self.DUF_deactivate:Play();
	else
		self.DUF_activate:Play();
	end
end

function DUF_PaladinPowerBar_OnUpdate(self, elapsed)
	self.delayedUpdate = self.delayedUpdate - elapsed;
	if ( self.delayedUpdate <= 0 ) then
		self.delayedUpdate = nil;
		self:SetScript("OnUpdate", nil);
		DUF_PaladinPowerBar_Update(self);
	end
end

function DUF_PaladinPowerBar_Update(self)
	if ( self.delayedUpdate ) then
		return;
	end
	
	local numHolyPower = UnitPower("player", SPELL_POWER_HOLY_POWER );
	local maxHolyPower = UnitPowerMax("player", SPELL_POWER_HOLY_POWER );
	
	-- a little hacky but we want to signify that the bank is being used to replenish holy power
	if ( self.lastPower and self.lastPower > HOLY_POWER_FULL and numHolyPower == self.lastPower - HOLY_POWER_FULL ) then
		for i = 1, HOLY_POWER_FULL do
			DUF_PaladinPowerBar_ToggleHolyRune(self["DUF_rune"..i], true);
		end
		self.lastPower = nil;
		self.delayedUpdate = 0.5;
		self:SetScript("OnUpdate", DUF_PaladinPowerBar_OnUpdate);
		return;
	end
	
	for i=1,maxHolyPower do
		local holyRune = self["DUF_rune"..i];
		local isShown = holyRune:GetAlpha()> 0 or holyRune.DUF_activate:IsPlaying();
		local shouldShow = i <= numHolyPower;
		if isShown ~= shouldShow then 
			DUF_PaladinPowerBar_ToggleHolyRune(holyRune, isShown);
		end
	end

	-- flash the bar if it's full (3 holy power)
	if numHolyPower >= HOLY_POWER_FULL then
		self.DUF_glow.DUF_pulse.stopPulse = false;
		self.DUF_glow.DUF_pulse:Play();
	else
		self.DUF_glow.DUF_pulse.stopPulse = true;
	end
	
	-- check whether to show bank slots
--[[
	if ( maxHolyPower ~= self.maxHolyPower ) then
		if ( maxHolyPower > HOLY_POWER_FULL ) then
			self.DUF_showBankAnim:Play();
		else
			-- there is no way to lose the bank slots once you have them, but just in case
			self.DUF_showBankAnim:Stop();
			self.DUF_bankBG:SetAlpha(0);
		end
		self.maxHolyPower = maxHolyPower;
	end
]]--	
	self.lastPower = numHolyPower;
end



function DUF_PaladinPowerBar_OnLoad (self)
	-- Disable frame if not a paladin
	local _, class = UnitClass("player");	
	if ( class ~= "PALADIN" ) then
		self:Hide();
		return;
	elseif UnitLevel("player") < PALADINPOWERBAR_SHOW_LEVEL then
		self:RegisterEvent("PLAYER_LEVEL_UP");
		self:SetAlpha(0);
	end
	
	self.maxHolyPower = UnitPowerMax("player", SPELL_POWER_HOLY_POWER);
--	if ( self.maxHolyPower > HOLY_POWER_FULL ) then
--		self.DUF_bankBG:SetAlpha(1);
--	end

	self:RegisterEvent("UNIT_POWER");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("UNIT_DISPLAYPOWER");
	
	self.DUF_glow:SetAlpha(0);
	self.DUF_rune1:SetAlpha(0);
	self.DUF_rune2:SetAlpha(0);
	self.DUF_rune3:SetAlpha(0);
	self.DUF_rune4:SetAlpha(0);
	self.DUF_rune5:SetAlpha(0);
end



function DUF_PaladinPowerBar_OnEvent (self, event, ...)
	local arg1, arg2 = ...
	if ( (event == "UNIT_POWER") and (arg1 == self:GetParent().unit) ) then
		if ( arg2 == "HOLY_POWER" ) then
			DUF_PaladinPowerBar_Update(self);
		end
	elseif( event ==  "PLAYER_LEVEL_UP" ) then
		local level = arg1;
		if level >= PALADINPOWERBAR_SHOW_LEVEL then
			self:UnregisterEvent("PLAYER_LEVEL_UP");
			self.DUF_showAnim:Play();
			DUF_PaladinPowerBar_Update(self);
		end
	else
		DUF_PaladinPowerBar_Update(self);
	end
end

------------------------------------------------------------ Warlock ------------------------------------------------------------------------------------
--local WARLOCK_POWER_FILLBAR = {
--	Demonology 			= { left = 0.03906250, right = 0.55468750, top = 0.10546875, bottom = 0.19921875, width = 132, fileWidth = 256 };
--	DemonologyActivated	= { left = 0.03906250, right = 0.55468750, top = 0.00390625, bottom = 0.09765625, width = 132, fileWidth = 256 };
--	Destruction			= { left = 0.30078125, right = 0.37890625, top = 0.32812500, bottom = 0.67187500, height = 22, fileHeight = 64 };
--};

local WARLOCK_POWER_FILLBAR = {
	Demonology 			= { left = 0, right = 1, top = 0, bottom = 1, width = 128, fileWidth = 128 };
	DemonologyActivated	= { left = 0, right = 1, top = 0, bottom = 1, width = 125, fileWidth = 128 };
--	Destruction			= { left = 0.30078125, right = 0.37890625, top = 0.32812500, bottom = 0.67187500, height = 22, fileHeight = 64 };
	Destruction			= { left = 0.30078125, right = 0.37890625, top = 0.66812500, bottom = 0.67187500, height = 22, fileHeight = 64 };
};
-- Fizzlemizz: Comment: playing with Destro "top" (above) to get embers looking right.
-- Fizzlemizz: Comment: maybe try replacing the fire with the glow for the fill operation. It won't produce the "pop" when you hit max or less than max

local MAX_POWER_PER_EMBER = 10;

-- GENERAL WARLOCK
function DUF_WarlockPowerFrame_OnLoad(self)
	local _, class = UnitClass("player");
	if ( class == "WARLOCK" ) then
		self:RegisterEvent("PLAYER_ENTERING_WORLD");
		self:RegisterEvent("UNIT_DISPLAYPOWER");
		self:RegisterUnitEvent("UNIT_POWER_FREQUENT", "player", "vehicle");	
		self:RegisterEvent("PLAYER_TALENT_UPDATE");
		--self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
		DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame.shardCount = 3;
		DUF_PlayerFrame_WarlockPowerFrame_EmberBarFrame.emberCount = 3;
		DUF_PlayerFrame_WarlockPowerFrame_EmberBarFrame.displayedPower = 0;
--		DUF_PlayerFrame_WarlockPowerFrame_DemonicFuryBarFrame.displayedPower = 0;
		DUF_WarlockPowerFrame_SetUpCurrentPower(self);
	end
end

function DUF_WarlockPowerFrame_OnEvent(self, event, ...)
	local arg1, arg2 = ...
	-- update events
	if ( self.activeBar ) then
		if ( (event == "UNIT_POWER_FREQUENT") and (arg1 == DUF_PlayerFrame.unit) ) then
			self.activeBar:OnEvent(arg2);
			return;
		elseif ( event == "UNIT_DISPLAYPOWER" or event == "PLAYER_ENTERING_WORLD" ) then
			self.activeBar:OnEvent();
			return;
		end
	end
	-- power specific events
--	if ( event == "UNIT_AURA" and (arg1 == DUF_PlayerFrame.unit) ) then
--		DUF_DemonicFuryBar_CheckAndSetState();
--	elseif ( event == "SPELLS_CHANGED" ) then
	if ( event == "SPELLS_CHANGED" ) then
		if ( IsPlayerSpell(self.reqSpellID) ) then
			self:UnregisterEvent("SPELLS_CHANGED");
			self.reqSpellID = nil;
			-- clear spec to force reevaluation
			self.spec = nil;
			DUF_WarlockPowerFrame_SetUpCurrentPower(self, true);
		end
--	elseif ( self.activeBar and event == "CVAR_UPDATE" and ( arg1 == "STATUS_TEXT_PLAYER" or arg1 == "STATUS_TEXT_PERCENT" ) ) then
--		DUF_DemonicFuryBar_CheckStatusCVars(self.activeBar);
--		self.activeBar:OnEvent(nil, true);
	-- power may have changed
	elseif ( event == "PLAYER_TALENT_UPDATE" ) then
		DUF_WarlockPowerFrame_SetUpCurrentPower(self, true);
	end
end

-- this function might be called to reshow the power bar, like after leaving a vehicle
function DUF_WarlockPowerFrame_SetUpCurrentPower(self, shouldAnim)
	self = self or DUF_PlayerFrame_WarlockPowerFrame;
	local doShow = false;
	local doAnim = false;
	local spec = GetSpecialization();
	if ( spec == SPEC_WARLOCK_AFFLICTION ) then
		-- set up Affliction
		if ( self.spec ~= spec ) then
			-- tear down Demonic and Destruction
--			DUF_PlayerFrame_WarlockPowerFrame_DemonicFuryBarFrame:Hide();
--			self:UnregisterEvent("UNIT_AURA");
--			self:UnregisterEvent("CVAR_UPDATE");
			DUF_PlayerFrame_WarlockPowerFrame_EmberBarFrame:Hide();
			self:UnregisterEvent("SPELLS_CHANGED");
			self:SetScript("OnUpdate", nil);
			-- set up Affliction
			-- only show shard bar if soulburn is known
			if ( IsPlayerSpell(WARLOCK_SOULBURN) ) then
				self.activeBar = DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame;
				self.activeBar.OnEvent = DUF_ShardBar_Update;
				DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame:Show();
				if ( shouldAnim ) then
					doAnim = true;
				end
			else
				self.activeBar = nil;
				self:RegisterEvent("SPELLS_CHANGED");
				self.reqSpellID = WARLOCK_SOULBURN;
			end
		end
		doShow = true;
	elseif ( spec == SPEC_WARLOCK_DESTRUCTION ) then
		-- set up Destruction
		if ( self.spec ~= spec ) then
			-- tear down Affliction and Demonic
--			DUF_PlayerFrame_WarlockPowerFrame_DemonicFuryBarFrame:Hide();
--			self:UnregisterEvent("UNIT_AURA");
--			self:UnregisterEvent("CVAR_UPDATE");
			DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame:Hide();
			self:UnregisterEvent("SPELLS_CHANGED");
			-- set up Destruction
			-- only show if burning embers is known
			if ( IsPlayerSpell(WARLOCK_BURNING_EMBERS) ) then
				self.activeBar = DUF_PlayerFrame_WarlockPowerFrame_EmberBarFrame;
				self.activeBar.OnEvent = DUF_BurningEmbersBar_Update;
				self.activeBar.SetPower = DUF_BurningEmbersBar_SetPower;
				self:SetScript("OnUpdate", DUF_WarlockPowerFrame_OnUpdate);
				DUF_PlayerFrame_WarlockPowerFrame_EmberBarFrame:Show();
				if ( shouldAnim ) then
					doAnim = true;
				end
			else
				self.activeBar = nil;
				self:SetScript("OnUpdate", nil);
				self:RegisterEvent("SPELLS_CHANGED");
				self.reqSpellID = WARLOCK_BURNING_EMBERS;
			end
		end
		doShow = true;
	else
		-- no spec
		self.activeBar = nil;
		self:UnregisterEvent("SPELLS_CHANGED");
		self:UnregisterEvent("UNIT_AURA");
		self:UnregisterEvent("CVAR_UPDATE");
		self:Hide();
	end
	
	self.spec = spec;
	if ( doShow ) then
		self:Show();
		if ( doAnim ) then
			self:SetAlpha(0);
			self.showAnim:Play();
		end
		if ( self.activeBar ) then
			self.activeBar:OnEvent(nil, true);	-- forces instant update instead of smooth progress
		end
	end
end

function DUF_WarlockPowerFrame_UpdateFill(texture, texData, value, maxValue)
--	if not (DUF_INITIALIZED) then return; end
--	local settings = DUF_Settings[DUF_INDEX].player.WarlockPowerFrame;
--	texData["height"] = settings.size;
	if ( value <= 0 ) then
		texture:Hide();
	elseif ( value >= maxValue ) then
		texture:SetTexCoord(texData["left"], texData["right"], texData["top"], texData["bottom"]);
		if ( texData.width ) then
			texture:SetWidth(texData["width"]);
		else
			texture:SetHeight(texData["height"]);
		end
		texture:Show();
	else
		if ( texData.width ) then
			local texWidth = (value / maxValue) * texData["width"];
			local right = texData["left"] + texWidth / texData["fileWidth"];
			texture:SetTexCoord(texData["left"], right, texData["top"], texData["bottom"]);
			texture:SetWidth(texWidth);
		else
			local texHeight = (value / maxValue) * texData["height"];
			local top = texData["bottom"] - texHeight / texData["fileHeight"];
			texture:SetTexCoord(texData["left"], texData["right"], top, texData["bottom"]);
			texture:SetHeight(texHeight);
		end
		texture:Show();
	end
--[[
	if ( value <= 0 ) then
		texture:Hide();
	elseif ( value >= maxValue ) then
		texture:SetTexCoord(texData["left"], texData["right"], texData["top"], texData["bottom"]);
		if ( texData.width ) then
			texture:SetWidth(texData["width"]);
		else
			texture:SetHeight(texData["height"]);
		end
		texture:Show();
	else
		if ( texData.width ) then
			local texWidth = (value / maxValue) * texData["width"];
			local right = texData["left"] + texWidth / texData["fileWidth"];
			texture:SetTexCoord(texData["left"], right, texData["top"], texData["bottom"]);
			texture:SetWidth(texWidth);
		else
			local texHeight = (value / maxValue) * texData["height"];
			local top = texData["bottom"] - texHeight / texData["fileHeight"];
			texture:SetTexCoord(texData["left"], texData["right"], top, texData["bottom"]);
			texture:SetHeight(texHeight);
		end
		texture:Show();
	end
]]--	
end

function DUF_WarlockPowerFrame_OnUpdate(self, elapsed)
	local activeBar = self.activeBar;
	if ( activeBar.power and activeBar.power ~= activeBar.displayedPower ) then
		activeBar:SetPower(GetSmoothProgressChange(activeBar.power, activeBar.displayedPower, activeBar.maxPower, elapsed));
	end
end

-- AFFLICTION
function DUF_ShardBar_SetShard(self, active)
	if ( active ) then
		if (self.animOut:IsPlaying()) then
			self.animOut:Stop();
		end
		
		if (not self.active and not self.animIn:IsPlaying()) then
			self.animIn:Play();
			self.active = true;
		end
	else
		if (self.animIn:IsPlaying()) then
			self.animIn:Stop();
		end
		
		if (self.active and not self.animOut:IsPlaying()) then
			self.animOut:Play();
			self.active = false;
		end
	end
end

function DUF_ShardBar_Update(self, powerType)
	if ( powerType and powerType ~= "SOUL_SHARDS" ) then
		return;
	end

	local numShards = UnitPower("player", SPELL_POWER_SOUL_SHARDS );
	local maxShards = UnitPowerMax("player", SPELL_POWER_SOUL_SHARDS );
	-- if max shards changed, show/hide the 4th and update anchors 
	if ( self.shardCount ~= maxShards ) then
		if ( maxShards == 3 ) then
--			self.shard1:SetPoint("TOPLEFT", 0, 0);
--			self.shard2:SetPoint("TOPLEFT", self.shard1, "TOPLEFT", 35, 0);
--			self.shard3:SetPoint("TOPLEFT", self.shard2, "TOPLEFT", 35, 0);
			self.DUF_shard4:Hide();
		else
--			self.shard1:SetPoint("TOPLEFT", -10, 0);
--			self.shard2:SetPoint("TOPLEFT", self.shard1, "TOPLEFT", 30, 0);
--			self.shard3:SetPoint("TOPLEFT", self.shard2, "TOPLEFT", 30, 0);
			self.DUF_shard4:Show();
		end
		self.shardCount = maxShards;
	end
	-- update individual shard display
	for i = 1, maxShards do
		local shard = _G["DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame_Shard_"..i];
		local shouldShow = i <= numShards;
		DUF_ShardBar_SetShard(shard, shouldShow);
	end
end

-- DESTRUCTION

function DUF_BurningEmbersBar_Update(self, powerType, forceUpdate)
	if ( powerType and powerType ~= "BURNING_EMBERS" ) then
		return;
	end

	local maxPower = UnitPowerMax("player", SPELL_POWER_BURNING_EMBERS, true);
	local power = UnitPower("player", SPELL_POWER_BURNING_EMBERS, true);
	local numEmbers = floor(maxPower / MAX_POWER_PER_EMBER);

	if ( self.emberCount ~= numEmbers ) then
		if ( numEmbers == 3 ) then
			--self.ember1:SetPoint("TOPLEFT", 17, 7);
			--self.ember2:SetPoint("LEFT", self.ember1, 40, 0);
			--self.ember3:SetPoint("LEFT", self.ember2, 40, 0);
			self.DUF_ember4.fire:Hide();
			self.DUF_ember4.active = false;
			self.DUF_ember4:Hide();
		else
			--self.ember1:SetPoint("TOPLEFT", 16, 7);
			--self.ember2:SetPoint("LEFT", self.ember1, 26, 0);
			--self.ember3:SetPoint("LEFT", self.ember2, 26, 0);
			self.DUF_ember4:Show();
		end
		self.emberCount = numEmbers;
	end
	self.power = power;
	self.maxPower = maxPower;
	if ( forceUpdate ) then
		DUF_BurningEmbersBar_SetPower(self, power);
	end
end

function DUF_BurningEmbersBar_SetPower(self, power)
	self.displayedPower = power;
	for i = 1, self.emberCount do
		local ember = self["DUF_ember"..i];
		DUF_WarlockPowerFrame_UpdateFill(ember.fill, WARLOCK_POWER_FILLBAR["Destruction"], power, MAX_POWER_PER_EMBER);

		-- animate?
		if ( power >= MAX_POWER_PER_EMBER ) then
			if (ember.animOut:IsPlaying()) then
				ember.animOut:Stop();
			end
			
			if (not ember.active and not ember.animIn:IsPlaying()) then
				ember.animIn:Play();
				ember.active = true;
				ember.fire:Show();
			end
		else
			if (ember.animIn:IsPlaying()) then
				ember.animIn:Stop();
			end
			
			if (ember.active and not ember.animOut:IsPlaying()) then
				ember.animOut:Play();
				ember.active = false;
				ember.fire:Hide();
			end
		end
		
		-- leftover for the other embers
		power = power - MAX_POWER_PER_EMBER;
	end
end

---------------------------------------------------------- Death Knight ---------------------------------------------------------------------------------
function DUF_RuneFrame_OnLoad(self)
	-- Disable rune frame if not a death knight.
--	local _, class = UnitClass("player");
	
--	if ( class ~= "DEATHKNIGHT" ) then
--		self:Hide();
--	end
	
	self:RegisterEvent("RUNE_POWER_UPDATE");
	self:RegisterEvent("RUNE_TYPE_UPDATE");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	
	self:SetScript("OnEvent", DUF_RuneFrame_OnEvent);
end

local RUNETYPE_BLOOD = 1;
local RUNETYPE_UNHOLY = 2;
local RUNETYPE_FROST = 3;
local RUNETYPE_DEATH = 4;

local MAX_RUNES = 6;


local iconTextures = {};
iconTextures[RUNETYPE_BLOOD] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Blood";
iconTextures[RUNETYPE_UNHOLY] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Unholy";
iconTextures[RUNETYPE_FROST] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Frost";
iconTextures[RUNETYPE_DEATH] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Death";

local runeTextures = {
	[RUNETYPE_BLOOD] = "Interface\\PlayerFrame\\UI-PlayerFrame-DeathKnight-Blood-Off.tga",
	[RUNETYPE_UNHOLY] = "Interface\\PlayerFrame\\UI-PlayerFrame-DeathKnight-Death-Off.tga",
	[RUNETYPE_FROST] = "Interface\\PlayerFrame\\UI-PlayerFrame-DeathKnight-Frost-Off.tga",
	[RUNETYPE_DEATH] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Chromatic-Off.tga",
}



local runeEnergizeTextures = {
	[RUNETYPE_BLOOD] = "Interface\\PlayerFrame\\Deathknight-Energize-Blood",
	[RUNETYPE_UNHOLY] = "Interface\\PlayerFrame\\Deathknight-Energize-Unholy",
	[RUNETYPE_FROST] = "Interface\\PlayerFrame\\Deathknight-Energize-Frost",
	[RUNETYPE_DEATH] = "Interface\\PlayerFrame\\Deathknight-Energize-White",
}

local runeColors = {
	[RUNETYPE_BLOOD] = {1, 0, 0},
	[RUNETYPE_UNHOLY] = {0, 0.5, 0},
	[RUNETYPE_FROST] = {0, 1, 1},
	[RUNETYPE_DEATH] = {0.8, 0.1, 1},
}

function DUF_RuneFrame_OnEvent(self, event, ...)
	if ( event == "PLAYER_ENTERING_WORLD" ) then
		for i=1,MAX_RUNES do
			local runeButton = _G["DUF_PlayerFrame_RuneFrame_RuneButtonIndividual"..i];
			if runeButton then
				RuneButton_Update(runeButton, i, true);
			end
		end
	elseif ( event == "RUNE_POWER_UPDATE" ) then
		local runeIndex, isEnergize = ...;
		if runeIndex and runeIndex >= 1 and runeIndex <= MAX_RUNES  then 
			local runeButton = _G["DUF_PlayerFrame_RuneFrame_RuneButtonIndividual"..runeIndex];
			local cooldown = _G[runeButton:GetName().."Cooldown"];
			
			local start, duration, runeReady = GetRuneCooldown(runeIndex);
			
			if not runeReady  then
				if start then
					CooldownFrame_SetTimer(cooldown, start, duration, 1);
				end
				runeButton.energize:Stop();
			else
				cooldown:Hide();
				runeButton.shine:SetVertexColor(1, 1, 1);
				RuneButton_ShineFadeIn(runeButton.shine)
			end
			
			if isEnergize  then
				runeButton.energize:Play();
			end
		else 
			assert(false, "Bad rune index")
		end

	elseif ( event == "RUNE_TYPE_UPDATE" ) then
		local runeIndex = ...;
		if ( runeIndex and runeIndex >= 1 and runeIndex <= MAX_RUNES ) then
			RuneButton_Update(_G["DUF_PlayerFrame_RuneFrame_RuneButtonIndividual"..runeIndex], runeIndex);
		end
	end
end

---------------------------------------------------------- Priest ---------------------------------------------------------------------------------------

function DUF_PriestOrbFrame_OnLoad(self)
	local _, class = UnitClass("player");
	if ( class == "PRIEST" ) then
		self:SetFrameLevel(self:GetParent():GetFrameLevel() + 2);
		if ( UnitLevel("player") < SHADOW_ORBS_SHOW_LEVEL ) then
			self:RegisterEvent("PLAYER_LEVEL_UP");
		else
			self.hasReqLevel = true;
			self:RegisterEvent("PLAYER_TALENT_UPDATE");
		end
		DUF_PriestOrbFrame_CheckAndShow(self);
	end
end

function DUF_PriestOrbFrame_OnEvent(self, event, ...)
	local arg1, arg2 = ...
	if ( (event == "UNIT_POWER_FREQUENT") and (arg1 == self:GetParent().unit) ) then
		if ( arg2 == "SHADOW_ORBS" ) then
			DUF_PriestBar_Update();
		end
	elseif ( event == "UNIT_DISPLAYPOWER" ) then
		DUF_PriestBar_Update();
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		DUF_PriestBar_Update();
	elseif ( event == "PLAYER_TALENT_UPDATE" ) then
		DUF_PriestOrbFrame_CheckAndShow(self);
	elseif( event ==  "PLAYER_LEVEL_UP" ) then
		local level = arg1;
		if ( level >= SHADOW_ORBS_SHOW_LEVEL ) then
			self.hasReqLevel = true;
			self:UnregisterEvent("PLAYER_LEVEL_UP");
			-- have to watch out for spec changes
			self:RegisterEvent("PLAYER_TALENT_UPDATE");
			-- clear spec to force reevaluation
			self.spec = nil;
			DUF_PriestOrbFrame_CheckAndShow(self, true);
		end
	end
end

-- this function might be called to reshow the power bar, like after leaving a vehicle
function DUF_PriestOrbFrame_CheckAndShow(self)
	self = self or DUF_PlayerFrame_PriestOrbFrame;
	-- check spec
	local spec = GetSpecialization();
	if ( spec == SPEC_PRIEST_SHADOW ) then
		if ( self.hasReqLevel ) then
			local adjustAttachments;
			if ( spec ~= self.spec ) then
				self:RegisterEvent("PLAYER_ENTERING_WORLD");
				self:RegisterEvent("UNIT_DISPLAYPOWER");
				self:RegisterUnitEvent("UNIT_POWER_FREQUENT", "player", "vehicle");
				self:SetAlpha(0);
				self.showAnim:Play();
				adjustAttachments = true;
			end
			self:Show();
--			if ( adjustAttachments ) then
--				PlayerFrame_AdjustAttachments();
--			end
			DUF_PriestBar_Update();
		end
	else
		-- undo previous spec
		if ( self.spec == SPEC_PRIEST_SHADOW ) then
			self:UnregisterEvent("PLAYER_ENTERING_WORLD");
			self:UnregisterEvent("UNIT_DISPLAYPOWER");
			self:UnregisterEvent("UNIT_POWER_FREQUENT");
			self:Hide();
--			PlayerFrame_AdjustAttachments();
		end
	end
	self.spec = spec;
end

function DUF_PriestBar_Update()
--	local numOrbs = UnitPower(DUF_PlayerFrame_PriestOrbFrame:GetParent().unit, SPELL_POWER_SHADOW_ORBS );
	local numOrbs = UnitPower("player", SPELL_POWER_SHADOW_ORBS );
	for i = 1, PRIEST_BAR_NUM_ORBS do
		local orb = _G["DUF_PlayerFrame_PriestOrbFrame_Orb_"..i];
		local shouldShow = i <= numOrbs;
		DUF_PriestBar_SetOrb(orb, shouldShow);
	end
end

function DUF_PriestBar_SetOrb(self, active)
	if ( active ) then
		if (self.animOut:IsPlaying()) then
			self.animOut:Stop();
		end
		
		if (not self.active and not self.animIn:IsPlaying()) then
			self.animIn:Play();
			self.active = true;
		end
	else
		if (self.animIn:IsPlaying()) then
			self.animIn:Stop();
		end
		
		if (self.active and not self.animOut:IsPlaying()) then
			self.animOut:Play();
			self.active = false;
		end
	end
end