function DUF_Element_OnDragStart(self)
	if (DUF_ELEMENTS_UNLOCKED) then
		self.moving = true;
		if (self.moveparent) then
			self:GetParent():StartMoving();
		else
			self:StartMoving();
		end
	elseif (DUF_FRAMES_UNLOCKED) then
		if (self.moveparent) then
			self:GetParent():GetParent():StartMoving();
		else
			self:GetParent():StartMoving();
		end
	end
end

function DUF_Element_GetOffsets(element, baseframe, settings)
	if (settings.attach ~= "Unit Frame" and settings.attach ~= "UIParent") then
		baseframe = _G[baseframe:GetName()..settings.attach];
	elseif (settings.attach == "UIParent") then
		baseframe = UIParent;
	end
	local xoffset, yoffset = DL_Get_Offsets(element, baseframe, settings.attachpoint, settings.attachto)
	return xoffset, yoffset;
end

function DUF_Element_OnDragStop(self)
	if (DUF_ELEMENTS_UNLOCKED) then
		self.moving = nil;
		if (self.moveparent) then
			self:GetParent():StopMovingOrSizing();
		else
			self:StopMovingOrSizing();
		end
		local frameindex, unitframe, xoffset, yoffset, settings;
		if (self.moveparent) then
			frameindex = DUF_FRAME_DATA[self:GetParent():GetParent().unit].index;
			if (self:GetParent().subindex) then
				settings = DUF_Settings[DUF_INDEX][frameindex][self:GetParent().index][self:GetParent().subindex];
			else
				settings = DUF_Settings[DUF_INDEX][frameindex][self:GetParent().index];
			end
			unitframe = _G[self:GetParent():GetParent():GetName()];
			xoffset, yoffset = DUF_Element_GetOffsets(self:GetParent(), unitframe, settings);
		else
--			frameindex = DUF_FRAME_DATA[self:GetParent().unit].index;
			frameindex = DUF_FRAME_DATA[self.unit].index;
			if (self.subindex) then
				settings = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex];
			else
				settings = DUF_Settings[DUF_INDEX][frameindex][self.index];
			end
			unitframe = _G[self:GetParent():GetName()];
			xoffset, yoffset = DUF_Element_GetOffsets(self, unitframe, settings);
		end
		if (self.subindex) then
			DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].xoffset = xoffset;
			DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].yoffset = yoffset;
		elseif (self.moveparent) then
			DUF_Settings[DUF_INDEX][frameindex][self:GetParent().index].xoffset = xoffset;
			DUF_Settings[DUF_INDEX][frameindex][self:GetParent().index].yoffset = yoffset;
		else
			DUF_Settings[DUF_INDEX][frameindex][self.index].xoffset = xoffset;
			DUF_Settings[DUF_INDEX][frameindex][self.index].yoffset = yoffset;
		end
		if (self.moveparent) then
			local settings = DUF_Settings[DUF_INDEX][frameindex][self:GetParent().index];
			local element = DUF_Get_ElementName(self:GetParent().index, self:GetParent().subindex);
			if (frameindex == "party" or frameindex == "partypet") then
				for i=1,4 do
					local unitFrame = DUF_FRAME_DATA[frameindex..i].frame;
					DUF_Set_ElementPosition(_G[unitFrame..element], unitFrame, settings);
				end
			else
				local unitFrame = DUF_FRAME_DATA[frameindex].frame;
				DUF_Set_ElementPosition(_G[unitFrame..element], unitFrame, settings);
			end
		else
			local settings;
			if (self.subindex) then
				settings = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex];
			else
				settings = DUF_Settings[DUF_INDEX][frameindex][self.index];
			end
			local element = DUF_Get_ElementName(self.index, self.subindex);
			if (frameindex == "party" or frameindex == "partypet") then
				for i=1,4 do
					local unitFrame = DUF_FRAME_DATA[frameindex..i].frame;
					DUF_Set_ElementPosition(_G[unitFrame..element], unitFrame, settings);
				end
			else
				local unitFrame = DUF_FRAME_DATA[frameindex].frame;
				DUF_Set_ElementPosition(_G[unitFrame..element], unitFrame, settings);
			end
		end
		if (DUF_Options) then
			DUF_Init_BaseOptions();
		end
	elseif (DUF_FRAMES_UNLOCKED) then
		if (self.moveparent) then
			self = self:GetParent():GetParent();
		else
			self = self:GetParent();
		end
		DUF_UnitFrame_OnDragStop(self);
	end
end

function DUF_Element_OnEnter(self)
	if (self.index == nil) then return; end
	local unit = self:GetParent().unit;
	local settings;
	if (self.subindex) then
		settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index][self.index][self.subindex];
	else
		settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index][self.index];
	end
	if (settings.usemouseovercolor) then
--		_G[self:GetName().."_Background"]:SetBackdropColor(settings.mouseovercolor.r, settings.mouseovercolor.g, settings.mouseovercolor.b, settings.bgalpha);
		self:SetBackdropColor(settings.mouseovercolor.r, settings.mouseovercolor.g, settings.mouseovercolor.b, settings.bgalpha);
	end
	if (settings.mouseovergroup) then
		local unitFrame = self:GetParent();
		local unitFrameName = unitFrame:GetName();
		local element;

		if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].mouseovergroup == settings.mouseovergroup) then
			if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].usemouseovercolor) then
				_G[self:GetParent():GetName().."_Background"]:SetBackdropColor(DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].mouseovercolor.r, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].mouseovercolor.g, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].mouseovercolor.b, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].bgalpha);
			end
		end

		for index, value in pairs(DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index]) do
			if (type(value) == "table") then
				if (index == "StatusBar") then
					for i = 1,6 do
						if (value[i]) then
							if (value[i].mouseovergroup == settings.mouseovergroup) then
								if (value[i].mouseover) then
									_G[unitFrameName..DUF_Get_ElementName(index, i)]:Show();
								elseif (value[i].hidemouseover) then
									_G[unitFrameName..DUF_Get_ElementName(index, i)]:SetAlpha(0);
								end
								if (value[i].usemouseovercolor) then
									_G[unitFrameName..DUF_Get_ElementName(index, i).."_Background"]:SetBackdropColor(value[i].mouseovercolor.r, value[i].mouseovercolor.g, value[i].mouseovercolor.b, value[i].bgalpha);
								end
							end
						end
					end
				elseif (index == "TextBox") then
					local tb
					if (unit == "player") then
						tb = DUF_NUM_PLAYER_TEXTBOXES;
					else
						tb = DUF_NUM_OTHERS_TEXTBOXES;
					end
					for i = 1,tb do
						if (value[i].mouseovergroup == settings.mouseovergroup) then
							if (value[i].mouseover) then
								_G[unitFrameName..DUF_Get_ElementName(index, i)]:Show();
							elseif (value[i].hidemouseover) then
								_G[unitFrameName..DUF_Get_ElementName(index, i)]:SetAlpha(0);
							end
							if (value[i].usemouseovercolor) then
								_G[unitFrameName..DUF_Get_ElementName(index, i).."_Background"]:SetBackdropColor(value[i].mouseovercolor.r, value[i].mouseovercolor.g, value[i].mouseovercolor.b, value[i].bgalpha);
							end
						end
					end
				else
					if (value.mouseovergroup == settings.mouseovergroup) then
						if (value.mouseover) then
							_G[unitFrameName..DUF_Get_ElementName(index, i)]:Show();
						elseif (value.hidemouseover) then
							_G[unitFrameName..DUF_Get_ElementName(index, i)]:SetAlpha(0);
						end
						if (value.usemouseovercolor) then
							_G[unitFrameName..DUF_Get_ElementName(index).."_Background"]:SetBackdropColor(value.mouseovercolor.r, value.mouseovercolor.g, value.mouseovercolor.b, value.bgalpha);
						end
					end
				end
			end
		end
	end

	if (settings.hidemouseover) then
		self.oldalpha = self:GetAlpha();
		self:SetAlpha(0);
	end

	if (settings.disabletooltip) then
		return;
	end
	if (unit and UnitName(unit)) then
		if (settings.usecustomtooltip) then
			local text = settings.customtooltip;
			if (text) then
				for var, value in pairs(DUF_VARIABLE_FUNCTIONS) do
					if (string.find(text, var)) then
						text = value.func(text, unit, self); --Fizzlemizz: Fixed
					end
				end
				GameTooltip_SetDefaultAnchor(GameTooltip, self)	
				GameTooltip:SetText(text, 1, 1, 1, 1, 1);
				GameTooltip:Show();
			end
		else
			self.unit = unit;
		 	UnitFrame_OnEnter(self);
		end
	end
end

function DUF_Element_OnHide(self)
	if (self.moving) then
		DUF_Element_OnDragStop(self);
	end
end

function DUF_Element_OnLeave(self)
	if (self:GetParent().unit and UnitName(self:GetParent().unit)) then
		self.unit = self:GetParent().unit;
		UnitFrame_OnLeave(self);
	end
	if (self.moving) then
		DUF_Element_OnDragStop(self);
	end
	if (self.index == nil) then return; end
	local unit = self:GetParent().unit;
	local settings;
	if (self.subindex) then
		settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index][self.index][self.subindex];
	else
		settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index][self.index];
	end
	if (self.oldalpha) then
		self:SetAlpha(self.oldalpha);
		self.oldalpha = nil;
	end
		if (settings.usemouseovercolor) then
			self:SetBackdropColor(settings.bgcolor.r, settings.bgcolor.g, settings.bgcolor.b, settings.bgalpha);
		end
	if (settings.mouseovergroup) then
		local unitFrame = self:GetParent();
		local unitFrameName = unitFrame:GetName();
		local element;

		if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].mouseovergroup == settings.mouseovergroup) then
			if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].usemouseovercolor) then
				_G[self:GetParent():GetName().."_Background"]:SetBackdropColor(DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].bgcolor.r, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].bgcolor.g, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].bgcolor.b, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].bgalpha);
			end
		end

		for index, value in pairs(DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index]) do
			if (type(value) == "table") then
				if (index == "StatusBar") then
					for i = 1,6 do
						if (value[i]) then
							if (value[i].mouseovergroup == settings.mouseovergroup) then
								if (value[i].mouseover) then
									_G[unitFrameName..DUF_Get_ElementName(index, i)]:Hide();
								elseif (value[i].hidemouseover) then
									_G[unitFrameName..DUF_Get_ElementName(index, i)]:SetAlpha(value[i].alpha);
								end
								if (value[i].usemouseovercolor) then
									_G[unitFrameName..DUF_Get_ElementName(index, i).."_Background"]:SetBackdropColor(value[i].bgcolor.r, value[i].bgcolor.g, value[i].bgcolor.b, value[i].bgalpha);
								end
							end
						end
					end
				elseif (index == "TextBox") then
					for i = 1,10 do
						if (value[i].mouseovergroup == settings.mouseovergroup) then
							if (value[i].mouseover) then
								_G[unitFrameName..DUF_Get_ElementName(index, i)]:Hide();
							elseif (value[i].hidemouseover) then
								_G[unitFrameName..DUF_Get_ElementName(index, i)]:SetAlpha(value[i].alpha);
							end
							if (value[i].usemouseovercolor) then
								_G[unitFrameName..DUF_Get_ElementName(index, i).."_Background"]:SetBackdropColor(value[i].bgcolor.r, value[i].bgcolor.g, value[i].bgcolor.b, value[i].bgalpha);
							end
						end
					end
				else
					if (value.mouseovergroup == settings.mouseovergroup) then
						if (value.mouseover) then
							_G[unitFrameName..DUF_Get_ElementName(index, i)]:Hide();
						elseif (value.hidemouseover) then
							_G[unitFrameName..DUF_Get_ElementName(index, i)]:SetAlpha(value.alpha);
						end
						if (value.usemouseovercolor) then
							_G[unitFrameName..DUF_Get_ElementName(index).."_Background"]:SetBackdropColor(value.bgcolor.r, value.bgcolor.g, value.bgcolor.b, value.bgalpha);
						end
					end
				end
			end
		end
	end
end

function DUF_Element_OnLoad(self)
	local use3D
	local unit = self:GetParent().unit;
	if (string.find(self:GetName(), "Portrait")) then
		use3D = DUF_Get3D(unit)
	end
	self:RegisterForDrag("LeftButton", "RightButton");
	if (not string.find(self:GetName(), "Druid") and not string.find(self:GetName(), "TempEnchant") and not string.find(self:GetName(), "PalyPowerFrame") and not use3D) then 
		self:RegisterForClicks("AnyDown")
	end	
	self:SetAttribute("useparent*",true)
	if (string.find(self:GetName(), "Bar")) then
		self.index = "StatusBar";
		self.subindex = self:GetID();
	elseif (string.find(self:GetName(), "Portrait")) then
		self.index = "Portrait";
	elseif (string.find(self:GetName(), "ClassIcon")) then
		self.index = "ClassIcon";
	elseif (string.find(self:GetName(), "RankIcon")) then
		self.index = "RankIcon";
	elseif (string.find(self:GetName(), "RaceIcon")) then
		self.index = "RaceIcon";
	elseif (string.find(self:GetName(), "Buffs")) then
		self.index = "Buffs";
	elseif (string.find(self:GetName(), "RoleIcon")) then
		self.index = "RoleIcon";
	elseif (string.find(self:GetName(), "Debuffs")) then
		self.index = "Debuffs";
	elseif (string.find(self:GetName(), "LootIcon")) then
		self.index = "LootIcon";
	elseif (string.find(self:GetName(), "PVPIcon")) then
		self.index = "PVPIcon";
	elseif (string.find(self:GetName(), "LeaderIcon")) then
		self.index = "LeaderIcon";
	elseif (string.find(self:GetName(), "StatusIcon")) then
		self.index = "StatusIcon";
	elseif (string.find(self:GetName(), "TextBox")) then
		self.index = "TextBox";
		self.subindex = self:GetID();
	elseif (string.find(self:GetName(), "ComboPoints")) then
		self.index = "ComboPoints";
	elseif (string.find(self:GetName(), "VoiceIcon")) then
		self.index = "VoiceIcon";
	elseif (string.find(self:GetName(), "EliteTexture")) then
		self.index = "EliteTexture";
	elseif (string.find(self:GetName(), "MonkHarmony")) then
		self.index = "MonkHarmony";
	elseif (string.find(self:GetName(), "PriestOrbFrame")) then
		self.index = "PriestOrbFrame";
	elseif (string.find(self:GetName(), "RunFrame")) then
		self.index = "RunFrame";
	end
	self.baseframelevel = self:GetFrameLevel();
end

function DUF_Element_OnShow(self)
	if (not DUF_INITIALIZED) then return; end
	local unit = self:GetParent().unit;
	local frameindex = DUF_FRAME_DATA[unit].index;
	if (string.find(self:GetName(), "TargetHealthBar") or string.find(self:GetName(), "TargetManaBar") or self.checkname) then
		unit = unit.."target";
	end
	local color, bgcolor, bordercolor;
	local context, bgcontext, bordercontext, bgstyle;
	if (self.subindex) then
		context = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].context;
		bgcontext = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].bgcontext;
		bordercontext = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].bordercontext;
	elseif (self.index) then
		context = DUF_Settings[DUF_INDEX][frameindex][self.index].context;
		bgcontext = DUF_Settings[DUF_INDEX][frameindex][self.index].bgcontext;
		bordercontext = DUF_Settings[DUF_INDEX][frameindex][self.index].bordercontext;
	else
		return
	end

	if ((not context) and (not bgcontext) and (not bordercontext)) then return; end

	if (self.subindex) then
		bgcolor = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].bgcolor;
		bordercolor = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].bordercolor;
		bgalpha = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].bgalpha;
		borderalpha = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].borderalpha;
	else
		bgcolor = DUF_Settings[DUF_INDEX][frameindex][self.index].bgcolor;
		bordercolor = DUF_Settings[DUF_INDEX][frameindex][self.index].bordercolor;
		bgalpha = DUF_Settings[DUF_INDEX][frameindex][self.index].bgalpha;
		borderalpha = DUF_Settings[DUF_INDEX][frameindex][self.index].borderalpha;
	end

	local background = _G[self:GetName().."_Background"];

	if (self.index == "StatusBar") then
		if (self.subindex == 2 or self.subindex == 5) then
			color = self.manacolor;
		else
			color = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].color;
		end
	elseif (self.index == "TextBox") then
		color = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].textcolor;
	else
		color = bgcolor;
	end
	
	local r, g, b;
	if (context and context < 4) then
		if (context == 1) then
			r, g ,b = DUF_Get_DifficultyColor(unit, color);
		elseif (context == 2) then
			r, g ,b = DUF_Get_ReactionColor(unit, color);
		elseif (context == 3) then
			r, g ,b = DUF_Get_ClassColor(unit, color);
		end
		DUF_Element_SetColor(self, r, g, b, bgstyle, bgalpha);
	end
	if (bgcontext and bgcontext < 4) then
		if (bgcontext == 1) then
			r, g ,b = DUF_Get_DifficultyColor(unit, bgcolor);
		elseif (bgcontext == 2) then
			r, g ,b = DUF_Get_ReactionColor(unit, bgcolor);
		elseif (bgcontext == 3) then
			r, g ,b = DUF_Get_ClassColor(unit, bgcolor);
		end
		background:SetBackdropColor(r, g, b, bgalpha);
	end
	if (bordercontext and bordercontext < 4) then
		if (bordercontext == 1) then
			r, g ,b = DUF_Get_DifficultyColor(unit, color);
		elseif (bordercontext == 2) then
			r, g ,b = DUF_Get_ReactionColor(unit, color);
		elseif (bordercontext == 3) then
			r, g ,b = DUF_Get_ClassColor(unit, color);
		end
		background:SetBackdropBorderColor(r, g, b, borderalpha);
	end
end

function DUF_Element_OnUpdate(self, elapsed)
	if (not DUF_INITIALIZED) then return; end
	if (not self.timer) then self.timer = DUF_Settings[DUF_INDEX].updatespeed; end
	if (not self.index) then return; end
	if (self.flashing) then
		self.flashtime = self.flashtime - elapsed;
		if (self.flashtime < 0) then
			self.flashtime = .5;
			if (self.direction) then
				self.direction = nil;
			else
				self.direction = 1;
			end
		end
		if (self.direction) then
			self:SetAlpha(1 - self.flashtime);
		else
			self:SetAlpha(self.flashtime + .5);
		end
	end

	self.timer = self.timer - elapsed;
	if (self.timer < 0) then
		self.timer = DUF_Settings[DUF_INDEX].updatespeed;
		if (self.index == "TextBox") then
			self.update = true;
		end
		local unit = self:GetParent().unit;
		local frameindex = DUF_FRAME_DATA[unit].index;
		if (string.find(self:GetName(), "TargetHealthBar") or string.find(self:GetName(), "TargetManaBar") or self.checkname) then
			unit = unit.."target";
		end
	
		local context, bgcontext, bordercontext, flash, targetIcon;
		if (self.subindex) then
			context = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].context;
			bgcontext = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].bgcontext;
			bordercontext = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].bordercontext;
			flash = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].flashlowhealth;
		else
			context = DUF_Settings[DUF_INDEX][frameindex][self.index].context;
			bgcontext = DUF_Settings[DUF_INDEX][frameindex][self.index].bgcontext;
			bordercontext = DUF_Settings[DUF_INDEX][frameindex][self.index].bordercontext;
			flash = DUF_Settings[DUF_INDEX][frameindex][self.index].flashlowhealth;
		end

		if (flash) then
			if (UnitHealth(unit) and UnitHealthMax(unit)) then
				local crud
-- Fizzlemizz: Comment: Divide by zero				if (UnitHealth(unit) / UnitHealthMax(unit) <= DUF_Settings[DUF_INDEX].flashthreshold and UnitHealth(unit) > 0) then
				if UnitHealthMax(unit) == 0 then
					crud = UnitHealth(unit);
				else
					crud = UnitHealth(unit) / UnitHealthMax(unit);
				end
				if (crud <= DUF_Settings[DUF_INDEX].flashthreshold and UnitHealth(unit) > 0) then
					if (not self.flashing) then
						self.flashing = true;
						self.direction = 1;
						self.flashtime = .5;
					end
				else
					self.flashing = nil;
					if (self.subindex) then
						self:SetAlpha(DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].alpha);
					else
						self:SetAlpha(DUF_Settings[DUF_INDEX][frameindex][self.index].alpha);
					end
				end
			end

			if (GetSpecialization() == SPEC_WARLOCK_DEMONOLOGY and UnitPower("player", SPELL_POWER_DEMONIC_FURY) and UnitPowerMax("player", SPELL_POWER_DEMONIC_FURY)) then
				local crud
-- Fizzlemizz: Comment: Divide by zero				if (UnitHealth(unit) / UnitHealthMax(unit) <= DUF_Settings[DUF_INDEX].flashthreshold and UnitHealth(unit) > 0) then
				if UnitPowerMax("player", SPELL_POWER_DEMONIC_FURY) == 0 then
					crud = UnitPower("player", SPELL_POWER_DEMONIC_FURY);
				else
					crud = UnitPower("player", SPELL_POWER_DEMONIC_FURY) / UnitPowerMax("player", SPELL_POWER_DEMONIC_FURY);
				end
				if (crud <= DUF_Settings[DUF_INDEX].flashthreshold and UnitPower("player", SPELL_POWER_DEMONIC_FURY) > 0) then
					if (not self.flashing) then
						self.flashing = true;
						self.direction = 1;
						self.flashtime = .5;
					end
				else
					self.flashing = nil;
					if (self.subindex) then
						self:SetAlpha(DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].alpha);
					else
						self:SetAlpha(DUF_Settings[DUF_INDEX][frameindex][self.index].alpha);
					end
				end
			end

		end

		if ((not context) and (not bgcontext) and (not bordercontext)) then return; end

		local color, bgcolor, bordercolor;
		if (self.subindex) then
			bgcolor = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].bgcolor;
			bordercolor = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].bordercolor;
			bgstyle = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].backgroundstyle;
			bgalpha = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].bgalpha;
			borderalpha = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].borderalpha;
		else
			bgcolor = DUF_Settings[DUF_INDEX][frameindex][self.index].bgcolor;
			bordercolor = DUF_Settings[DUF_INDEX][frameindex][self.index].bordercolor;
			bgstyle = DUF_Settings[DUF_INDEX][frameindex][self.index].backgroundstyle;
			bgalpha = DUF_Settings[DUF_INDEX][frameindex][self.index].bgalpha;
			borderalpha = DUF_Settings[DUF_INDEX][frameindex][self.index].borderalpha;
		end

		if (self.index == "StatusBar") then
			if (self.subindex == 2 or self.subindex == 5) then
				color = self.manacolor;
			else
				color = DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].color;
			end
		elseif (self.index == "TextBox") then
			color =  DUF_Settings[DUF_INDEX][frameindex][self.index][self.subindex].textcolor;
		else
			color = bgcolor;
		end
		local r, g, b;
		if (context == 4 or bgcontext == 4 or bordercontext == 4) then
			local health = UnitHealth(unit);
			local healthmax = UnitHealthMax(unit);
			if (self.health ~= health or self.healthmax ~= self.healthmax) then
				self.health = health;
				self.healthmax = healthmax;
				if (context == 4) then
					r, g, b = DUF_Get_HealthColor(unit, color);
					DUF_Element_SetColor(self, r, g, b, bgstyle, bgalpha);
				end
				if (bgcontext == 4) then
					r, g, b = DUF_Get_HealthColor(unit, bgcolor);
					_G[self:GetName().."_Background"]:SetBackdropColor(r, g, b, bgalpha);
				end
				if (bordercontext == 4) then
					r, g, b = DUF_Get_HealthColor(unit, bordercolor);
					_G[self:GetName().."_Background"]:SetBackdropBorderColor(r, g, b, borderalpha);
				end
			end
		end
		if (context == 5 or bgcontext == 5 or bordercontext == 5) then
			local mana = UnitPower(unit);
			local manamax = UnitPower(unit);
			if (self.mana ~= mana or self.manamax ~= self.manamax) then
				self.mana = mana;
				self.manamax = manamax;
				if (context == 5) then
					if (not color) then return; end
					r, g, b = DUF_Get_ManaColor(unit, color);
					DUF_Element_SetColor(self, r, g, b, bgstyle, bgalpha);
				end
				if (bgcontext == 5) then
					r, g, b = DUF_Get_ManaColor(unit, bgcolor);
					_G[self:GetName().."_Background"]:SetBackdropColor(r, g, b, bgalpha);
				end
				if (bordercontext == 5) then
					r, g, b = DUF_Get_ManaColor(unit, bordercolor);
					_G[self:GetName().."_Background"]:SetBackdropBorderColor(r, g, b, borderalpha);
				end
			end
		end
		if (context == 2 or bgcontext == 2 or bordercontext == 2) then
			local reaction = DUF_Get_Reaction(unit);
			if (self.reaction ~= reaction) then
				self.reaction = reaction;
				if (context == 2) then
					if (not color) then return; end
					r, g, b = DUF_Get_ReactionColor(unit, color);
					DUF_Element_SetColor(self, r, g, b, bgstyle, bgalpha);
				end
				if (bgcontext == 2) then
					r, g, b = DUF_Get_ReactionColor(unit, bgcolor);
					_G[self:GetName().."_Background"]:SetBackdropColor(r, g, b, bgalpha);
				end
				if (bordercontext == 2) then
					r, g, b = DUF_Get_ReactionColor(unit, bordercolor);
					_G[self:GetName().."_Background"]:SetBackdropBorderColor(r, g, b, borderalpha);
				end
			end
		end
	end
end

function DUF_Element_SetColor(self, r, g, b, bgstyle, alpha)
	if (self.index == "StatusBar") then
		_G[self:GetName().."_Bar"]:SetVertexColor(r, g, b);
	elseif (self.index == "TextBox") then
		_G[self:GetName().."_Text"]:SetTextColor(r, g, b);
	else
		_G[self:GetName().."_Background"]:SetBackdropColor(r, g, b, alpha);
	end
end
