function DUF_Initialize()
	if (DUF_INITIALIZED) then return; end
	if (DUF_DL_VERSION > DL_VERSION) then
		DL_Debug("** You need to install the latest version of the Discord Library for this mod to work right.  It should be included in the same .zip file from which you extracted this mod. **");
		return;
	end
	local _, unitClass = UnitClass("player") 
	if (unitClass == DUF_CLASS_ENU.Druid) then
		DUF_ISDRUID = true;
	end
	if (not DUF_Settings) then
		DUF_Settings = {};
	elseif (not DUF_Settings["INITIALIZED2.3"]) then
		for index in pairs(DUF_Settings) do
			if (index ~= "SavedSettings") then
				DUF_Settings[index] = nil;
			end
		end
		for profile in pairs(DUF_Settings.SavedSettings) do
			DUF_Settings[profile] = {};
			DL_Copy_Table(DUF_Settings.SavedSettings[profile], DUF_Settings[profile]);
		end
		DUF_Settings.SavedSettings = nil;
	end
	DUF_Settings["INITIALIZED2.3"] = 1;

	DUF_PLAYER_INDEX = UnitName("player").." :: "..GetCVar("realmName");
	DUF_INDEX = DUF_Settings[DUF_PLAYER_INDEX];

	if (not DUF_INDEX) then
		DUF_INDEX = DUF_TEXT.Default;
		DUF_Settings[DUF_PLAYER_INDEX] = DUF_INDEX;
	end

	if (not DUF_Settings[DUF_INDEX]) then
		DUF_Options_LoadDefaultSettings(1);
	end

	if (DUF_CUSTOM_SETTINGS) then
		DUF_Settings.Custom = {};
		DL_Copy_Table(DUF_CUSTOM_SETTINGS, DUF_Settings.Custom);
		DUF_CUSTOM_SETTINGS = nil;
	end

	DUF_Initialize_NewSettings();
	DUF_Settings.CharacterSettings = nil;
	DUF_INITIALIZED = true;
	DUF_SetDefaultUIHooks();
	DUF_Initialize_AllFrames();
	DUF_Main_UpdatePartyMembers();
	DUF_Main_OnEvent("UNIT_PET");
	DUF_XPBar_Update();
	DUF_PetXPBar_Update();
	DUF_HonorBar_Update();
end

function DUF_Initialize_NewSettings()
	--TigerHeart
	if (not DUF_Settings[DUF_INDEX].focus) then
		DUF_Settings[DUF_INDEX].focus = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].targettarget, DUF_Settings[DUF_INDEX].focus);
		DUF_Settings[DUF_INDEX].focus.hide = true;
		DUF_Settings[DUF_INDEX].focus.ComboPoints = nil;
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.0"]) then
		DUF_Settings[DUF_INDEX].target.ComboPoints.xoffset = DUF_Settings[DUF_INDEX].ComboOffset.x;
		DUF_Settings[DUF_INDEX].target.ComboPoints.yoffset = DUF_Settings[DUF_INDEX].ComboOffset.y;
		DUF_Settings[DUF_INDEX].ComboOffset.y = nil;
		DUF_Settings[DUF_INDEX].ComboOffset.x = nil;
		DUF_Settings[DUF_INDEX].optionscale = 1;
		DUF_Settings[DUF_INDEX].updatespeed = 1 / 30;
		DUF_Settings[DUF_INDEX].updatespeedbase = 30;
		DUF_Settings[DUF_INDEX].flashthreshold = .1;
		DUF_Settings[DUF_INDEX].healththreshold1 = .6;
		DUF_Settings[DUF_INDEX].healththreshold2 = .3;
		DUF_Settings[DUF_INDEX].healthcolor1 = { r=1, g=1, b=0 };
		DUF_Settings[DUF_INDEX].healthcolor2 = { r=1, g=0, b=0 };
		DUF_Settings[DUF_INDEX].manathreshold1 = .6;
		DUF_Settings[DUF_INDEX].manathreshold2 = .3;
		DUF_Settings[DUF_INDEX].manacolor1 = { r=1, g=1, b=0 };
		DUF_Settings[DUF_INDEX].manacolor2 = { r=1, g=0, b=0 };
		DUF_Settings[DUF_INDEX].targettarget = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].target, DUF_Settings[DUF_INDEX].targettarget);
		DUF_Settings[DUF_INDEX].targettarget.hide = true;
		DUF_Settings[DUF_INDEX].targettarget.ComboPoints = nil;

		--TigerHeart
		DUF_Settings[DUF_INDEX].focus = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].targettarget, DUF_Settings[DUF_INDEX].focus);
		DUF_Settings[DUF_INDEX].focus.hide = true;
		DUF_Settings[DUF_INDEX].focus.ComboPoints = nil;

		DUF_Settings[DUF_INDEX].pet.StatusBar[3] = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.StatusBar[3], DUF_Settings[DUF_INDEX].pet.StatusBar[3]);
		DUF_Settings[DUF_INDEX].pet.StatusBar[3].hide = true;
		DUF_Settings[DUF_INDEX].player.StatusBar[6] = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX].player.StatusBar[3], DUF_Settings[DUF_INDEX].player.StatusBar[6]);
		DUF_Settings[DUF_INDEX].player.StatusBar[6].hide = true;
		for _,unit in pairs(DUF_FRAME_INDICES) do
			DUF_Settings[DUF_INDEX][unit].RaceIcon = {};
			DL_Copy_Table(DUF_Settings[DUF_INDEX][unit].ClassIcon, DUF_Settings[DUF_INDEX][unit].RaceIcon);
			DUF_Settings[DUF_INDEX][unit].RaceIcon.hide = true;
			DUF_Settings[DUF_INDEX][unit].RankIcon = {};
			DL_Copy_Table(DUF_Settings[DUF_INDEX][unit].ClassIcon, DUF_Settings[DUF_INDEX][unit].RankIcon);
			DUF_Settings[DUF_INDEX][unit].RankIcon.hide = true;
			DUF_Settings[DUF_INDEX][unit].backgroundstyle = 2;
			DUF_Settings[DUF_INDEX][unit].bgalpha = 1;
			DUF_Settings[DUF_INDEX][unit].bgcolor.a = nil;
			DUF_Settings[DUF_INDEX][unit].bordercolor.a = nil;
			DUF_Settings[DUF_INDEX][unit].bgpadding = 5;
			DUF_Settings[DUF_INDEX][unit].Buffs.spacing = 0;
			DUF_Settings[DUF_INDEX][unit].Debuffs.spacing = 0;
			DUF_Settings[DUF_INDEX][unit].Buffs.bordercolor = {r=1, g=1, b=1};
			DUF_Settings[DUF_INDEX][unit].Debuffs.bordercolor = {r=1, g=1, b=1};
			if (DUF_Settings[DUF_INDEX][unit].context == "Reaction") then
				DUF_Settings[DUF_INDEX][unit].context = 2;
			elseif (DUF_Settings[DUF_INDEX][unit].context == "Difficulty") then
				DUF_Settings[DUF_INDEX][unit].context = 1;
			elseif (DUF_Settings[DUF_INDEX][unit].context == "Class") then
				DUF_Settings[DUF_INDEX][unit].context = 3;
			else
				DUF_Settings[DUF_INDEX][unit].context = nil;
			end
			if (DUF_Settings[DUF_INDEX][unit].recolor) then
				DUF_Settings[DUF_INDEX][unit].bgcontext = 4;
			end
			DUF_Settings[DUF_INDEX][unit].StatusBar[4] = {};
			DUF_Settings[DUF_INDEX][unit].StatusBar[5] = {};
			DL_Copy_Table(DUF_Settings[DUF_INDEX][unit].StatusBar[1], DUF_Settings[DUF_INDEX][unit].StatusBar[4]);
			DL_Copy_Table(DUF_Settings[DUF_INDEX][unit].StatusBar[2], DUF_Settings[DUF_INDEX][unit].StatusBar[5]);
			DUF_Settings[DUF_INDEX][unit].StatusBar[4].hide = true;
			DUF_Settings[DUF_INDEX][unit].StatusBar[5].hide = true;
			DUF_Settings[DUF_INDEX][unit].leftclick = 1;
			DUF_Settings[DUF_INDEX][unit].rightclick = 3;
			DUF_Settings[DUF_INDEX][unit].middleclick = 2;
			DUF_Settings[DUF_INDEX][unit].connectmethod = 1;
			DUF_Settings[DUF_INDEX][unit].spacing = 0;
			for _,element in pairs(DUF_ELEMENT_INDICES) do
				if (element == "TextBox") then
					for i=1,10 do
						DUF_Settings[DUF_INDEX][unit][element][i].backgroundstyle = 1;
						DUF_Settings[DUF_INDEX][unit][element][i].bgalpha = 1;
						if (not DUF_Settings[DUF_INDEX][unit][element][i].borderalpha) then
							DUF_Settings[DUF_INDEX][unit][element][i].borderalpha = 1;
						end
						DUF_Settings[DUF_INDEX][unit][element][i].bgcolor.a = nil;
						DUF_Settings[DUF_INDEX][unit][element][i].bordercolor.a = nil;
						DUF_Settings[DUF_INDEX][unit][element][i].bgpadding = 1;
						DUF_Settings[DUF_INDEX][unit][element][i].font = 1;
						DUF_Settings[DUF_INDEX][unit][element][i].justifyV = "CENTER";
						if (not DUF_Settings[DUF_INDEX][unit][element][i].showbg) then
							DUF_Settings[DUF_INDEX][unit][element][i].hidebg = true;
						end
						DUF_Settings[DUF_INDEX][unit][element][i].showbg = nil;
						if (DUF_Settings[DUF_INDEX][unit][element][i].context == "Reaction") then
							DUF_Settings[DUF_INDEX][unit][element][i].context = 2;
						elseif (DUF_Settings[DUF_INDEX][unit][element][i].context == "Difficulty") then
							DUF_Settings[DUF_INDEX][unit][element][i].context = 1;
						elseif (DUF_Settings[DUF_INDEX][unit][element][i].context == "Class") then
							DUF_Settings[DUF_INDEX][unit][element][i].context = 3;
						else
							DUF_Settings[DUF_INDEX][unit].context = nil;
						end
						if (not DUF_Settings[DUF_INDEX][unit][element][i].mouseovercolor) then
							DUF_Settings[DUF_INDEX][unit][element][i].mouseovercolor = {r=1, g=1, b=0};
						end
						DUF_Settings[DUF_INDEX][unit][element][i].attach = "Unit Frame";
						DUF_Settings[DUF_INDEX][unit][element][i].attachpoint = "TOPLEFT";
						DUF_Settings[DUF_INDEX][unit][element][i].attachto = "TOPLEFT";
						DUF_Settings[DUF_INDEX][unit][element][i].leftclick = 1;
						DUF_Settings[DUF_INDEX][unit][element][i].rightclick = 3;
						DUF_Settings[DUF_INDEX][unit][element][i].middleclick = 2;
					end
				elseif (element == "StatusBar") then
					for i=1,6 do
						if (DUF_Settings[DUF_INDEX][unit][element][i]) then
							DUF_Settings[DUF_INDEX][unit][element][i].backgroundstyle = 1;
							DUF_Settings[DUF_INDEX][unit][element][i].bgalpha = 1;
							DUF_Settings[DUF_INDEX][unit][element][i].bgcolor.a = nil;
							DUF_Settings[DUF_INDEX][unit][element][i].bordercolor.a = nil;
							DUF_Settings[DUF_INDEX][unit][element][i].bgpadding = 1;
							DUF_Settings[DUF_INDEX][unit][element][i].color2 = {r=1, g=1, b=0};
							DUF_Settings[DUF_INDEX][unit][element][i].attach = "Unit Frame";
							DUF_Settings[DUF_INDEX][unit][element][i].attachpoint = "TOPLEFT";
							DUF_Settings[DUF_INDEX][unit][element][i].attachto = "TOPLEFT";
							DUF_Settings[DUF_INDEX][unit][element][i].leftclick = 1;
							DUF_Settings[DUF_INDEX][unit][element][i].rightclick = 3;
							DUF_Settings[DUF_INDEX][unit][element][i].middleclick = 2;
							if (not DUF_Settings[DUF_INDEX][unit][element][i].mouseovercolor) then
								DUF_Settings[DUF_INDEX][unit][element][i].mouseovercolor = {r=1, g=1, b=0};
							end
							if (DUF_Settings[DUF_INDEX][unit][element][i].recolor) then
								if (i==1) then
									DUF_Settings[DUF_INDEX][unit][element][i].context = 4;
								else
									DUF_Settings[DUF_INDEX][unit][element][i].context = 5;
								end
								DUF_Settings[DUF_INDEX][unit][element][i].recolor = nil;
							end
						end
						if (i == 1 or i == 4) then
							DUF_Settings[DUF_INDEX][unit][element][i].context = 4;
						elseif (i == 2 or i == 5) then
							DUF_Settings[DUF_INDEX][unit][element][i].context = 5;
							DUF_Settings[DUF_INDEX][unit][element][i].hideifnomana = true;
						end
					end
				else
					DUF_Settings[DUF_INDEX][unit][element].backgroundstyle = 2;
					DUF_Settings[DUF_INDEX][unit][element].bgalpha = 1;
					DUF_Settings[DUF_INDEX][unit][element].bgcolor.a = nil;
					DUF_Settings[DUF_INDEX][unit][element].bgpadding = 5;
					DUF_Settings[DUF_INDEX][unit][element].context = nil;
					if (not DUF_Settings[DUF_INDEX][unit][element].mouseovercolor) then
						DUF_Settings[DUF_INDEX][unit][element].mouseovercolor = {r=1, g=1, b=0};
					end
					DUF_Settings[DUF_INDEX][unit][element].attach = "Unit Frame";
					DUF_Settings[DUF_INDEX][unit][element].attachpoint = "TOPLEFT";
					DUF_Settings[DUF_INDEX][unit][element].attachto = "TOPLEFT";
					DUF_Settings[DUF_INDEX][unit][element].leftclick = 1;
					DUF_Settings[DUF_INDEX][unit][element].rightclick = 3;
					DUF_Settings[DUF_INDEX][unit][element].middleclick = 2;
					if (not DUF_Settings[DUF_INDEX][unit][element].borderalpha) then
						DUF_Settings[DUF_INDEX][unit][element].borderalpha = 1;
					end
				end
			end
		end
		DUF_Settings[DUF_INDEX].target.ComboPoints.backgroundstyle = 2;
		DUF_Settings[DUF_INDEX].target.ComboPoints.bgalpha = 1;
		DUF_Settings[DUF_INDEX].target.ComboPoints.bgcolor.a = nil;
		DUF_Settings[DUF_INDEX].target.ComboPoints.bgpadding = 5;
		DUF_Settings[DUF_INDEX].target.ComboPoints.attach = "Unit Frame";
		DUF_Settings[DUF_INDEX].target.ComboPoints.attachpoint = "TOPLEFT";
		DUF_Settings[DUF_INDEX].target.ComboPoints.attachto = "TOPLEFT";
		DUF_Settings[DUF_INDEX].target.ComboPoints.mouseovercolor = { r=1, g=1, b=0 };
		DUF_Settings[DUF_INDEX].target.EliteTexture = { size=128, alpha=1, bgcolor={0,0,0}, bordercolor={0,0,0}, mouseovercolor={1,1,0}, bgalpha=1, bgpadding=5, hidebg=true, backgroundstyle=2, borderalpha=1, xoffset=0, yoffset=0, attach="Unit Frame", attachto="TOPLEFT", attachpoint="TOPLEFT", hide=true};
	end
	DUF_Settings[DUF_INDEX].ComboOffset = nil;

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.0f"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			for i=1,10 do
				if (tonumber(DUF_Settings[DUF_INDEX][unit].TextBox[i].font)) then
					DUF_Settings[DUF_INDEX][unit].TextBox[i].font = "DUF_Font"..DUF_Settings[DUF_INDEX][unit].TextBox[i].font..".ttf";
				end
			end
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.1"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			DUF_Settings[DUF_INDEX][unit].Portrait.bordcolor = { r=1, g=1, b=1 };
			for _,element in pairs(DUF_ELEMENT_INDICES) do
				if (element == "TextBox") then
					for i=1,10 do
						DUF_Settings[DUF_INDEX][unit][element][i].framelevel = 0;
						DUF_Settings[DUF_INDEX][unit][element][i].framestrata = "LOW";
						DUF_Settings[DUF_INDEX][unit][element][i].label = DUF_TEXT["TextBox"..i];
					end
				elseif (element == "StatusBar") then
					for i=1,6 do
						if (DUF_Settings[DUF_INDEX][unit][element][i]) then
							DUF_Settings[DUF_INDEX][unit][element][i].framelevel = 0;
							DUF_Settings[DUF_INDEX][unit][element][i].framestrata = "BACKGROUND";
						end
					end
				else
					if (DUF_Settings[DUF_INDEX][unit][element] == nil) then
						DUF_Settings[DUF_INDEX][unit][element] = { }
					end;
					DUF_Settings[DUF_INDEX][unit][element].framelevel = 0;
					DUF_Settings[DUF_INDEX][unit][element].framestrata = "LOW";
				end
			end
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.2"]) then
		DUF_Settings[DUF_INDEX].player.Buffs.durationheight = 6;
		DUF_Settings[DUF_INDEX].player.Buffs.durationcolor = {r=1, g=1, b=1};
		DUF_Settings[DUF_INDEX].player.Buffs.durationfont = "DUF_Font1.ttf";
		DUF_Settings[DUF_INDEX].player.Buffs.durationalpha = 1;
		DUF_Settings[DUF_INDEX].player.Buffs.durationx = 0;
		DUF_Settings[DUF_INDEX].player.Buffs.durationy = -5;
		DUF_Settings[DUF_INDEX].player.Debuffs.durationheight = 6;
		DUF_Settings[DUF_INDEX].player.Debuffs.durationcolor = {r=1, g=1, b=1};
		DUF_Settings[DUF_INDEX].player.Debuffs.durationfont = "DUF_Font1.ttf";
		DUF_Settings[DUF_INDEX].player.Debuffs.durationalpha = 1;
		DUF_Settings[DUF_INDEX].player.Debuffs.durationx = 0;
		DUF_Settings[DUF_INDEX].player.Debuffs.durationy = -5;
		for i=0,3 do
			DUF_Settings[DUF_INDEX]["usefor"..i] = 1;
		end
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.2c"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			DUF_Settings[DUF_INDEX][unit].Buffs.hspacing = DUF_Settings[DUF_INDEX][unit].Buffs.spacing;
			DUF_Settings[DUF_INDEX][unit].Buffs.vspacing = DUF_Settings[DUF_INDEX][unit].Buffs.spacing;
			DUF_Settings[DUF_INDEX][unit].Debuffs.hspacing = DUF_Settings[DUF_INDEX][unit].Debuffs.spacing;
			DUF_Settings[DUF_INDEX][unit].Debuffs.vspacing = DUF_Settings[DUF_INDEX][unit].Debuffs.spacing;
		end
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.3s"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			for i=1,6 do
				if (DUF_Settings[DUF_INDEX][unit].StatusBar[i]) then
					DUF_Settings[DUF_INDEX][unit].StatusBar[i].direction = 1;
				end
			end
		end
	end
	--Eris
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.3t"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			for _,element in pairs(DUF_ELEMENT_INDICES) do
				if (element == "StatusBar") then
					DUF_Settings[DUF_INDEX][unit].StatusBar[7] = {};
					DL_Copy_Table(DUF_Settings[DUF_INDEX].player.StatusBar[2], DUF_Settings[DUF_INDEX][unit].StatusBar[7]);
					DUF_Settings[DUF_INDEX][unit].StatusBar[7].hide = true;
					DUF_Settings[DUF_INDEX][unit].StatusBar[7].hideifnocast = false;
					DUF_Settings[DUF_INDEX][unit].StatusBar[7].direction = 1;
				end
			end
		end
	end
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.3x"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			for _,element in pairs(DUF_ELEMENT_INDICES) do
				if (element == "Buffs" or element == "Debuffs") then
					DUF_Settings[DUF_INDEX][unit][element].showduration = 1;
					DUF_Settings[DUF_INDEX][unit][element].altformat = 1;
					DUF_Settings[DUF_INDEX][unit][element].durationx = 0;
					DUF_Settings[DUF_INDEX][unit][element].durationy = -5;
					DUF_Settings[DUF_INDEX][unit][element].durationheight = 6;
					DUF_Settings[DUF_INDEX][unit][element].durationalpha = 1;
					DUF_Settings[DUF_INDEX][unit][element].durationfont = "DUF_Font1.ttf";
					DUF_Settings[DUF_INDEX][unit][element].durationcolor = {r=1, g=1, b=1};
				end
			end
		end
		DUF_Settings[DUF_INDEX]["classcolorShaman"] = {
				["r"] = .14,
				["g"] = .35,
				["b"] = 1,
			};
	end
	
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED2.4"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do			
			DUF_Settings[DUF_INDEX][unit].VoiceIcon = {
				["bgcolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 1,
				},
				["borderalpha"] = 0,
				["framestrata"] = "LOW",
				["attachpoint"] = "TOPLEFT",
				["framelevel"] = 0,
				["middleclick"] = 2,
				["attachto"] = "TOPLEFT",
				["mouseovercolor"] = {
					["b"] = 0,
					["g"] = 1,
					["r"] = 1,
				},
				["size"] = 20,
				["bgpadding"] = 5,
				["attach"] = "Unit Frame",
				["bordercolor"] = {
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["alpha"] = 1,
				["yoffset"] = 0,
				["hide"] = false,
				["backgroundstyle"] = 2,
				["xoffset"] = 0,
				["bgalpha"] = 1,
				["rightclick"] = 3,
				["leftclick"] = 1,
				["bgtexture"] = "VoiceChat-Speaker.tga",
				};
		end
	end;

-- scree, 3.0.3a, Dec 2008
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED3.0.3a"]) then
		DUF_Settings[DUF_INDEX]["classcolorDeathKnight"] = {
				["r"] = 0.77,
				["g"] = 0.12,
				["b"] = 0.23,
			};
	end
	
-- scree, 3.1.0a, Mar 2009
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED3.1.0a"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			local statusBarHasMana = { 2, 5 };
			for _,v in ipairs(statusBarHasMana) do
				DUF_Settings[DUF_INDEX][unit].StatusBar[v]["runicpowercolor"] = {
					["r"] = 0.00,
					["g"] = 0.82,
					["b"] = 1.00,
				};
			end
		end
	end

--Fizzlemizz: Comment: 4.0 initalisation settings for TempEnchants
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED4.0"]) then
		DUF_Settings[DUF_INDEX]["player"].TempEnchants = {
				["bgcolor"] = {
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["borderalpha"] = 1,
				["rightclick"] = 3,
				["altformat"] = 1,
				["bgalpha"] = 1,
				["framelevel"] = 0,
				["middleclick"] = 2,
				["vertical"] = false,
				["spacing"] = 3,
				["mouseovercolor"] = {
					["b"] = 0,
					["g"] = 1,
					["r"] = 1,
				},
				["vspacing"] = 0,
				["hspacing"] = -10,
				["hidebg"] = 1,
				["shown"] = 2,
				["bgpadding"] = 5,
				["background"] = false,
				["framestrata"] = "LOW",
				["leftclick"] = 1,
				["attach"] = "Unit Frame",
				["bordercolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 1,
				},
				["mouseover"] = false,
				["attachto"] = "TOPRIGHT",
				["attachpoint"] = "TOPRIGHT",
				["backgroundstyle"] = 2,
				["alpha"] = 1,
				["xoffset"] = -167,
				["size"] = 32,
				["yoffset"] = 27,
				["durationheight"] = 6,
				["durationheight"] = 6;
				["durationcolor"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 1,
				};
				["durationfont"] = "DUF_Font1.ttf";
				["durationalpha"] = 1;
				["durationx"] = 0;
				["durationy"] = -5;
			};
	end

--Fizzlemizz: Comment: 4.0a initalisation settings for Druid Mana Bar
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED4.0a"]) then
		DUF_Settings[DUF_INDEX]["player"]["StatusBar"][8] = {
					["direction"] = 3,
					["bgcolor"] = {
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["borderalpha"] = 0.5,
					["rightclick"] = 3,
					["attachpoint"] = "BOTTOMLEFT",
					["middleclick"] = 2,
					["runicpowercolor"] = {
						["r"] = 0,
						["g"] = 0.82,
						["b"] = 1,
					},
					["recolor"] = false,
					["bordercolor"] = {
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["color2"] = {
						["b"] = 0.8901960784313725,
						["g"] = 0.04705882352941176,
						["r"] = 0.7215686274509804,
					},
					["height"] = 40,
					["yoffset"] = 0,
					["framelevel"] = 0,
					["attachto"] = "BOTTOMRIGHT",
					["mouseovercolor"] = {
						["b"] = 0,
						["g"] = 1,
						["r"] = 1,
					},
					["framestrata"] = "BACKGROUND",
					["focuscolor"] = {
						["b"] = 0.9215686274509803,
						["g"] = 0.5568627450980392,
						["r"] = 0.5568627450980392,
					},
					["alpha"] = 1,
					["customtexture2"] = "bg",
					["manacolor"] = {
						["b"] = 0.9215686274509803,
						["g"] = 0.5568627450980392,
						["r"] = 0.5568627450980392,
					},
					["bordersize"] = 1,
					["attach"] = "_ManaBar",
					["width"] = 10,
					["backgroundstyle"] = 1,
					["bgpadding"] = 1,
					["xoffset"] = 0,
					["fade"] = 1,
					["hideifnomana"] = 1,
					["bgalpha"] = 0,
					["customtexture"] = "bg",
					["leftclick"] = 1,
				}; -- [8] Druid Mana Bar
	end
--Fizzlemizz: Comment: 4.1a initalisation settings for duration timer performance update
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED4.0b"]) then
		DUF_Settings[DUF_INDEX].limitdurationupdates = nil
	end

--Fizzlemizz: Comment: 4.15 initalisation settings for Temp. Enchant MouseOver error
	if (DUF_Settings[DUF_INDEX]["player"].TempEnchants.usemouseovercolor == nil) then
		DUF_Settings[DUF_INDEX]["player"]["TempEnchants"].usemouseovercolor = 0;
	end
	
--Fizzlemizz: Comment: 4.17 Setting for 3D models
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED4.17"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			DUF_Settings[DUF_INDEX][unit]["Portrait"].use3D = false;
			DUF_Settings[DUF_INDEX][unit]["Portrait"].use3Dface = false;
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED4.18"]) then
		for _,unit in pairs(DUF_FRAME_INDICES) do
			DUF_Settings[DUF_INDEX][unit]["RoleIcon"] = {
				["bgcolor"] = {
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["borderalpha"] = 1,
				["rightclick"] = 3,
				["attachpoint"] = "CENTER",
				["middleclick"] = 2,
				["attachto"] = "BOTTOMRIGHT",
				["mouseovercolor"] = {
					["b"] = 0,
					["g"] = 1,
					["r"] = 1,
				},
				["hide"] = 1,
				["bgpadding"] = 3,
				["attach"] = "_Portrait",
				["bordercolor"] = {
					["r"] = 0.996078,
					["g"] = 1,
					["b"] = 0,
				},
				["alpha"] = 1,
				["leftclick"] = 1,
				["size"] = 25,
				["backgroundstyle"] = 2,
				["xoffset"] = 4,
				["bgalpha"] = 1,
				["hidebg"] = 1,
				["yoffset"] = -4,
			};
		end
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.0"]) then
		DUF_Settings[DUF_INDEX]["classcolorMonk"] = {
			["r"] = 0,
			["g"] = 1,
			["b"] = .588,
		};
	end	

--Fizzlemizz : Comment: MOP Beta Settings for Monk Chi orbs
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.0a"]) then
		DUF_Settings[DUF_INDEX].player["MonkHarmony"] = {
			["bgcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["borderalpha"] = 0,
			["customtexture"] = "",
			["bgalpha"] = 1,
			["framelevel"] = 0,
			["spacing"] = 0,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["size"] = 13,
			["bgpadding"] = 5,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["alpha"] = 1,
			["hidebg"] = 1,
			["attachto"] = "TOP",
			["color"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["disablemouse"] = 1,
			["attachpoint"] = "BOTTOM",
			["xoffset"] = 0,
			["framestrata"] = "BACKGROUND",
			["backgroundstyle"] = 2,
			["yoffset"] = 5,
		};
	end
--Fizzlemizz : Comment: MOP Beta Settings for DK Rune and Paly Power.... finally
	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.0b"]) then
		DUF_Settings[DUF_INDEX].player.MonkHarmony["bgsize"] = {
				["width"] = 12,
				["height"] = 16,
			};

		DUF_Settings[DUF_INDEX].player["PalyPowerFrame"] = {
			["bgcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["borderalpha"] = 0,
			["customtexture"] = "",
			["bgalpha"] = 1,
			["framelevel"] = 0,
			["spacing"] = 0,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["bgsize"] = {
				["width"] = 12,
				["height"] = 16,
			},
			["size"] = 13,
			["bgpadding"] = 5,
			["hidebg"] = 1,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["alpha"] = 1,
			["backgroundstyle"] = 2,
			["attachto"] = "TOP",
			["color"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["attachpoint"] = "BOTTOM",
			["xoffset"] = 0,
			["disablemouse"] = 1,
			["framestrata"] = "BACKGROUND",
			["yoffset"] = 17,
		};
		DUF_Settings[DUF_INDEX].player["WarlockPowerFrame"] = {
			["bgcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["borderalpha"] = 0,
			["customtexture"] = "",
			["bgalpha"] = 1,
			["framelevel"] = 0,
			["spacing"] = 0,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["bgsize"] = {
				["width"] = 12,
				["height"] = 16,
			},
			["size"] = 13,
			["bgpadding"] = 5,
			["hidebg"] = 1,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["alpha"] = 1,
			["backgroundstyle"] = 2,
			["attachto"] = "TOP",
			["color"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["attachpoint"] = "BOTTOM",
			["xoffset"] = 0,
			["disablemouse"] = 1,
			["framestrata"] = "BACKGROUND",
			["yoffset"] = 17,
		};
		DUF_Settings[DUF_INDEX].player["RuneFrame"] = {
			["bgcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["bgsize"] = {
				["width"] = 12,
				["height"] = 16,
			},
			["bgHeight"] = 16,
			["borderalpha"] = 0,
			["customtexture"] = "",
			["bgalpha"] = 1,
			["hidebg"] = 1,
			["framelevel"] = 0,
			["spacing"] = 10,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["size"] = 13,
			["bgpadding"] = 5,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["alpha"] = 1,
			["backgroundstyle"] = 2,
			["attachto"] = "TOP",
			["color"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["attachpoint"] = "BOTTOM",
			["xoffset"] = -51,
			["disablemouse"] = 1,
			["framestrata"] = "BACKGROUND",
			["yoffset"] = 5,
		};
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.0c"]) then
		DUF_Settings[DUF_INDEX].player.WarlockPowerFrame.DemoBar = nil;

		DUF_Settings[DUF_INDEX]["player"]["StatusBar"][9] = {
			["direction"] = 1,
			["bgcolor"] = {
				["b"] = 0.0117647,
				["g"] = 0,
				["r"] = 0.294118,
			},
			["borderalpha"] = 1,
			["rightclick"] = 3,
			["bgalpha"] = 1,
			["fade"] = 1,
			["middleclick"] = 2,
			["attachto"] = "TOPLEFT",
			["mouseovercolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 0,
			},
			["context"] = 4,
			["hide"] = false,
			["bgpadding"] = 1,
			["framestrata"] = "BACKGROUND",
			["framelevel"] = 0,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0.694118,
				["g"] = 0.654902,
				["b"] = 0,
			},
			["bordersize"] = 1,
			["width"] = 131,
			["color2"] = {
				["b"] = 1,
				["g"] = 0.7333333333333333,
				["r"] = 0.8980392156862745,
			},
			["yoffset"] = 16,
			["alpha"] = 1,
			["xoffset"] = 59,
			["height"] = 11,
			["attachpoint"] = "TOPLEFT",
			["color"] = {
				["b"] = 1,
				["g"] = 0.2980392156862745,
				["r"] = 0.7764705882352941,
			},
			["leftclick"] = 1,
		}; -- [9] Warlock Demonic Power Bar


		DUF_Settings[DUF_INDEX]["player"]["TextBox"][11] = {
			["outline"] = "NORMAL",
			["leftclick"] = 1,
			["bgcolor"] = {
				["b"] = 0.09019607843137255,
				["g"] = 0.01176470588235294,
				["r"] = 0.08627450980392157,
			},
			["borderalpha"] = 0,
			["framestrata"] = "LOW",
			["attachpoint"] = "TOP",
			["justifyV"] = "TOP",
			["verttext"] = 1,
			["textheight"] = 9,
			["middleclick"] = 2,
			["bgalpha"] = 0.57,
			["bgcolorcontext"] = "No Context",
			["attachto"] = "LEFT",
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["height"] = 50,
			["colorcontext"] = "No Context",
			["hidebg"] = 1,
			["bgpadding"] = 7,
			["textcolor"] = {
				["r"] = 0.984313725490196,
				["g"] = 0.996078431372549,
				["b"] = 1,
			},
			["justify"] = "LEFT",
			["alpha"] = 1,
			["attach"] = "_DruidManaBar",
			["text"] = "$rp%",
			["backgroundstyle"] = 2,
			["width"] = 14,
			["rightclick"] = 3,
			["font"] = "DUF_Font3.ttf",
			["bordercolor"] = {
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["bgtexture"] = "",
			["xoffset"] = 0,
			["framelevel"] = 1,
			["yoffset"] = 15,
		}; -- [11] Druid mana Bar Text

		DUF_Settings[DUF_INDEX]["player"]["TextBox"][12] = {
			["outline"] = "NORMAL",
			["leftclick"] = 1,
			["bgcolor"] = {
				["b"] = 0.09019607843137255,
				["g"] = 0.01176470588235294,
				["r"] = 0.08627450980392157,
			},
			["borderalpha"] = 0,
			["framestrata"] = "LOW",
			["attachpoint"] = "RIGHT",
			["justifyV"] = "CENTER",
			["textheight"] = 7,
			["middleclick"] = 2,
			["bgalpha"] = 0.57,
			["bgcolorcontext"] = "No Context",
			["attachto"] = "RIGHT",
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["height"] = 10,
			["colorcontext"] = "No Context",
			["hidebg"] = 1,
			["bgpadding"] = 7,
			["textcolor"] = {
				["r"] = 0.984313725490196,
				["g"] = 0.996078431372549,
				["b"] = 1,
			},
			["justify"] = "LEFT",
			["alpha"] = 1,
			["attach"] = "_DemonicPowerBar",
			["text"] = "$dc/$dm",
			["backgroundstyle"] = 2,
			["width"] = 108,
			["rightclick"] = 3,
			["font"] = "DUF_Font3.ttf",
			["bordercolor"] = {
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["bgtexture"] = "",
			["xoffset"] = 0,
			["framelevel"] = 1,
			["yoffset"] = 0,
		}; -- [12] Warlock Fury Bar Text
	end

	if (not DUF_Settings[DUF_INDEX]["INITIALIZED5.1"]) then
		DUF_Settings[DUF_INDEX].player["PriestOrbFrame"] = {
			["bgcolor"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["bgsize"] = {
				["width"] = 12,
				["height"] = 16,
			},
			["borderalpha"] = 0,
			["customtexture"] = "",
			["bgalpha"] = 1,
			["framelevel"] = 0,
			["spacing"] = 0,
			["mouseovercolor"] = {
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			["size"] = 13,
			["bgpadding"] = 5,
			["attach"] = "Unit Frame",
			["bordercolor"] = {
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["alpha"] = 1,
			["hidebg"] = 1,
			["attachto"] = "TOP",
			["color"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["disablemouse"] = 1,
			["attachpoint"] = "BOTTOM",
			["xoffset"] = 0,
			["framestrata"] = "BACKGROUND",
			["backgroundstyle"] = 2,
			["yoffset"] = 5,
		};
	end


	DUF_Settings[DUF_INDEX]["INITIALIZED5.1"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.0c"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.0b"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.0a"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED5.0"] = true; --Fizzlemizz	
	DUF_Settings[DUF_INDEX]["INITIALIZED4.18"] = true; --Fizzlemizz
	DUF_Settings[DUF_INDEX]["INITIALIZED4.17"] = true; --Fizzlemizz
	DUF_Settings[DUF_INDEX]["INITIALIZED4.1a"] = true; --Fizzlemizz
	DUF_Settings[DUF_INDEX]["INITIALIZED4.0a"] = true; --Fizzlemizz
	DUF_Settings[DUF_INDEX]["INITIALIZED4.0"] = true; --Fizzlemizz
	DUF_Settings[DUF_INDEX]["INITIALIZED3.1.0a"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED3.0.3a"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.4"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3x"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3w"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3u"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3t"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.3s"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.2c"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.2"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.1"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.0f"] = true;
	DUF_Settings[DUF_INDEX]["INITIALIZED2.0"] = true;
end

function DUF_Initialize_AllFrames(debug)
	local unitFrame;
	for unit, value in pairs(DUF_FRAME_DATA) do
		local unitFrame = _G[DUF_FRAME_DATA[unit].frame];
		DUF_CreatePortrait(unit)  -- Fizzlemizz: Function caled here to create portrait framres before SetrUnitFrameWatch to allow for 3D portraits
		DUF_SetFrameUnitWatch(unitFrame, not DUF_Settings[DUF_INDEX][value.index].hide) 
		DUF_SetupClickTargetting(unitFrame, unit);
		local children = { unitFrame:GetChildren() }
		for _, child in ipairs(children) do
			child.menu = unitFrame.menu
		end
		DUF_Initialize_Frame(unitFrame, unit);
		DUF_Initialize_Portrait(unit);
		DUF_Initialize_ClassIcon(unit);
		DUF_Initialize_RaceIcon(unit);
		DUF_Initialize_RankIcon(unit);
		DUF_Initialize_RoleIcon(unit);
		local tb
		if (unit == "player") then
			tb = DUF_NUM_PLAYER_TEXTBOXES;
		else
			tb = DUF_NUM_OTHERS_TEXTBOXES;
		end

		for i=1,tb do
			DUF_Initialize_TextBox(0, unit, i); 
		end
		for i=1,DUF_NUM_STATUSBARS do
			DUF_Initialize_StatusBar(0, unit, i, debug); 
		end
		DUF_Initialize_PVPIcon(unit);
		DUF_Initialize_StatusIcon(unit);
		DUF_Initialize_LootIcon(unit);
		DUF_Initialize_LeaderIcon(unit);
		DUF_Initialize_Buffs(unitFrame, unit);
		DUF_Initialize_Debuffs(unitFrame, unit);
		DUF_Initialize_VoiceIcon(unit);
	end
	DUF_Initialize_TempEnchants();
	DUF_Initialize_MonkHarmony();
	DUF_Initialize_RuneFrame();
	DUF_Initialize_PalyPowerFrame();
	DUF_Initialize_PriestOrbFrame();
	DUF_Initialize_WarlockPowerFrame();
	DUF_Initialize_ComboPoints();
	DUF_Initialize_EliteTexture();
	if (DUF_Options) then
		DUF_Options_SetScale();
		DUF_Init_ContextColors();
		DUF_Init_MiscOptions();
	end	
	DUF_Options_SetUpdateSpeed();
	DUF_Toggle_DefaultFrames();
	DUF_PlayerFrame:Hide();
	if (not DUF_Settings[DUF_INDEX].player.hide) then
		DUF_PlayerFrame:Show();
	end
	for i=1,DL_UNIT_BUFFCOUNT do
		_G["DUF_PlayerFrame_Buffs_"..i].playerbuff = true;
		_G["DUF_PlayerFrame_Debuffs_"..i].playerbuff = true;
	end
	if (DUF_Settings[DUF_INDEX].hidebuffframe) then
		BuffFrame:Hide();
		BuffFrame.origShow = BuffFrame.Show;
		BuffFrame.Show = function() end;
		ConsolidatedBuffs:Hide();
	elseif (BuffFrame.origShow) then
		BuffFrame.Show = BuffFrame.origShow;
		BuffFrame.origShow = nil;
		BuffFrame:Show();
		if GetCVarBool("consolidateBuffs") then
			ConsolidatedBuffs:Show()
		end
	end
--	CompactRaidFrameManager:Hide(); -- Fizzlemizz: Might want to add this as an option. Added hear because it doesn't get hidden using ReloadUI while in a group/raid
	if DUF_OPTIONS_VISIBLE then
		DUF_Options_ShowFrames()
	end
end

function DUF_Initialize_BaseSettings(frame, settings, debug)
	local framename = frame:GetName();
	local bgframe = _G[framename.."_Background"];
	local bgtexture = "Interface\\AddOns\\DiscordLibrary\\PlainBackdrop";
	if (settings.bgtexture and settings.bgtexture ~= "") then
		if (DUF_Settings[DUF_INDEX].custompaths) then
			bgtexture = settings.bgtexture;
		else
			bgtexture = "Interface\\AddOns\\DiscordUnitFrames\\CustomTextures\\"..settings.bgtexture;
		end
	end
	if (settings.backgroundstyle == 1) then
		bgframe:SetBackdrop({bgFile = bgtexture, edgeFile = "Interface\\AddOns\\DiscordLibrary\\PlainBackdrop", tile = nil, tileSize = 1, edgeSize = 1, insets = { left = 1, right = 1, top = 1, bottom = 1 }});
	elseif (settings.backgroundstyle == 2) then
		bgframe:SetBackdrop({bgFile = bgtexture, edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = nil, tileSize = 16, edgeSize = 16, insets = { left = 5, right = 5, top = 5, bottom = 5 }});
	elseif (settings.backgroundstyle == 3) then
		bgframe:SetBackdrop({bgFile = bgtexture, edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = nil, tileSize = 32, edgeSize = 32, insets = { left = 11, right = 12, top = 12, bottom = 11 }});
	elseif (settings.backgroundstyle == 4) then
		bgframe:SetBackdrop({bgFile = bgtexture, edgeFile = "Interface\\Buttons\\UI-SliderBar-Border", tile = nil, tileSize = 8, edgeSize = 8, insets = { left = 3, right = 3, top = 6, bottom = 6 }});
	end
	bgframe:SetBackdropColor(settings.bgcolor.r, settings.bgcolor.g, settings.bgcolor.b, settings.bgalpha);
	bgframe:SetBackdropBorderColor(settings.bordercolor.r, settings.bordercolor.g, settings.bordercolor.b, settings.borderalpha);
	if (settings.hidebg) then
		bgframe:Hide();
	else
		bgframe:Show();
	end
	frame:ClearAllPoints();
	frame:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
	if (settings.framelevel and settings.framestrata) then
		frame:SetFrameStrata(settings.framestrata);
		local framelevel = frame.baseframelevel + settings.framelevel;
		if (framelevel < 0) then framelevel = 0; end
		frame:SetFrameLevel(framelevel);
	end
	bgframe:SetFrameStrata("BACKGROUND");
	local height, width;
	if (settings.size) then
		height = settings.size;
		width = settings.size;
	else
		height = settings.height;
		width = settings.width;
	end
	if (frame.dynamicsize) then
		height = height * frame.dynamicsize;
		width = width * frame.dynamicsize;
	end
	frame:SetWidth(width);
	frame:SetHeight(height);
	frame:SetAlpha(settings.alpha);
	bgframe:SetWidth(width + settings.bgpadding * 2);
	bgframe:SetHeight(height + settings.bgpadding * 2);
	if (settings.hide or settings.mouseover) then
		frame:Hide();
	else
		frame:Show();
	end
	frame.flashing = nil;
	if (settings.disablemouse) then
		frame:EnableMouse(false);
	else
		frame:EnableMouse(1);
	end
end

function DUF_Initialize_TempEnchants()
	TemporaryEnchantFrame:Hide()
	local prevname , duf_button;
	local frame = _G[DUF_FRAME_DATA["player"].frame.."_TempEnchants"];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA["player"].index].TempEnchants;
	DUF_Initialize_Element("player", frame, settings);
	frame:SetFrameStrata("BACKGROUND"); 
	for i=1,3 do --NUM_TEMP_ENCHANT_FRAMES
		prevname = duf_button
		duf_button = _G[frame:GetName().."_" .. i];
		duf_button:ClearAllPoints();
		if (i == 1) then
			duf_button:SetPoint("TOPLEFT", frame:GetName(), "TOPLEFT", 0, 0);
		else
			if (settings.vertical) then
				duf_button:SetPoint("TOP", prevname, "BOTTOM", 0, -settings.vspacing);
			else
				duf_button:SetPoint("LEFT", prevname, "RIGHT", settings.hspacing, 0);
			end
		end
		duf_button:SetWidth(settings.size);
		duf_button:SetHeight(settings.size);
		local icon = _G[DUF_FRAME_DATA["player"].frame.."_TempEnchants_" .. i .. "_Texture"];
		if (DUF_OPTIONS_VISIBLE) then
			icon:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Buff");
			duf_button:Show();
		else
			icon:SetTexture();
			duf_button:Hide();
		end
	end
	TemporaryEnchantFrame:Show() 
end

function DUF_Initialize_Buffs(self, unit)
	local frame = _G[DUF_FRAME_DATA[unit].frame.."_Buffs"];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].Buffs;
	DUF_Initialize_Element(unit, frame, settings);
	if (settings.reverse) then
		local button = _G[frame:GetName().."_"..DL_UNIT_BUFFCOUNT];
		local buttontexture = _G[frame:GetName().."_"..DL_UNIT_BUFFCOUNT.."_Texture"];
		button:ClearAllPoints();
		button:SetPoint("BOTTOMRIGHT", frame:GetName(), "BOTTOMRIGHT", 0, 0);
		button:SetFrameLevel(frame:GetFrameLevel() + 1);
		button:SetWidth(settings.size);
		button:SetHeight(settings.size);
		buttontexture:SetWidth(settings.size);
		buttontexture:SetHeight(settings.size);
		local prevname;
		for i=DL_UNIT_BUFFCOUNT-1, 1, -1 do
			prevname = frame:GetName().."_"..(i+1);
			button = _G[frame:GetName().."_"..i];
			buttontexture = _G[frame:GetName().."_"..i.."_Texture"];
			button:ClearAllPoints();
			if (settings.vertical) then
				button:SetPoint("BOTTOM", prevname, "TOP", 0, settings.vspacing);
			else
				button:SetPoint("RIGHT", prevname, "LEFT", -settings.hspacing, 0);
			end
			button:SetFrameLevel(frame:GetFrameLevel() + (DL_UNIT_BUFFCOUNT+1 - i));
			button:SetWidth(settings.size);
			button:SetHeight(settings.size);
			buttontexture:SetWidth(settings.size);
			buttontexture:SetHeight(settings.size);
		end
	else
		local button = _G[frame:GetName().."_1"];
		local buttontexture = _G[frame:GetName().."_1_Texture"];
		button:ClearAllPoints();
		button:SetPoint("TOPLEFT", frame:GetName(), "TOPLEFT", 0, 0);
		button:SetFrameLevel(frame:GetFrameLevel() + 1);
		button:SetWidth(settings.size);
		button:SetHeight(settings.size);
		buttontexture:SetWidth(settings.size);
		buttontexture:SetHeight(settings.size);
		local prevname;
		for i=2,DL_UNIT_BUFFCOUNT do
			prevname = frame:GetName().."_"..(i-1);
			button = _G[frame:GetName().."_"..i];
			buttontexture = _G[frame:GetName().."_"..i.."_Texture"];
			button:ClearAllPoints();
			if (settings.vertical) then
				button:SetPoint("TOP", prevname, "BOTTOM", 0, -settings.vspacing);
			else
				button:SetPoint("LEFT", prevname, "RIGHT", settings.hspacing, 0);
			end
			button:SetFrameLevel(frame:GetFrameLevel() + i);
			button:SetWidth(settings.size);
			button:SetHeight(settings.size);
			buttontexture:SetWidth(settings.size);
			buttontexture:SetHeight(settings.size);
		end
	end
	if (settings.tworows) then
		local row2start = math.ceil(settings.shown / 2) + 1;
		if (settings.reverse) then
			row2start = DL_UNIT_BUFFCOUNT - row2start + 1;
		end
		button = _G[frame:GetName().."_"..row2start];
		button:ClearAllPoints();
		if (settings.vertical) then
			if (settings.reverse) then
				button:SetPoint("RIGHT", frame:GetName().."_"..DL_UNIT_BUFFCOUNT, "LEFT", -settings.hspacing, 0);
			else
				button:SetPoint("LEFT", frame:GetName().."_1", "RIGHT", settings.hspacing, 0);
			end
		else
			if (settings.reverse) then
				button:SetPoint("BOTTOM", frame:GetName().."_"..DL_UNIT_BUFFCOUNT, "TOP", 0, settings.vspacing);
			else
				button:SetPoint("TOP", frame:GetName().."_1", "BOTTOM", 0, -settings.vspacing);
			end
		end
	end
	local stacksize = 9 * settings.size / 15;
	for i=1,DL_UNIT_BUFFCOUNT do
		local button = _G[frame:GetName().."_"..i];
		local stack = _G[button:GetName().."_Stack"];
		local scale = button:GetScale();
		stack:SetFont("Interface\\AddOns\\DiscordUnitFrames\\CustomFonts\\DUF_Font1.ttf", stacksize, "outline='THICK'");
		button:SetScale(scale + 1);
		button:SetScale(scale);
	end
	for i=1,DL_UNIT_BUFFCOUNT do
		local button = _G[frame:GetName().."_"..i];
		local duration = _G[frame:GetName().."_"..i.."_Text"];
		if (DUF_Settings[DUF_INDEX].custompaths) then
			duration:SetFont(settings.durationfont, settings.durationheight);
		else
			duration:SetFont("Interface\\AddOns\\DiscordUnitFrames\\CustomFonts\\"..settings.durationfont, settings.durationheight);
		end
		duration:SetTextColor(settings.durationcolor.r, settings.durationcolor.g, settings.durationcolor.b, settings.durationalpha);
		local scale = button:GetScale();
		button:SetScale(scale + 1);
		button:SetScale(scale);
		duration:ClearAllPoints();
		duration:SetPoint("TOP", button, "BOTTOM", settings.durationx, settings.durationy);
		if (settings.showduration) then
			duration:Show();
		else
			duration:Hide();
		end
		button.playerbuff = 1
	end
	DUF_UnitFrame_UpdateBuffs(self, unit);
end

function DUF_Initialize_ClassIcon(unit)
	local frame = _G[DUF_FRAME_DATA[unit].frame.."_ClassIcon"];
	local texture = _G[DUF_FRAME_DATA[unit].frame.."_ClassIcon_Texture"];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].ClassIcon;

	DUF_Initialize_Element(unit, frame, settings);

	texture:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes");
	DUF_Set_ClassIcon(unit);
end

function DUF_Initialize_ComboPoints()
	local settings = DUF_Settings[DUF_INDEX].target.ComboPoints;
	DUF_Initialize_Element("target", DUF_TargetFrame_ComboPoints, settings);
	local combopoint
	for i=1, 5 do
		combopoint = _G["DUF_TargetFrame_ComboPoints_"..i];
		combopoint:SetHeight(settings.size);
		combopoint:SetWidth(settings.size);
		_G["DUF_TargetFrame_ComboPoints_"..i.."_Texture"]:SetVertexColor(settings.color.r, settings.color.g, settings.color.b);
		combopoint:ClearAllPoints();
		if (i > 1) then
			local prev = "DUF_TargetFrame_ComboPoints_"..(i - 1);
			if (settings.vertical) then
				combopoint:SetPoint("TOP", prev, "BOTTOM", 0, -settings.spacing);
			else
				combopoint:SetPoint("LEFT", prev, "RIGHT", settings.spacing, 0);
			end
		else
			combopoint:SetPoint("TOPLEFT", "DUF_TargetFrame_ComboPoints", "TOPLEFT", 0, 0);
		end
		local cptexture = _G["DUF_TargetFrame_ComboPoints_"..i.."_Texture"];
		if (settings.customtexture and settings.customtexture ~= "") then
			if (DUF_Settings[DUF_INDEX].custompaths) then
				cptexture:SetTexture(settings.customtexture)
			else
				cptexture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\CustomTextures\\"..settings.customtexture);
			end
			cptexture:SetTexCoord(0, 1, 0, 1);
		else
			cptexture:SetTexture("Interface\\ComboFrame\\ComboPoint");
			cptexture:SetTexCoord(0, .375, 0, .8);
		end
	end
	DUF_ComboPoints_Update();
end

function DUF_Initialize_MonkHarmony()
	local settings = DUF_Settings[DUF_INDEX].player.MonkHarmony;
	DUF_Initialize_Element("player", DUF_PlayerFrame_MonkHarmony, settings);
	local orb, texture, attachOrb
	local bar = _G["DUF_PlayerFrame_MonkHarmony"]
	for i=1, 5 do
		orb = _G["DUF_PlayerFrame_MonkHarmony_LightEnergy_"..i];
--		_G["DUF_PlayerFrame_MonkHarmony_LightEnergy_"..i.."_Texture"]:SetVertexColor(settings.color.r, settings.color.g, settings.color.b);
		orb:ClearAllPoints();
		if (i == 1) then
			DUF_Position_Rune(orb, nil, settings, "DUF_PlayerFrame_MonkHarmony")
		else
			attachOrb = _G["DUF_PlayerFrame_MonkHarmony_LightEnergy_".. i - 1]
			DUF_Position_Rune(orb, attachOrb, settings)
		end
		local kids = { orb:GetChildren() };
		for _, child in ipairs(kids) do
			DL_Debug(tostring(child:GetName()))
		end
		_G["DUF_PlayerFrame_MonkHarmony_LightEnergy_".. i.."OrbOff"]:SetWidth(settings.size);
		_G["DUF_PlayerFrame_MonkHarmony_LightEnergy_".. i.."OrbOff"]:SetHeight(settings.size);
		_G["DUF_PlayerFrame_MonkHarmony_LightEnergy_".. i.."Glow"]:SetWidth(settings.size);
		_G["DUF_PlayerFrame_MonkHarmony_LightEnergy_".. i.."Glow"]:SetHeight(settings.size);
	end
	DUF_SetVisibility(bar, DUF_CLASS_ENU.Monk, settings.hide)
end

function DUF_Initialize_PalyPowerFrame()
	local bar = _G["DUF_PlayerFrame_PalyPowerFrame"]
	local settings = DUF_Settings[DUF_INDEX].player.PalyPowerFrame;
	DUF_Initialize_Element("player", DUF_PlayerFrame_PalyPowerFrame, settings);
	local rune, attachRune
	for i = 1, 5 do
		rune = _G["DUF_PlayerFrame_PalyPowerFrame_Rune_".. i];
		if (i == 1) then
			DUF_Position_Rune(rune, nil, settings, "DUF_PlayerFrame_PalyPowerFrame")
			rune:SetAlpha(1)
		else
			attachRune = _G["DUF_PlayerFrame_PalyPowerFrame_Rune_".. i - 1]
			DUF_Position_Rune(rune, attachRune, settings)
		end
	end
	DUF_SetVisibility(bar, DUF_CLASS_ENU.Paladin, settings.hide)
end

function DUF_Initialize_PriestOrbFrame()
	local bar = _G["DUF_PlayerFrame_PriestOrbFrame"]
	local settings = DUF_Settings[DUF_INDEX].player.PriestOrbFrame;
	DUF_Initialize_Element("player", DUF_PlayerFrame_PriestOrbFrame, settings);
	local orb, attachOrb
	for i = 1, 3 do
		orb = _G["DUF_PlayerFrame_PriestOrbFrame_Orb_".. i];
		if (i == 1) then
			DUF_Position_Rune(orb, nil, settings, "DUF_PlayerFrame_PriestOrbFrame")
			orb:SetAlpha(1)
		else
			attachOrb = _G["DUF_PlayerFrame_PriestOrbFrame_Orb_".. i - 1]
			DUF_Position_Rune(orb, attachOrb, settings)
		end
		_G["DUF_PlayerFrame_PriestOrbFrame_Orb_".. i.."Bg"]:SetWidth(settings.size);
		_G["DUF_PlayerFrame_PriestOrbFrame_Orb_".. i.."Bg"]:SetHeight(settings.size);
		_G["DUF_PlayerFrame_PriestOrbFrame_Orb_".. i.."Orb"]:SetWidth(settings.size);
		_G["DUF_PlayerFrame_PriestOrbFrame_Orb_".. i.."Orb"]:SetHeight(settings.size);
		_G["DUF_PlayerFrame_PriestOrbFrame_Orb_".. i.."Highlight"]:SetWidth(settings.size);
		_G["DUF_PlayerFrame_PriestOrbFrame_Orb_".. i.."Highlight"]:SetHeight(settings.size);
		_G["DUF_PlayerFrame_PriestOrbFrame_Orb_".. i.."Glow"]:SetWidth(settings.size);
		_G["DUF_PlayerFrame_PriestOrbFrame_Orb_".. i.."Glow"]:SetHeight(settings.size);
	end
	DUF_SetVisibility(bar, DUF_CLASS_ENU.Priest, settings.hide)
end

function DUF_Initialize_RuneFrame()
	local settings = DUF_Settings[DUF_INDEX].player.RuneFrame;
	DUF_Initialize_Element("player", DUF_PlayerFrame_RuneFrame, settings);
	local bar = _G["DUF_PlayerFrame_RuneFrame"];
	DUF_Position_Rune(DUF_PlayerFrame_RuneFrame_RuneButtonIndividual1, nil, settings, "DUF_PlayerFrame_RuneFrame");
	DUF_Position_Rune(DUF_PlayerFrame_RuneFrame_RuneButtonIndividual2, DUF_PlayerFrame_RuneFrame_RuneButtonIndividual1, settings);
	DUF_Position_Rune(DUF_PlayerFrame_RuneFrame_RuneButtonIndividual5, DUF_PlayerFrame_RuneFrame_RuneButtonIndividual2, settings);
	DUF_Position_Rune(DUF_PlayerFrame_RuneFrame_RuneButtonIndividual6, DUF_PlayerFrame_RuneFrame_RuneButtonIndividual5, settings);
	DUF_Position_Rune(DUF_PlayerFrame_RuneFrame_RuneButtonIndividual3, DUF_PlayerFrame_RuneFrame_RuneButtonIndividual6, settings);
	DUF_Position_Rune(DUF_PlayerFrame_RuneFrame_RuneButtonIndividual4, DUF_PlayerFrame_RuneFrame_RuneButtonIndividual3, settings);
	for i = 1,6 do
		_G["DUF_PlayerFrame_RuneFrame_RuneButtonIndividual"..i.."Rune"]:SetWidth(settings.size);
		_G["DUF_PlayerFrame_RuneFrame_RuneButtonIndividual"..i.."Rune"]:SetHeight(settings.size);
		_G["DUF_PlayerFrame_RuneFrame_RuneButtonIndividual"..i.."Border"]:SetWidth(settings.size);
		_G["DUF_PlayerFrame_RuneFrame_RuneButtonIndividual"..i.."Border"]:SetHeight(settings.size);
	end
	
	DUF_SetVisibility(bar, DUF_CLASS_ENU.DeathKnight, settings.hide);
	RuneFrame:Hide();
	RuneFrame:UnregisterAllEvents();
end

function DUF_Position_Rune(rune, prev, settings, frameName, xAdjust, yAdjust)
		rune:SetHeight(settings.size);
		rune:SetWidth(settings.size);
		rune:ClearAllPoints();
		local xa = 0;
		local ya = 0;
		if (xAdjust) then
			xa = xAdjust;
		end
		if (yAdjust) then
			ya = yAdjust;
		end
		if (prev) then
			if (settings.vertical) then
				rune:SetPoint("TOP", prev:GetName(), "BOTTOM", 0, -settings.spacing + xa);
			else
				rune:SetPoint("LEFT", prev:GetName(), "RIGHT", settings.spacing + ya, 0);
			end
		else
			rune:SetPoint("TOPLEFT", frameName, "TOPLEFT", xa, ya);
		end
		
end

function DUF_Initialize_WarlockPowerFrame()
	local settings = DUF_Settings[DUF_INDEX].player.WarlockPowerFrame;
	DUF_Initialize_Element("player", DUF_PlayerFrame_WarlockPowerFrame, settings);
	local rune1, rune2, attachRune1, attachRune2
	local bar = _G["DUF_PlayerFrame_WarlockPowerFrame"]
	DUF_Position_Rune(DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame, nil, settings, DUF_PlayerFrame_WarlockPowerFrame)
	DUF_Position_Rune(DUF_PlayerFrame_WarlockPowerFrame_EmberBarFrame, nil, settings, DUF_PlayerFrame_WarlockPowerFrame)
	local spec = GetSpecialization();
	for i=1, 4 do
		rune1 = _G["DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame_Shard_"..i];
		rune2 = _G["DUF_PlayerFrame_WarlockPowerFrame_EmberBarFrame_Ember_"..i];
		if (i == 1) then
			DUF_Position_Rune(rune1, nil, settings, DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame);
			DUF_Position_Rune(rune2, nil, settings, DUF_PlayerFrame_WarlockPowerFrame_EmberBarFrame, -5, 5);
		else
			attachRune1 = _G["DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame_Shard_".. i - 1];
			attachRune2 = _G["DUF_PlayerFrame_WarlockPowerFrame_EmberBarFrame_Ember_".. i - 1];
			DUF_Position_Rune(rune1, attachRune1, settings);
			DUF_Position_Rune(rune2, attachRune2, settings,nil, -5, 5);
		end
		if ( spec == SPEC_WARLOCK_AFFLICTION or DUF_OPTIONS_VISIBLE) then
			_G["DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame_Shard_"..i.."Border"]:SetWidth(settings.size*1.5);
			_G["DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame_Shard_"..i.."Border"]:SetHeight(settings.size);
			_G["DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame_Shard_"..i.."Fill"]:SetWidth((settings.size*1.5) - 25);
			_G["DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame_Shard_"..i.."Fill"]:SetHeight(settings.size - 13);
		end
		if ( spec == SPEC_WARLOCK_DESTRUCTION or DUF_OPTIONS_VISIBLE) then
			_G["DUF_PlayerFrame_WarlockPowerFrame_EmberBarFrame_Ember_"..i.."Fill"]:SetWidth(settings.size/1.5);
			_G["DUF_PlayerFrame_WarlockPowerFrame_EmberBarFrame_Ember_"..i.."Fill"]:SetHeight(settings.size/1.5);
			_G["DUF_PlayerFrame_WarlockPowerFrame_EmberBarFrame_Ember_"..i.."Fire"]:SetWidth(settings.size);
			_G["DUF_PlayerFrame_WarlockPowerFrame_EmberBarFrame_Ember_"..i.."Fire"]:SetHeight(settings.size);
		end
	end

	DUF_SetVisibility(bar, DUF_CLASS_ENU.Warlock, settings.hide)
	DUF_DemonicBar_Update_Display()
end

function DUF_Initialize_Debuffs(self, unit)
	local frame = _G[DUF_FRAME_DATA[unit].frame.."_Debuffs"];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].Debuffs;

	DUF_Initialize_Element(unit, frame, settings);

	if (settings.reverse) then
		local button = _G[frame:GetName().."_"..DL_UNIT_BUFFCOUNT];
		local buttontex = _G[frame:GetName().."_"..DL_UNIT_BUFFCOUNT.."_Texture"];
		button:ClearAllPoints();
		button:SetPoint("BOTTOMRIGHT", frame:GetName(), "BOTTOMRIGHT", 0, 0);
		button:SetFrameLevel(frame:GetFrameLevel() + 1);
		button:SetWidth(settings.size);
		button:SetHeight(settings.size);
		buttontex:SetWidth(settings.size);
		buttontex:SetHeight(settings.size);
		local prevname;
		for i=DL_UNIT_BUFFCOUNT-1, 1, -1 do
			prevname = frame:GetName().."_"..(i+1);
			button = _G[frame:GetName().."_"..i];
			buttontex = _G[frame:GetName().."_"..i.."_Texture"];
			button:ClearAllPoints();
			if (settings.vertical) then
				button:SetPoint("BOTTOM", prevname, "TOP", 0, settings.vspacing);
			else
				button:SetPoint("RIGHT", prevname, "LEFT", -settings.hspacing, 0);
			end
			button:SetFrameLevel(frame:GetFrameLevel() + (DL_UNIT_BUFFCOUNT + 1 - i));
			button:SetWidth(settings.size);
			button:SetHeight(settings.size);
			buttontex:SetWidth(settings.size);
			buttontex:SetHeight(settings.size);
		end
	else
		local button = _G[frame:GetName().."_1"];
		local buttontex = _G[frame:GetName().."_1_Texture"];
		button:ClearAllPoints();
		button:SetPoint("TOPLEFT", frame:GetName(), "TOPLEFT", 0, 0);
		button:SetFrameLevel(frame:GetFrameLevel() + 1);
		button:SetWidth(settings.size);
		button:SetHeight(settings.size);
		buttontex:SetWidth(settings.size);
		buttontex:SetHeight(settings.size);
		local prevname;
		for i=2,DL_UNIT_BUFFCOUNT do
			prevname = frame:GetName().."_"..(i-1);
			button = _G[frame:GetName().."_"..i];
			buttontex = _G[frame:GetName().."_"..i.."_Texture"];
			button:ClearAllPoints();
			if (settings.vertical) then
				button:SetPoint("TOP", prevname, "BOTTOM", 0, -settings.vspacing);
			else
				button:SetPoint("LEFT", prevname, "RIGHT", settings.hspacing, 0);
			end
			button:SetFrameLevel(frame:GetFrameLevel() + i);
			button:SetWidth(settings.size);
			button:SetHeight(settings.size);
			buttontex:SetWidth(settings.size);
			buttontex:SetHeight(settings.size);
		end
	end
	
	if (settings.flash) then
		for i=1,DL_UNIT_BUFFCOUNT do
			local button = _G[frame:GetName().."_"..i];
			button.flashing = true;
			button.timer = .5;
			button.direction = 1;
		end
	else
		for i=1,DL_UNIT_BUFFCOUNT do
			local button = _G[frame:GetName().."_"..i];
			button:SetAlpha(1);
			button.flashing = nil;
		end
	end
	if (settings.tworows) then
		local row2start = math.ceil(settings.shown / 2) + 1;
		if (settings.reverse) then
			row2start = DL_UNIT_BUFFCOUNT - row2start + 1;
		end
		button = _G[frame:GetName().."_"..row2start];
		button:ClearAllPoints();
		if (settings.vertical) then
			if (settings.reverse) then
				button:SetPoint("RIGHT", frame:GetName().."_"..DL_UNIT_BUFFCOUNT, "LEFT", -settings.hspacing, 0);
			else
				button:SetPoint("LEFT", frame:GetName().."_1", "RIGHT", settings.hspacing, 0);
			end
		else
			if (settings.reverse) then
				button:SetPoint("BOTTOM", frame:GetName().."_"..DL_UNIT_BUFFCOUNT, "TOP", 0, settings.vspacing);
			else
				button:SetPoint("TOP", frame:GetName().."_1", "BOTTOM", 0, -settings.vspacing);
			end
		end
	end
	local stacksize = 12 * settings.size / 15;
	for i=1,DL_UNIT_BUFFCOUNT do
		local button = _G[frame:GetName().."_"..i];
		local stack = _G[button:GetName().."_Stack"];
		local scale = button:GetScale();
		stack:SetFont("Interface\\AddOns\\DiscordUnitFrames\\CustomFonts\\DUF_Font1.ttf", stacksize, "outline='THICK'");
		button:SetScale(scale + 1);
		button:SetScale(scale);
	end

		for i=1,DL_UNIT_BUFFCOUNT do
			local button = _G[frame:GetName().."_"..i];
			local duration = _G[frame:GetName().."_"..i.."_Text"];
			if (DUF_Settings[DUF_INDEX].custompaths) then
				duration:SetFont(settings.durationfont, settings.durationheight);
			else
				duration:SetFont("Interface\\AddOns\\DiscordUnitFrames\\CustomFonts\\"..settings.durationfont, settings.durationheight);
			end
			duration:SetTextColor(settings.durationcolor.r, settings.durationcolor.g, settings.durationcolor.b, settings.durationalpha);
			local scale = button:GetScale();
			button:SetScale(scale + 1);
			button:SetScale(scale);
			duration:ClearAllPoints();
			duration:SetPoint("TOP", button, "BOTTOM", settings.durationx, settings.durationy);
			if (settings.showduration) then
				duration:Show();
			else
				duration:Hide();
			end
			button.playerbuff = 1
		end

	DUF_UnitFrame_UpdateDebuffs(self, unit);
end

function DUF_Initialize_Element(unit, frame, settings, debug)
	DUF_Initialize_BaseSettings(frame, settings, debug);
	DUF_Set_ElementPosition(frame, DUF_FRAME_DATA[unit].frame, settings);
end

function DUF_Initialize_EliteTexture()
	local frame = DUF_TargetFrame_EliteTexture;
	local settings = DUF_Settings[DUF_INDEX].target.EliteTexture;

	DUF_Initialize_Element("target", frame, settings);

	DUF_Set_EliteTexture();
end

function DUF_Initialize_Frame(self, unit)
	local unitFrame = _G[DUF_FRAME_DATA[unit].frame];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index];

	DUF_Initialize_BaseSettings(unitFrame, settings);

	DUF_Initialize_FrameLoc(unit)

	unitFrame:SetScale(settings.scale);
	unitFrame.scale = settings.scale;
	unitFrame.basecolor = {};
	unitFrame.basecolor.r = settings.bgcolor.r;
	unitFrame.basecolor.g = settings.bgcolor.g;
	unitFrame.basecolor.b = settings.bgcolor.b;
	if ((not UnitName(unit)) and (not UnitExists(unit)) and (not DUF_OPTIONS_VISIBLE)) then
		unitFrame:Hide();
	end
end

function DUF_Initialize_FrameLoc(unit)
	local unitFrame = _G[DUF_FRAME_DATA[unit].frame];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index];
	unitFrame:ClearAllPoints();
	if (settings.connect and unitFrame:GetID() > 1) then
		if (DUF_FRAME_DATA[unit].index == "party" or DUF_FRAME_DATA[unit].index == "partypet") then
			local connectframe = "DUF_PartyFrame"..(unitFrame:GetID() - 1);
			if (DUF_FRAME_DATA[unit].index == "partypet") then
				connectframe = "DUF_PartyPetFrame"..(unitFrame:GetID() - 1);
			end
			if (settings.connectmethod == 1) then
				unitFrame:SetPoint("TOP", connectframe, "BOTTOM", 0, -settings.spacing);
			elseif (settings.connectmethod == 2) then
				unitFrame:SetPoint("BOTTOM", connectframe, "TOP", 0, settings.spacing);
			elseif (settings.connectmethod == 3) then
				unitFrame:SetPoint("LEFT", connectframe, "RIGHT", settings.spacing, 0);
			elseif (settings.connectmethod == 4) then
				unitFrame:SetPoint("RIGHT", connectframe, "LEFT", -settings.spacing, 0);
			end
		else
			unitFrame:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", settings.xos[unitFrame:GetID()], settings.yos[unitFrame:GetID()]);
		end
	else
		unitFrame:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", settings.xos[unitFrame:GetID()], settings.yos[unitFrame:GetID()]);
	end
end

function DUF_Initialize_IconBackground(frame, settings)
	frame = _G[frame:GetName().."_Circle"];
	if (settings.circle) then
		frame:Show();
	else
		frame:Hide();
		return;
	end
	local background = _G[frame:GetName().."_Background"];
	local border = _G[frame:GetName().."_Border"];
	background:SetVertexColor(settings.bgcolor.r, settings.bgcolor.g, settings.bgcolor.b, settings.bgalpha);
	border:SetVertexColor(settings.bordercolor.r, settings.bordercolor.g, settings.bordercolor.b, settings.borderalpha);
end

function DUF_Initialize_LeaderIcon(unit)
	local frame = _G[DUF_FRAME_DATA[unit].frame.."_LeaderIcon"];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].LeaderIcon;

	DUF_Initialize_Element(unit, frame, settings);
	DUF_Initialize_IconBackground(frame, settings);
	_G[DUF_FRAME_DATA[unit].frame.."_LeaderIcon_Texture"]:SetTexture("Interface\\GroupFrame\\UI-Group-LeaderIcon");
	DUF_LeaderIcon_Update(unit);
end

function DUF_Initialize_LootIcon(unit)
	local frame = _G[DUF_FRAME_DATA[unit].frame.."_LootIcon"];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].LootIcon;

	DUF_Initialize_Element(unit, frame, settings);
	DUF_Initialize_IconBackground(frame, settings);
	_G[DUF_FRAME_DATA[unit].frame.."_LootIcon_Texture"]:SetTexture("Interface\\GroupFrame\\UI-Group-MasterLooter");
	DUF_LootIcon_Update(unit);
end

function DUF_CreatePortrait(unit) -- Fizzlemizz: Function added to move portraits from XML to allow for 3D portraits
	local frame = _G[DUF_FRAME_DATA[unit].frame .. "_Portrait"]
	if (frame) then
		frame:Hide();
	end
	local use3D, use3Dface = DUF_Get3D(unit);
	if (use3D) then	
		if (not _G[DUF_FRAME_DATA[unit].frame .. "_Portrait_Frame3d"]) then
			frame = CreateFrame("PlayerModel" , unit .. "_Portrait" , _G[DUF_FRAME_DATA[unit].frame] , "DUF_3DPortraitTemplate"); -- Fizzlemizz:
			_G[DUF_FRAME_DATA[unit].frame .. "_Portrait_Frame3d"] = frame;
		else
			frame = _G[DUF_FRAME_DATA[unit].frame .. "_Portrait_Frame3d"]
		end
	else
		if (not _G[DUF_FRAME_DATA[unit].frame .. "_Portrait_Frame2d"]) then
			frame = CreateFrame("Button" , unit .. "_Portrait" , _G[DUF_FRAME_DATA[unit].frame] , "DUF_PortraitTemplate"); -- Fizzlemizz:
			_G[DUF_FRAME_DATA[unit].frame .. "_Portrait_Frame2d"] = frame;
		else
			frame = _G[DUF_FRAME_DATA[unit].frame .. "_Portrait_Frame2d"]
		end
	end
	_G[DUF_FRAME_DATA[unit].frame .. "_Portrait"] = frame -- Fizzlemizz:
	local texture, border = frame:GetRegions();
	_G[DUF_FRAME_DATA[unit].frame.."_Portrait_Border"] = border -- Fizzlemizz:
	_G[DUF_FRAME_DATA[unit].frame.."_Portrait_Texture"] = texture; -- Fizzlemizz:
	_G[frame:GetName().."_Border"] = border -- Fizzlemizz:
	_G[frame:GetName().."_Texture"] = texture -- Fizzlemizz:
	frame:Show()
end

function DUF_Initialize_Portrait(unit)
	DUF_CreatePortrait(unit)
	local frame = _G[DUF_FRAME_DATA[unit].frame.."_Portrait"];
	_G[frame:GetName().."_Border"]:Hide();
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].Portrait;
	DUF_Initialize_Element(unit, frame, settings);
	local use3D, use3Dface = DUF_Get3D(unit);
	if (not use3D) then	
		if (settings.showborder) then
			_G[frame:GetName().."_Border"]:Show();
		else
			_G[frame:GetName().."_Border"]:Hide();
		end
	end
	_G[frame:GetName().."_Border"]:SetVertexColor(settings.bordcolor.r, settings.bordcolor.g, settings.bordcolor.b);
	DUF_Set_Portrait(unit);
end

function DUF_Initialize_PVPIcon(unit)
	local frame = _G[DUF_FRAME_DATA[unit].frame.."_PVPIcon"];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].PVPIcon;

	DUF_Initialize_Element(unit, frame, settings);
	DUF_Initialize_IconBackground(frame, settings);

	_G[DUF_FRAME_DATA[unit].frame.."_PVPIcon_Texture"]:SetTexCoord(0, .6875, 0, .625);
	DUF_PVPIcon_Update(unit);
end

function DUF_Initialize_RaceIcon(unit)
	local frame = _G[DUF_FRAME_DATA[unit].frame.."_RaceIcon"];
	local texture = _G[DUF_FRAME_DATA[unit].frame.."_RaceIcon_Texture"];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].RaceIcon;

	DUF_Initialize_Element(unit, frame, settings);

	texture.targetIcon = nil
	if (settings.targetIcon) then
		if (frame:GetParent().targetIcon == 1) then
			frame:GetParent().targetIcon = 3
		else
			frame:GetParent().targetIcon = 2
		end
		texture.targetIcon = 1
		texture:Hide()
		frame:GetParent().targetIndex = nil
		texture:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
	end
	DUF_Set_RaceIcon(unit);
end

function DUF_Initialize_RankIcon(unit)
	local frame = _G[DUF_FRAME_DATA[unit].frame.."_RankIcon"];
	local texture = _G[DUF_FRAME_DATA[unit].frame.."_RankIcon_Texture"];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].RankIcon;

	DUF_Initialize_Element(unit, frame, settings);

	texture.targetIcon = nil
	if (settings.targetIcon) then
		if (frame:GetParent().targetIcon == 2) then
			frame:GetParent().targetIcon = 3
		else
			frame:GetParent().targetIcon = 1
		end
		texture.targetIcon = 1
		texture:Hide()
		frame:GetParent().targetIndex = nil
		texture:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
	end
	

	DUF_Set_RankIcon(unit);
end

function DUF_Initialize_RoleIcon(unit)
	local frame = _G[DUF_FRAME_DATA[unit].frame.."_RoleIcon"];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].RoleIcon;
	DUF_Initialize_Element(unit, frame, settings);
	DUF_Initialize_IconBackground(frame, settings);
	DUF_RoleIcon_Update(unit);
end

function DUF_Initialize_StatusBar(Fizz, unit, bar, debug)  
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].StatusBar[bar];
	local frame = _G[DUF_FRAME_DATA[unit].frame..DUF_STATUSBARS[bar]];
	if ((not settings) or (not frame)) then return; end
	local statusbar = _G[DUF_FRAME_DATA[unit].frame..DUF_STATUSBARS[bar].."_Bar"];
	local statusbarbg = _G[DUF_FRAME_DATA[unit].frame..DUF_STATUSBARS[bar].."_Bar2"];
	if (not settings.resizemax) then
		frame.dynamicsize = nil;
	end
	DUF_Initialize_Element(unit, frame, settings, debug);
	if (settings.customtexture and settings.customtexture ~= "") then
		if (DUF_Settings[DUF_INDEX].custompaths) then
			statusbar:SetTexture(settings.customtexture);
		else
			statusbar:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\CustomTextures\\"..settings.customtexture);
		end
	else
		statusbar:SetTexture("Interface\\TargetingFrame\\UI-StatusBar");
	end
	if (settings.customtexture2 and settings.customtexture2 ~= "") then
		if (DUF_Settings[DUF_INDEX].custompaths) then
			statusbarbg:SetTexture(settings.customtexture2);
		else
			statusbarbg:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\CustomTextures\\"..settings.customtexture2);
		end
	else
		statusbarbg:SetTexture("Interface\\AddOns\\DiscordLibrary\\PlainBackdrop");
	end
	statusbar:SetWidth(settings.width);
	statusbarbg:SetWidth(settings.width);
	statusbar:SetHeight(settings.height);
	statusbarbg:SetHeight(settings.height);
	statusbar:ClearAllPoints();
	statusbarbg:ClearAllPoints();
	statusbar.direction = settings.direction;
	statusbarbg.direction = settings.direction;
	if (settings.direction == 1) then
		statusbar:SetPoint("LEFT", frame, "LEFT", 0, 0);
		statusbarbg:SetPoint("LEFT", frame, "LEFT", 0, 0);
		statusbar.length = settings.width;
		statusbarbg.length = settings.width;
	elseif (settings.direction == 2) then
		statusbar:SetPoint("RIGHT", frame, "RIGHT", 0, 0);
		statusbarbg:SetPoint("RIGHT", frame, "RIGHT", 0, 0);
		statusbar.length = settings.width;
		statusbarbg.length = settings.width;
	elseif (settings.direction == 3) then
		statusbar:SetPoint("BOTTOM", frame, "BOTTOM", 0, 0);
		statusbarbg:SetPoint("BOTTOM", frame, "BOTTOM", 0, 0);
		statusbar.length = settings.height;
		statusbarbg.length = settings.height;
	else
		statusbar:SetPoint("TOP", frame, "TOP", 0, 0);
		statusbarbg:SetPoint("TOP", frame, "TOP", 0, 0);
		statusbar.length = settings.height;
		statusbarbg.length = settings.height;
	end

	if (bar ~= 2 and bar ~= 5 and bar ~= 7 and bar ~= 8) then 
		statusbar:SetVertexColor(settings.color.r, settings.color.g, settings.color.b);
	end
	statusbarbg:SetVertexColor(settings.color2.r, settings.color2.g, settings.color2.b);
	local DUF_Initialize_StatusBar = _G[DUF_FRAME_DATA[unit].frame];
	if (bar == 1) then
		DUF_Initialize_StatusBar.lasthealth = UnitHealth(unit);
		DUF_Initialize_StatusBar.lasthealthalpha = 0;
		DUF_HealthBar_Update(DUF_Initialize_StatusBar);
	elseif (bar == 2) then
		DUF_Initialize_StatusBar.lastmana = UnitPower(unit);
		DUF_Initialize_StatusBar.lastmanaalpha = 0;
		DUF_Initialize_StatusBar.manatype = 0;
		DUF_ManaBar_Update(DUF_Initialize_StatusBar);
		DUF_ManaBar_UpdateType(DUF_Initialize_StatusBar);
	elseif (bar == 3) then
		if (unit == "player") then
			DUF_XPBar_Update();
		else
			DUF_PetXPBar_Update();
		end
	elseif (bar == 4) then
		DUF_TargetHealthBar_Update(DUF_Initialize_StatusBar);
	elseif (bar == 5) then
		DUF_TargetManaBar_Update(DUF_Initialize_StatusBar);
		DUF_TargetManaBar_UpdateType(DUF_Initialize_StatusBar);
	elseif (bar == 6) then
		DUF_HonorBar_Update();
	elseif (bar == 7) then
		DUF_CastBar_Update(DUF_Initialize_StatusBar);
	elseif (bar == 8) then 
		if (unit == "player" and DUF_ISDRUID) then
			DUF_Initialize_StatusBar.lastmana = UnitPower(unit);
			DUF_Initialize_StatusBar.lastmanaalpha = 0;
			DUF_DruidManaBar_Update(DUF_Initialize_StatusBar);
			DUF_Initialize_StatusBar.manatype = 0;
			DUF_DruidManaBar_UpdateType(DUF_Initialize_StatusBar);
		end
		DUF_DruidManaBar_Update_Display();
	elseif (bar == 9) then
		if (unit == "player") then
			DUF_Initialize_StatusBar.lastdemopower = UnitPower("player", SPELL_POWER_DEMONIC_FURY);
			DUF_Initialize_StatusBar.lastdemopoweralpha = 0;
			DUF_DemonicBar_Update(DUF_Initialize_StatusBar);
			DUF_DemonicBar_Update_Display()
		end
	end
end

function DUF_Initialize_StatusIcon(unit)
	local frame = _G[DUF_FRAME_DATA[unit].frame.."_StatusIcon"];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].StatusIcon;

	DUF_Initialize_Element(unit, frame, settings);
	DUF_Initialize_IconBackground(frame, settings);

	DUF_StatusIcon_Update(unit);
end

function DUF_Initialize_TextBox(Fizz, unit, box)
	local frame = _G[DUF_FRAME_DATA[unit].frame.."_TextBox_"..box];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].TextBox[box];
	if ((not frame) or (not settings)) then return; end
	local textbox = _G[DUF_FRAME_DATA[unit].frame.."_TextBox_"..box.."_Text"];
	DUF_Initialize_Element(unit, frame, settings);
	local fontFlags = "";
	if (settings.outline) then
		fontFlags = "outline='"..settings.outline.."'";
	end
	if (DUF_Settings[DUF_INDEX].custompaths) then
		textbox:SetFont(settings.font, settings.textheight, fontFlags);
	else
		textbox:SetFont("Interface\\AddOns\\DiscordUnitFrames\\CustomFonts\\"..settings.font, settings.textheight, fontFlags);
	end
	frame:SetScale(2);
	frame:SetScale(1);
	textbox:SetJustifyH(settings.justify);
	textbox:SetJustifyV(settings.justifyV);
	textbox:SetTextColor(settings.textcolor.r, settings.textcolor.g, settings.textcolor.b);

	for variable, value in pairs(DUF_VARIABLE_FUNCTIONS) do
		for _,event in pairs(value.events) do
			frame:UnregisterEvent(event);			
		end
	end
	if (settings.text and settings.text ~= "") then
		frame.variables = {};
		for variable, value in pairs(DUF_VARIABLE_FUNCTIONS) do
			if (string.find(settings.text, variable)) then
				frame.variables[variable] = true;
				for _,event in pairs(value.events) do
					frame:RegisterEvent(event);			
				end			
			end
			if (DUF_UNIT_CHANGED_EVENTS[frame:GetParent().unit]) then
				frame:RegisterEvent(DUF_UNIT_CHANGED_EVENTS[frame:GetParent().unit])
			end
		end
		DUF_CallMethod(frame, DUF_TextBox_Update, frame)
	else
		textbox:SetText("");
		frame:Hide();
	end
	frame.checkname = nil;
	frame.checkhealth = nil;
	frame.checkmana = nil;
	frame.checkhealthmax = nil;
	frame.checkmanamax = nil;
	frame.checklevel = nil;
	frame.checktype = nil;
	frame.checkoffline = nil;
	frame.checkreaction = nil;
	frame.checkcombat = nil;
	frame.checkpetxp = nil;
	frame.checkvisibility = nil;
	frame.checkcolor = nil;
	if (string.find(settings.text, '$t')) then
		frame.checkname= true;
	end
	if (string.find(settings.text, '$th')) then
		frame.checkhealth = true;
	end
	if (string.find(settings.text, '$tm')) then
		frame.checkmana = true;
	end
	if (string.find(settings.text, '$tx')) then
		frame.checkhealthmax = true;
	end
	if (string.find(settings.text, '$ta')) then
		frame.checkhealth = true;
		frame.checkhealthmax = true;
	end
	if (string.find(settings.text, '$tb')) then
		frame.checkmana = true;
		frame.checkmanamax = true;
	end
	if (string.find(settings.text, '$ty')) then
		frame.checkmanamax = true;
	end
	if (string.find(settings.text, '$tl')) then
		frame.checklevel = true;
	end
	if (string.find(settings.text, '$tt')) then
		frame.checktype = true;
	end
	if (string.find(settings.text, '$re')) then
		frame.checkreaction = true;
	end
	if (string.find(settings.text, '$of')) then
		frame.checkoffline = true;
	end
	if (string.find(settings.text, '$ic')) then
		frame.checkcombat = true;
	end
	if (string.find(settings.text, '$iv')) then
		frame.checkvisibility = true;
	end
	if (string.find(settings.text, '$px') or string.find(settings.text, '$py') or string.find(settings.text, '$pc') or string.find(settings.text, '$pp') or string.find(settings.text, '$pg')) then
		frame.checkpetxp = true;
	end
	if (string.find(settings.text, '$cr') or string.find(settings.text, '$cw') or string.find(settings.text, '$cm') or string.find(settings.text, '$ch') or string.find(settings.text, '$cq')) then
		frame.checkcolor = true;
	end
end

function DUF_Initialize_VariablesFrame()
	DUF_TextVariablesFrame_Title:SetText(DUF_TEXT.VariablesTitle);
	local column1, column2 = "", "";
	local count = #DUF_TEXTVARIABLES;
	local halfway = math.ceil(count / 2);
	for i=1, halfway do
		column1 = column1..DUF_TEXTVARIABLES[i].."\n";
	end
	halfway = halfway + 1
	for i = halfway, count do
		column2 = column2..DUF_TEXTVARIABLES[i].."\n";
	end
	DUF_TextVariablesFrame_Column1:SetText(column1);
	DUF_TextVariablesFrame_Column2:SetText(column2);
	DUF_TextVariablesFrame:SetWidth(DUF_TextVariablesFrame_Column1:GetWidth() + DUF_TextVariablesFrame_Column1:GetWidth() + 20);
	DUF_TextVariablesFrame:SetHeight(DUF_TextVariablesFrame_Column1:GetHeight() + 85);
end
