function DUF_SetupClickTargetting(frame, unit)
  local buttons = {"leftclick", "rightclick", "middleclick" }
  local actions = {"target", "assist", "menu"}
  for butval,but in pairs(buttons) do
    local frameindex = DUF_FRAME_DATA[unit].index
    local action = actions[ DUF_Settings[DUF_INDEX][frameindex][but] ]
    frame:SetAttribute("*type"..butval, action)
  end
end

function DUF_ComboPoints_Update()
	local comboPoints = GetComboPoints( UnitHasVehicleUI( "player") and "vehicle" or "player", "target");
	if (DUF_OPTIONS_VISIBLE) then
		if (UnitClass("player") == DUF_TEXT.Rogue or UnitClass("player") == DUF_TEXT.Druid) then
			comboPoints = 5;
		end
	end
	local comboPoint;
	local alpha = DUF_Settings[DUF_INDEX].target.ComboPoints.alpha
	for i=1,5 do
		comboPoint = _G["DUF_TargetFrame_ComboPoints_"..i];
		if (i <= comboPoints) then
			comboPoint:SetAlpha(alpha)
			ComboFrame:Hide();
		else
		      comboPoint:SetAlpha(0)
		end
	end
end

function DUF_Load_Options()
	if (DUF_Options) then return; end
	DUF_GENERALPROPERTIES = nil;
	UIParentLoadAddOn("DiscordUnitFramesOptions");
	DL_Set_OptionsTitle("DUF_Options", "DiscordUnitFrames\\Icons\\title.tga", DUF_VERSION .. DUF_SUBVERSION);
	DUF_Initialize_VariablesFrame();
	DUF_FRAME_INDEX = "player";
	DUF_SelectFrame_OnClick(DUF_Options_Self, "player", DUF_Options_Self);
	DUF_Options_SelectFrameOptions();
	DUF_OPTIONS_SELECTED = "DUF_ElementOptions_BaseSelect";
	DUF_ElementOptions_BaseSelect:SetNormalFontObject(GameFontNormal);
	DUF_ElementOptions_BaseSelect:SetBackdropColor(1, 1, 0);
	DUF_ElementOptions_BaseSelect:SetBackdropBorderColor(1, 1, 1);
	DUF_Update_SavedSettings();
	DUF_Options_SetScale();
	DUF_Init_ContextColors();
	DUF_Init_MiscOptions();
end

function DUF_Main_OnEvent(self, event, ...)
	local arg1, arg2 = ...
	if (not DUF_INITIALIZED) then return; end
	if (event == "PARTY_MEMBERS_CHANGED") then
		DUF_Main_UpdatePartyMembers();
	elseif (event == "UNIT_COMBO_POINTS") then 
		DUF_ComboPoints_Update();
	elseif (event == "PLAYER_PVP_KILLS_CHANGED" or event == "PLAYER_PVP_RANK_CHANGED") then
		DUF_HonorBar_Update();
	elseif (event == "UNIT_TARGET") then
		if arg1 == "target" then
			DUF_CallMethod(DUF_TargetOfTargetFrame, DUF_UnitFrame_OnShow, self)
		end
	elseif (event == "PLAYER_TARGET_CHANGED") then
		if (DL_UnitName("target")) then
			if (not DUF_Settings[DUF_INDEX].target.hide) then
				if ( not InCombatLockdown() ) then 
					DUF_TargetFrame:Show();
					DUF_CallMethod(DUF_TargetFrame,         DUF_UnitFrame_OnShow, self) 
					DUF_CallMethod(DUF_TargetOfTargetFrame, DUF_UnitFrame_OnShow, self) 
					DUF_Set_EliteTexture();
				end;
			end
			if (DL_UnitName("targettarget")) then
				if (not DUF_Settings[DUF_INDEX].targettarget.hide) then
					if (DUF_Settings[DUF_INDEX].hidetargettarget) then
--						if (GetNumRaidMembers() + GetNumPartyMembers() > 0) then
--						if (GetNumGroupMembers() + GetNumPartyMembers() > 0) then
						if (GetNumGroupMembers() + GetNumSubgroupMembers() > 0) then
						 	if ( not InCombatLockdown() ) then 
								DUF_SetFrameUnitWatch(DUF_TargetOfTargetFrame,true);
								DUF_CallMethod(DUF_TargetOfTargetFrame, DUF_UnitFrame_OnShow, self) 
						 	end
						else
						 	if ( not InCombatLockdown() ) then 
								DUF_SetFrameUnitWatch(DUF_TargetOfTargetFrame,false);
								DUF_TargetOfTargetFrame:Hide();
							end
						end
					else
						DUF_CallMethod(DUF_TargetOfTargetFrame, DUF_UnitFrame_OnShow, self) 
					end
				end
			end
		else
		end
		DUF_ComboPoints_Update();
		if (not DUF_Settings[DUF_INDEX].target.showDefault) then
			if (MobHealthFrame) then
			end
		end
	elseif (event == "PLAYER_XP_UPDATE" or event == "PLAYER_UPDATE_RESTING") then
		if (not DUF_Settings[DUF_INDEX].player.StatusBar[3].trackRep) then
			DUF_XPBar_Update();
		end
	elseif (event == "UPDATE_FACTION") then
		if (DUF_Settings[DUF_INDEX].player.StatusBar[3].trackRep) then
			DUF_XPBar_Update();
		end
		if (DUF_Settings[DUF_INDEX].player.StatusBar[6].trackRep) then
			DUF_HonorBar_Update();
		end
	elseif (event == "PLAYER_LEVEL_UP") then
		DUF_XPBar_Update();
	elseif (event == "GROUP_ROSTER_UPDATE" or event == "RAID_ROSTER_UPDATE") then
		DUF_Main_UpdatePartyMembers();
	elseif (event == "UNIT_PET") then
		if (not InCombatLockdown()) then -- Fizzlemizz: Comment: 5.0.4 change
			for i=1,4 do
				_G["DUF_PartyPetFrame"..i]:Hide();
			end
		end
		if (DUF_Settings[DUF_INDEX].hidepartyinraid) then
			if (IsInRaid()) then
				return;
			end
		end
	elseif (event == "UNIT_PET_EXPERIENCE") then
		DUF_PetXPBar_Update();
	elseif (event == "PLAYER_REGEN_DISABLED") then
		if (DUF_OPTIONS_VISIBLE) then
      			DUF_Options:Hide()
    		end
    	elseif (event == "UPDATE_SHAPESHIFT_FORM") then  
    		if not DUF_ISDRUID then return; end
    			DUF_DruidManaBar_Update_Display()
	elseif (event == "PLAYER_UNGHOST") then
		for unit, value in pairs(DUF_FRAME_DATA) do
			if (unit and not UnitIsDeadOrGhost(unit))then
			  DUF_Set_Portrait(unit)
			end
		end
	elseif (event == "PLAYER_TALENT_UPDATE" or event == "SPELLS_CHANGED") then
		if (InCombatLockdown()) then return; end
		DUF_DemonicBar_Update_Display()
  	else
  		DUF_Voice_Event(event, ...);
	end
end

function DUF_Main_OnLoad(self)
	self:RegisterEvent("PARTY_MEMBERS_CHANGED");
	self:RegisterEvent("GROUP_ROSTER_UPDATE");
	self:RegisterEvent("ROLE_CHANGED_INFORM");
	self:RegisterEvent("UNIT_COMBO_POINTS");		
	self:RegisterEvent("PLAYER_FLAGS_CHANGED");
	self:RegisterEvent("PLAYER_LEVEL_UP");
	self:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
	self:RegisterEvent("PLAYER_PVP_RANK_CHANGED");
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("PLAYER_TARGET_CHANGED");
	self:RegisterEvent("UNIT_TARGET");
	self:RegisterEvent("PLAYER_UPDATE_RESTING");
	self:RegisterEvent("PLAYER_XP_UPDATE");
	self:RegisterEvent("RAID_ROSTER_UPDATE");
--	self:RegisterEvent("UNIT_HAPPINESS"); -- Fizzlemizz: Change: Removed pet happiness
	self:RegisterEvent("UNIT_PET");
	self:RegisterEvent("UNIT_PET_EXPERIENCE");
	self:RegisterEvent("UPDATE_EXHAUSTION");
	self:RegisterEvent("UPDATE_FACTION");
	self:RegisterEvent("VOICE_START");
	self:RegisterEvent("VOICE_STOP");
	self:RegisterEvent("VOICE_SESSIONS_UPDATE");
	self:RegisterEvent("VOICE_STATUS_UPDATE");
	self:RegisterEvent("VOICE_LEFT_SESSION");
	self:RegisterEvent("VOICE_CHAT_ENABLED_UPDATE");
        self:RegisterEvent("UPDATE_SHAPESHIFT_FORM");
	self:RegisterEvent("PLAYER_UNGHOST");
	self:RegisterEvent("SPELLS_CHANGED");
	self:RegisterEvent("PLAYER_TALENT_UPDATE");
	self:RegisterUnitEvent("UNIT_POWER_FREQUENT", "player", "vehicle");
	self:RegisterEvent("UNIT_DISPLAYPOWER");
	DiscordLib_RegisterInitFunc(DUF_Initialize);
	SlashCmdList["DUF"] = DUF_Slash_Handler;
	SLASH_DUF1 = "/duf";
	SLASH_DUF2 = "/discordunitframes";
end

function DUF_Main_OnUpdate(self, elapsed)
	if (not DUF_INITIALIZED) then return; end
	local min,max = GetPetExperience();
	if (min ~= self.minpetxp or max ~= self.maxpetxp) then
		self.minpetxp = min;
		self.maxpetxp = max;
		DUF_PetXPBar_Update();
	end
end

function DUF_Main_UpdatePartyMembers()
--	local force_hide_party = DUF_Settings[DUF_INDEX].party.hide or (DUF_Settings[DUF_INDEX].hidepartyinraid and (IsInRaid() and GetNumGroupMembers() > 0))
	local force_hide_party = DUF_Settings[DUF_INDEX].party.hide or (DUF_Settings[DUF_INDEX].hidepartyinraid and (IsInRaid()))
	local force_hide_partypet = force_hide_party or DUF_Settings[DUF_INDEX].partypet.hide
	for i=1,4 do
		local frame = _G["DUF_PartyFrame"..i]
		DUF_SetFrameUnitWatch(frame, not force_hide_party)

		local frame = _G["DUF_PartyPetFrame"..i]
		DUF_SetFrameUnitWatch(frame, not force_hide_partypet)
	end
 	if ( InCombatLockdown() ) then
 		return
 	end
 	if (not DUF_Settings[DUF_INDEX].party.hide) then
 		if (DUF_Settings[DUF_INDEX].hidepartyinraid) then
 			if (IsInRaid()) then
			 	for i=1,4 do
			 		_G["DUF_PartyFrame"..i]:Hide();
			 		_G["DUF_PartyPetFrame"..i]:Hide();
			 	end
 			else
		 		for i=1, GetNumSubgroupMembers() do
		 			_G["DUF_PartyFrame"..i]:Show();
		 			if (DL_UnitName("partypet"..i) and UnitExists("partypet"..i) and (not DUF_Settings[DUF_INDEX].partypet.hide)) then
		 				_G["DUF_PartyPetFrame"..i]:Show();
		 			end
		 		end
 			end
 		end
	end
 	
end

function DUF_Options_LoadDefaultSettings(toggle)
	if (not DUF_DEFAULT_SETTINGS) then
		DL_Feedback(DUF_TEXT.NoDefaultSettings);
		return;
	end
	DUF_Settings[DUF_INDEX] = {nil};
	DL_Copy_Table(DUF_DEFAULT_SETTINGS, DUF_Settings[DUF_INDEX]);
	DUF_Settings[DUF_PLAYER_INDEX] = DUF_INDEX;
	if (not toggle) then
		DUF_Initialize_NewSettings();
		DUF_Initialize_AllFrames();
		DL_Feedback(DUF_TEXT.DefaultSettingsLoaded);
	end
end

function DUF_Options_LoadSettings(index, safe)
	if (not index) then
		index = DUF_LOADINDEX;
	end
	if (index == "" or (not index)) then
		return;
	end
	if (not DUF_Settings[index]) then
		DL_Feedback(DUF_TEXT.NoSettingsFound);
		return;
	end
	if (index == DUF_INDEX) then return; end
	DUF_Settings[DUF_PLAYER_INDEX] = index;
	DUF_INDEX = index;
	DUF_Initialize_NewSettings();
	if (safe) then
		ReloadUI();
	else
		DUF_Initialize_AllFrames();
		DL_Feedback(DUF_TEXT.SettingsLoaded);
	end
	if (DUF_Options) then
		DUF_MiscOptions_CurrentProfile:SetText(DUF_TEXT.CurrentProfile..":  "..DUF_INDEX);
		DUF_MiscOptions_LoadSettings_Setting:SetText("");
	end
end

function DUF_Options_SetUpdateSpeed()
	DUF_Settings[DUF_INDEX].updatespeed = 1 / DUF_Settings[DUF_INDEX].updatespeedbase;
end

function DUF_Slash_Handler(msg)
	local command, param;
	local index = string.find(msg, " ");
	if( index) then
		command = string.sub(msg, 1, (index - 1));
		param = string.sub(msg, (index + 1)  );
	else
		command = msg;
	end

	if InCombatLockdown() then
		message("You cannot configure Discord Unit Frames while in combat.") 
	else
		if (not DUF_Options) then
			DUF_Load_Options(0); 
		end
		if (DUF_Options:IsVisible()) then
			DUF_Options:Hide();
		else
			DUF_Options:Show();
		end
	end
end

function DUF_Init_DropDown(dropDown, unitFrame, unit)
	dropDown:SetParent(unitFrame);
	dropDown.unit = unit;
	dropDown.point = "TOPLEFT";
	dropDown.relativePoint = "TOPLEFT";
	DUF_FRAME_DATA[unit].upx = unitFrame:GetWidth();

end

function DUF_Uninit_DropDown(dropDown, unitFrame)
	dropDown:SetParent(unitFrame);
	dropDown.point = nil;
	dropDown.relativePoint = nil;
end

function DUF_Toggle_DefaultFrames()
	if (not DUF_INITIALIZED) then return; end
	if (not DUF_Settings[DUF_INDEX].player.showDefault) then
		PlayerFrame:Hide();
		DUF_Init_DropDown(PlayerFrameDropDown, DUF_PlayerFrame, "player");
	else
		PlayerFrame:Show();
		DUF_Uninit_DropDown(PlayerFrameDropDown, PlayerFrame);
	end
	if (DUF_Settings[DUF_INDEX].pet.showDefault) then
		if (DL_UnitName("pet")) then
			PetFrame:Show();
		end
		DUF_Uninit_DropDown(PetFrameDropDown, PetFrame);
	else
		PetFrame:Hide();
		DUF_Init_DropDown(PetFrameDropDown, DUF_PetFrame, "pet");
	end
	if (not DUF_Settings[DUF_INDEX].party.showDefault) then
		local partyframe;
		for i=1,4 do
			partyframe = _G["PartyMemberFrame"..i];
			partyframe:Hide();
			DUF_Init_DropDown(_G["PartyMemberFrame"..i.."DropDown"], _G["DUF_PartyFrame"..i], "party"..i);
		end
	else
--		for i = 1, GetNumPartyMembers() do
		for i = 1, GetNumSubgroupMembers() do
			_G["PartyMemberFrame"..i]:Show();
		end
		for i=1,4 do
			DUF_Uninit_DropDown(_G["PartyMemberFrame"..i.."DropDown"], "PartyMemberFrame"..i);
		end
	end
	if (not DUF_Settings[DUF_INDEX].partypet.showDefault) then
		local partyframe;
		for i=1,4 do
			partyframe = _G["PartyMemberFrame"..i.."PetFrame"];
			partyframe:Hide();
		end
	else
--		for i = 1, GetNumPartyMembers() do
		for i = 1, GetNumSubgroupMembers() do
			if (DL_UnitName("partypet"..i)) then
				_G["PartyMemberFrame"..i.."PetFrame"]:Show();
			end
		end
	end	
	if (not DUF_Settings[DUF_INDEX].target.showDefault) then
		TargetFrame:UnregisterEvent( "PLAYER_TARGET_CHANGED");
		DUF_Init_DropDown(TargetFrameDropDown, DUF_TargetFrame, "target");
	else
		if (DL_UnitName("target")) then
		end
		TargetFrame:RegisterEvent( "PLAYER_TARGET_CHANGED");
		DUF_Uninit_DropDown(TargetFrameDropDown, TargetFrame);
	end
end

function DUF_Toggle_ElementsLock()
	if (DUF_ELEMENTS_UNLOCKED) then
		DUF_ELEMENTS_UNLOCKED = nil;
		if (DUF_Options) then
			DUF_Options_ToggleElements:SetText(DUF_TEXT.UnlockElements);
		end
		if (not DUF_FRAMES_UNLOCKED) then
			if (GB_PlayerBar) then
				DUF_HIDING_CLICKBOXES = nil;
				if (not GB_Settings[GB_INDEX].hideClickboxes) then
					GB_PlayerClickbox:Show();
					if (DL_UnitName("pet")) then
						GB_Pet0Clickbox:Show();
					end
--					for i=1, GetNumPartyMembers() do
					for i=1, GetNumSubgroupMembers() do
						_G["GB_Party"..i.."Clickbox"]:Show();
						if (DL_UnitName("partypet"..i)) then
							_G["GB_Pet"..i.."Clickbox"]:Show();
						end
					end
					if (DL_UnitName("target")) then
						GB_TargetClickbox:Show();
					end
				end
			end
		end
	else
		DUF_ELEMENTS_UNLOCKED = 1;
		if (DUF_Options) then
			DUF_Options_ToggleElements:SetText(DUF_TEXT.LockElements);
		end
		if (GB_PlayerBar) then
			DUF_HIDING_CLICKBOXES = true;
			for _, frame in pairs(GB_CLICKBOXES) do
				_G[frame]:Hide();
			end
		end
	end
end

function DUF_Toggle_FramesLock()
	if (DUF_FRAMES_UNLOCKED) then
		DUF_FRAMES_UNLOCKED = nil;
		if (DUF_Options) then
			DUF_Options_ToggleFrames:SetText(DUF_TEXT.UnlockFrames);
		end
		if (not DUF_ELEMENTS_UNLOCKED) then
			if (GB_PlayerBar) then
				DUF_HIDING_CLICKBOXES = nil;
				if (not GB_Settings[GB_INDEX].hideClickboxes) then
					GB_PlayerClickbox:Show();
					if (DL_UnitName("pet")) then
						GB_Pet0Clickbox:Show();
					end
--					for i=1, GetNumPartyMembers() do
					for i=1, GetNumSubgroupMembers() do
						_G["GB_Party"..i.."Clickbox"]:Show();
						if (DL_UnitName("partypet"..i)) then
							_G["GB_Pet"..i.."Clickbox"]:Show();
						end
					end
					if (DL_UnitName("target")) then
						GB_TargetClickbox:Show();
					end
				end
			end
		end
	else
		DUF_FRAMES_UNLOCKED = 1;
		if (DUF_Options) then
			DUF_Options_ToggleFrames:SetText(DUF_TEXT.LockFrames);
		end
		if (GB_PlayerBar) then
			DUF_HIDING_CLICKBOXES = true;
			for _, frame in pairs(GB_CLICKBOXES) do
				_G[frame]:Hide();
			end
		end
	end
end

function DUF_Format_TimeLeft(timeLeft) -- Fizzlemizz: PVP Countdown Timer
	local timeText;
	if (timeLeft > 60) then
		local seconds = timeLeft - math.floor(timeLeft / 60) * 60;
		if (seconds < 10) then
			timeText = math.floor(timeLeft / 60)..":0"..seconds;
		else
			timeText = math.floor(timeLeft / 60)..":"..seconds;
		end
	else
		if (timeLeft < 10) then
			timeText = "0" .. timeLeft .. "s";
		else
			timeText = "" .. timeLeft .. "s";
		end
	end
	return timeText;
end

function DUF_SetVisibility(frame, unitClass, hideSetting)
	local _, uc = UnitClass("player");
	if (unitClass == uc or DUF_OPTIONS_VISIBLE) then
		if (not hideSetting) then
			if (not frame:IsVisible()) then
				frame:Show();
			end
		else
			if (frame:IsVisible()) then
				frame:Hide();
			end
		end
		if (frame:GetName() == "DUF_PlayerFrame_PalyPowerFrame") then
			local palyRune;
			if (DUF_OPTIONS_VISIBLE) then
				for i=1,3 do
					palyRune = _G[frame:GetName() .. "_Rune_" .. i];
					if (hideSetting) then
						palyRune.DUF_deactivate:Play()
					else
						palyRune.DUF_activate:Play()
					end
				end
			else
				DUF_PaladinPowerBar_Update(frame)
			end
		elseif (frame:GetName() == "DUF_PlayerFrame_WarlockPowerFrame") then
			if (DUF_OPTIONS_VISIBLE) then
				if (not DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame:IsVisible()) then
					DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame.OpShow = true;
					DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame:Show();
				end
			else
				if (DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame.OpShow) then
					DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame.OpShow = nil;
					DUF_PlayerFrame_WarlockPowerFrame_ShardBarFrame:Hide();
				end
			end
		end
	else
		if (frame:IsVisible()) then
			frame:Hide();
		end
	end
end

