function DUF_Aura_timeLeft(self, framename,timeLeft, settings)
	if (not DUF_INITIALIZED) then return; end
	local frame = _G[framename];
	if (DUF_Settings[DUF_INDEX].limitdurationupdates) then 
		local timeleft = math.floor(timeLeft)
		if (timeleft == 0) then
			frame.timeleft = 0;
		else
			if (not frame.timeleft or frame.timeleft < timeleft) then
				frame.timeleft = timeleft;
			end
		end
		if (frame.timeleft and timeleft and frame.timeleft - timeleft < 1) then return; end
		frame.timeleft = timeleft;
	end		
	if (frame.flashing) then
		if (frame.timer < 0) then
			frame.timer = .5;
			if (frame.direction) then
				frame.direction = nil;
			else
				frame.direction = true;
			end
		end
		if (frame.direction) then
			frame:SetAlpha(frame.timer + .5);
		else
			frame:SetAlpha(1 - frame.timer);
		end
	end
	local buffText = _G[framename.."_Text"];
 	if (timeLeft and timeLeft > 0) then
		timeLeft = math.floor(timeLeft);
		if (settings.altformat) then
			if (timeLeft > 60) then
				local hours = ""
				if (timeLeft >= 3600) then
					local numHours = math.floor(timeLeft / 3600)
					hours = tostring(numHours) .. ":"
					timeLeft = timeLeft - (numHours * 3600)
				end
				local minutes = math.floor(timeLeft / 60);
				local seconds = timeLeft - math.floor(timeLeft / 60) * 60;
				local minspacer = ""
				local secspacer = ":"
				if (minutes < 10) then
					minspacer = "0"
				end
				if (seconds < 10) then
					secspacer = ":0"
--					buffText:SetText(hours .. math.floor(timeLeft / 60)..":0"..seconds);
--				else
--					buffText:SetText(hours .. math.floor(timeLeft / 60)..":"..seconds);
				end
				buffText:SetText(hours .. minspacer .. minutes .. secspacer .. seconds);

			else
				if (timeLeft < 10) then
					buffText:SetText("0:0" .. timeLeft .. " s");
				else
					buffText:SetText("0:" .. timeLeft .. " s");
				end
			end
		else
			buffText:SetFormattedText(SecondsToTimeAbbrev(timeLeft));
		-- Fizzlemiz: Change: replaced 2 lines below with line above to fix standard formatting of duration timer text
		--	securecall("AuraButton_UpdateDuration", self, self.timeLeft);
		--	self.timeLeft = max(self.timeLeft - elapsed, 0);
		end			
		if ((not untilCancelled) and timeLeft < 61 and timeLeft > 0) then
			if (not self.flashing) then
				frame.flashing = true;
				frame.timer = .5;
				frame.direction = 1;
			end
		elseif (frame.flashing) then
			if (not settings.flash) then
				frame.flashing = nil;
				frame:SetAlpha(1);
			end
		end
	elseif (DUF_OPTIONS_VISIBLE) then
		if (settings.altformat) then
			buffText:SetText("99:99");
		else
			buffText:SetText("99 m");
		end
	else
		buffText:SetText("");
	end
	
end

function DUF_Buff_OnClick(self, button)
	if InCombatLockdown() then return; end
	if (self.playerbuff and button == "RightButton") then
		local buffID = self:GetID();
		if (DUF_Settings[DUF_INDEX].player.Buffs.reverse) then
			buffID = DL_UNIT_BUFFCOUNT + 1 - buffID;
		end
		CancelUnitBuff("player", buffID, "HELPFUL");
	end
end

function DUF_Buff_OnEnter(self)
	local buffID = self:GetID();
	if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self:GetParent():GetParent().unit].index].Buffs.reverse) then
		buffID = DL_UNIT_BUFFCOUNT + 1 - buffID;
	end
	if (self:GetRight() > UIParent:GetRight() / 2) then
		GameTooltip:SetOwner(self, "ANCHOR_LEFT");
	else
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
	end
	if (self:GetParent():GetParent().unit=="player") then
		GameTooltip:SetUnitBuff("player", buffID, "HELPFUL");
	else
		GameTooltip:SetUnitBuff(self:GetParent():GetParent().unit, buffID);
	end
end


function DUF_Buff_OnLeave()
	GameTooltip:Hide();
end

function DUF_Debuff_OnClick(button)
	if (this.playerbuff and button == "RightButton") then
		local buffID = this:GetID();
		if (DUF_Settings[DUF_INDEX].player.Debuffs.reverse) then
			buffID = DL_UNIT_BUFFCOUNT + 1 - buffID;
		end
		CancelUnitBuff("player", buffID, "HARMFUL");
	end
end

function DUF_Debuff_OnEnter(self)
	local buffID = self:GetID();
	if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self:GetParent():GetParent().unit].index].Debuffs.reverse) then
		buffID = DL_UNIT_BUFFCOUNT + 1 - buffID;
	end
	if (self:GetRight() > UIParent:GetRight() / 2) then
		GameTooltip:SetOwner(self, "ANCHOR_LEFT");
	else
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
	end
	if (self:GetParent():GetParent().unit=="player") then
		GameTooltip:SetUnitDebuff("player", buffID, "HARMFUL");
	else
		GameTooltip:SetUnitDebuff(self:GetParent():GetParent().unit, buffID);
	end
end

function DUF_Debuff_OnLeave()
	GameTooltip:Hide();
end

function DUF_UnitFrame_OnDragStart(self)
	if (DUF_FRAMES_UNLOCKED) then
		self:StartMoving();
		self.moving = true;
	end
end

function DUF_UnitFrame_OnDragStop(self)
	if (DUF_FRAMES_UNLOCKED) then
		self:StopMovingOrSizing();
		self.moving = nil;
		local frameindex = DUF_FRAME_DATA[self.unit].index;
		local xoffset, yoffset = DL_Get_Offsets(self, UIParent, "TOPLEFT", "TOPLEFT");
		DUF_Settings[DUF_INDEX][frameindex].xos[self:GetID()] = xoffset;
		DUF_Settings[DUF_INDEX][frameindex].yos[self:GetID()] = yoffset;
		self:ClearAllPoints();
		self:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", xoffset, yoffset);
	end
end

function DUF_UnitFrame_OnEnter(self)
	local unit = self.unit;
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index];
	if (settings.usemouseovercolor) then
		_G[self:GetName().."_Background"]:SetBackdropColor(settings.mouseovercolor.r, settings.mouseovercolor.g, settings.mouseovercolor.b, settings.bgalpha);
	end

	if (settings.mouseovergroup) then
		local unitFrame = self;
		local unitFrameName = unitFrame:GetName();
		local element;
		for index, value in pairs(DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index]) do
			if (type(value) == "table") then
				if (index == "StatusBar") then
					for i = 1,6 do
						if (value[i]) then
							if (value[i].mouseovergroup == settings.mouseovergroup) then
								if (value[i].mouseover) then
									_G[unitFrameName..DUF_Get_ElementName(index, i)]:Show();
								end
								if (value[i].usemouseovercolor) then
									_G[unitFrameName..DUF_Get_ElementName(index, i).."_Background"]:SetBackdropColor(value[i].mouseovercolor.r, value[i].mouseovercolor.g, value[i].mouseovercolor.b, value[i].bgalpha);
								end
							end
						end
					end
				elseif (index == "TextBox") then
					for i = 1,10 do
						if (value[i].mouseovergroup == settings.mouseovergroup) then
							if (value[i].mouseover) then
								_G[unitFrameName..DUF_Get_ElementName(index, i)]:Show();
							end
							if (value[i].usemouseovercolor) then
								_G[unitFrameName..DUF_Get_ElementName(index, i).."_Background"]:SetBackdropColor(value[i].mouseovercolor.r, value[i].mouseovercolor.g, value[i].mouseovercolor.b, value[i].bgalpha);
							end
						end
					end
				else
					if (value.mouseovergroup == settings.mouseovergroup) then
						if (value.mouseover) then
							_G[unitFrameName..DUF_Get_ElementName(index, i)]:Show();
						end
						if (value.usemouseovercolor) then
							_G[unitFrameName..DUF_Get_ElementName(index).."_Background"]:SetBackdropColor(value.mouseovercolor.r, value.mouseovercolor.g, value.mouseovercolor.b, value.bgalpha);
						end
					end
				end
			end
		end
	end

	if (settings.disabletooltip) then
		return;
	end
	if (unit and UnitName(unit)) then
		if (settings.usecustomtooltip) then
			local text = settings.customtooltip;
			if (text) then
				for var, value in pairs(DUF_VARIABLE_FUNCTIONS) do
					if (string.find(text, var)) then
						text = value.func(text, unit, self); --Fizzlemizz: Fixed
					end
				end
				GameTooltip_SetDefaultAnchor(GameTooltip, self)	
				GameTooltip:SetText(text, 1, 1, 1, 1, 1);
				GameTooltip:Show();
			end
		else
			UnitFrame_OnEnter(self);
		end
	end
end

function DUF_UnitFrame_OnEvent(self, event, ...)
  	local arg1 = ...
	if (not DUF_INITIALIZED) then return; end
	if (not self:IsVisible()) then return; end
	if (event == DUF_UNIT_CHANGED_EVENTS[self.unit]) then
		DUF_UnitFrame_OnShow(self) 
	elseif (event == "RAID_TARGET_UPDATE") then
		DUF_Set_RaceIcon(self.unit)
		DUF_Set_RankIcon(self.unit)
	end
	if (arg1 ~= self.unit) then return; end

	if (event == "UNIT_AURA") then
		self.updateauras = true;
	elseif (event == "UNIT_NAME_UPDATE") then
		DUF_Set_ClassIcon(self.unit);
		DUF_Set_RaceIcon(self.unit);
	elseif (event == "UNIT_MODEL_CHANGED") or (event == "UNIT_PORTRAIT_UPDATE") then
		DUF_Set_Portrait(self.unit)
	elseif (event == "UNIT_INVENTORY_CHANGED") then
		self.updatetempenchants = true;
	end
end

function DUF_UnitFrame_OnHide(self)
	if (self.unit == "target") then
		PlaySound("INTERFACESOUND_LOSTTARGETUNIT");
	end
	if (self.moving) then
		DUF_UnitFrame_OnDragStop(self);
	end
end

function DUF_UnitFrame_OnLeave(self)
	local unit = self.unit;
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index];

	if (settings.usemouseovercolor) then
		_G[self:GetName().."_Background"]:SetBackdropColor(settings.bgcolor.r, settings.bgcolor.g, settings.bgcolor.b, settings.bgalpha);
	end

	if (settings.mouseovergroup) then
		local unitFrame = self;
		local unitFrameName = unitFrame:GetName();
		local element;

		for index, value in pairs(DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index]) do
			if (type(value) == "table") then
				if (index == "StatusBar") then
					for i = 1,6 do
						if (value[i]) then
							if (value[i].mouseovergroup == settings.mouseovergroup) then
								if (value[i].mouseover) then
									_G[unitFrameName..DUF_Get_ElementName(index, i)]:Hide();
								end
								if (value[i].usemouseovercolor) then
									_G[unitFrameName..DUF_Get_ElementName(index, i).."_Background"]:SetBackdropColor(value[i].bgcolor.r, value[i].bgcolor.g, value[i].bgcolor.b, value[i].bgalpha);
								end
							end
						end
					end
				elseif (index == "TextBox") then
					for i = 1,10 do
						if (value[i].mouseovergroup == settings.mouseovergroup) then
							if (value[i].mouseover) then
								_G[unitFrameName..DUF_Get_ElementName(index, i)]:Hide();
							end
							if (value[i].usemouseovercolor) then
								_G[unitFrameName..DUF_Get_ElementName(index, i).."_Background"]:SetBackdropColor(value[i].bgcolor.r, value[i].bgcolor.g, value[i].bgcolor.b, value[i].bgalpha);
							end
						end
					end
				else
					if (value.mouseovergroup == settings.mouseovergroup) then
						if (value.mouseover) then
							_G[unitFrameName..DUF_Get_ElementName(index, i)]:Hide();
						end
						if (value.usemouseovercolor) then
							_G[unitFrameName..DUF_Get_ElementName(index).."_Background"]:SetBackdropColor(value.bgcolor.r, value.bgcolor.g, value.bgcolor.b, value.bgalpha);
						end
					end
				end
			end
		end
	end
	if (UnitName(self.unit)) then
		UnitFrame_OnLeave(self);
	end
end

function DUF_UnitFrame_OnLoad(self, unit)
	self.unit = unit
	self:SetAttribute("unit", unit)
	self.menu = function() DUF_UnitPopup_ShowMenu(unit) end
	self:RegisterForDrag("LeftButton", "RightButton");
	self:RegisterForClicks("AnyDown")
	ClickCastFrames = ClickCastFrames or {}
	ClickCastFrames[self] = true
	self:RegisterEvent("UNIT_AURA");
	self:RegisterEvent("UNIT_COMBAT");
	self:RegisterEvent("UNIT_NAME_UPDATE");
	self:RegisterEvent("UNIT_PORTRAIT_UPDATE");
	self:RegisterEvent("UNIT_MODEL_CHANGED");
	self:RegisterEvent("RAID_TARGET_UPDATE");
	self:RegisterEvent("COMSAT_START");
	self:RegisterEvent("COMSAT_STOP");
	self:RegisterEvent("COMSAT_VOICE_STATUS_UPDATE");
	self:RegisterEvent("UNIT_INVENTORY_CHANGED");
	if (DUF_UNIT_CHANGED_EVENTS[self.unit]) then
		self:RegisterEvent(DUF_UNIT_CHANGED_EVENTS[self.unit])
	end
end

function DUF_UnitFrame_OnShow(self)
	if (not DUF_INITIALIZED) then return; end
	if (not DL_UnitName(self.unit)) then return; end
	DUF_HealthBar_Update(self);
	DUF_LootIcon_Update(self.unit);
	DUF_LeaderIcon_Update(self.unit);
	DUF_PVPIcon_Update(self.unit);
	DUF_StatusIcon_Update(self.unit);
	DUF_UnitFrame_UpdateBuffs(self, self.unit);
	DUF_UnitFrame_UpdateDebuffs(self, self.unit);
	DUF_UnitFrame_UpdateTempEnchants(self);
	DUF_DemonicBar_Update(self);
	DUF_Set_ClassIcon(self.unit);
	DUF_Set_Portrait(self.unit);
	DUF_Set_RaceIcon(self.unit);
	DUF_Set_RankIcon(self.unit);
	DUF_RoleIcon_Update(self.unit);

	local children = { self:GetChildren() }
	for _, child in ipairs(children) do
		DUF_CallMethod(child, DUF_Element_OnShow, self)
	end

	local background = _G[self:GetName().."_Background"];
	if (not background) then return end
	local r, g, b;
	local context = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].context;
	local bgcontext = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bgcontext;
	local bordercontext = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bordercontext;
	if (context == 1 or bgcontext == 1) then
		r, g, b = DUF_Get_DifficultyColor(self.unit, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bgcolor);
	elseif (context == 2 or bgcontext == 2) then
		r, g, b = DUF_Get_ReactionColor(self.unit, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bgcolor);
	elseif (context == 3 or bgcontext == 3) then
		r, g, b = DUF_Get_ClassColor(self.unit, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bgcolor);
	else
		r, g, b = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bgcolor.r, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bgcolor.g, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bgcolor.b;
	end
	self.basecolor = {};
	self.basecolor.r = r;
	self.basecolor.g = g;
	self.basecolor.b = b;
	background:SetBackdropColor(r, g, b, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bgalpha);

	if (bordercontext == 1) then
		r, g, b = DUF_Get_DifficultyColor(self.unit, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bordercolor);
	elseif (bordercontext == 2) then
		r, g, b = DUF_Get_ReactionColor(self.unit, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bordercolor);
	elseif (bordercontext == 3) then
		r, g, b = DUF_Get_ClassColor(self.unit, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bordercolor);
	else
		r, g, b = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bordercolor.r, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bordercolor.g, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].bordercolor.b;
	end
	background:SetBackdropBorderColor(r, g, b, DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index].borderalpha);
	self.mana = nil;
	self.health = nil;
	self.manatarget = nil;
	self.healthtarget = nil;
	self.demopower = nil;
	if (self.unit == "target") then
		if ( UnitIsEnemy("target", "player") ) then
			PlaySound("igCreatureAggroSelect");
		elseif ( UnitIsFriend("player", "target") ) then
			PlaySound("igCharacterNPCSelect");
		else
			PlaySound("igCreatureNeutralSelect");
		end
	end
	local frame = DUF_FRAME_DATA[self.unit].frame
	local tb
	if (self.unit == "player") then
		tb = DUF_NUM_PLAYER_TEXTBOXES;
	else
		tb = DUF_NUM_OTHERS_TEXTBOXES;
	end
	for i=1,tb do
		self = _G[frame.."_TextBox_"..i];
		DUF_TextBox_Update(self);
	end
end

function DL_FocusHide(target)
	if (not DUF_OPTIONS_VISIBLE) then
		FocusFrame:Hide();
	end
end

hooksecurefunc( "FocusUnit", DL_FocusHide)

function DUF_AnimatePortrait(self, elapsed, sequence, alpha)
	local frame = _G[DUF_FRAME_DATA[self.unit].frame .. "_Portrait"];
	frame.seqtime = frame.seqtime + (elapsed * 1000);
	frame:SetAlpha(alpha)
	frame:SetSequenceTime(sequence, frame.seqtime);
end

function DUF_UnitFrame_OnUpdate(self, elapsed)
	if (not DUF_INITIALIZED) then return; end
	local targettarget, focus;
	local FRAME_SETTINGS = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[self.unit].index]
	local FRAME_NAME = self:GetName()
	if (not self.timer) then self.timer = DUF_Settings[DUF_INDEX].updatespeed; end
	self.timer = self.timer - elapsed;
--Fizzlemizz; Start onupdate animation code	
	local use3d, use3dface = DUF_Get3D(self.unit)
	if (self:IsVisible() and use3d) then
		if (not use3dface) then
			if (UnitIsDead(self.unit)) then
				DUF_AnimatePortrait(self, elapsed, self.deathseq, 1)
			elseif (self.unit == "player" and UnitIsAFK(self.unit)) then
				DUF_AnimatePortrait(self, elapsed, 96, 1);
			elseif (UnitIsGhost(self.unit)) then	
				DUF_AnimatePortrait(self, elapsed, 5, .5)
			end
		end
	end
--Fizzlemizz; End onupdate animation code	
	if (self.timer < 0) then
		self.timer = DUF_Settings[DUF_INDEX].updatespeed;
		local health = UnitHealth(self.unit);
		local healthmax = UnitHealthMax(self.unit);
		local healthtarget = UnitHealth(self.unit.."target");
		local healthmaxtarget = UnitHealthMax(self.unit.."target");
--		if (self.unit == "player") then
			local demopower = UnitPower("player", SPELL_POWER_DEMONIC_FURY);
			local demopowermax = UnitPowerMax("player", SPELL_POWER_DEMONIC_FURY);
--		end

		local manatarget = UnitPower(self.unit.."target");
		local manamaxtarget = UnitPowerMax(self.unit.."target");
		local targetname = UnitName(self.unit.."target");
		local mana = UnitPower(self.unit);
		local manamax = UnitPowerMax(self.unit);
		local manatype = UnitPowerType(self.unit);
		local manatypetarget = UnitPowerType(self.unit.."target");
		local status = 0;
--		local leader = UnitIsPartyLeader(self.unit);
		local leader = UnitIsGroupLeader(self.unit);
--		local inParty = GetNumPartyMembers() + GetNumRaidMembers();
--		local inParty = GetNumPartyMembers() + GetNumGroupMembers();
		local inParty = GetNumGroupMembers() + GetNumSubgroupMembers();
		if (inParty == 0) then
			leader = nil;
		end
		local pvp = UnitIsPVP(self.unit);
		local pvpfree = UnitIsPVPFreeForAll(self.unit);
		local _,loot = GetLootMethod();
		local role = UnitGroupRolesAssigned(self.unit);
		local level = UnitLevel(self.unit);
		local reaction = DUF_Get_Reaction(self.unit);
		local optionsvisible = DUF_OPTIONS_VISIBLE;
		local targetIndex
		if (self.unit == "target" or self.unit == "targettarget" or self.unit == "focus") then
			targetIndex = GetRaidTargetIndex(self.unit)
		else
			targetIndex = GetRaidTargetIndex(self.unit.."target")
		end
		local cisChanneling = false;
		local cspell, crank, cdisplayName, cicon, cstartTime, cendTime, cisTradeSkill = UnitCastingInfo(self.unit);
		if (cspell == nil) then
			cisChanneling = true;
			cspell, crank, cdisplayName, cicon, cstartTime, cendTime, cisTradeSkill = UnitChannelInfo(self.unit);
		end;
		if ((not self.lastmana) or mana > self.lastmana) then self.lastmana = mana; end
		if ((not self.lasthealth) or health > self.lasthealth) then self.lasthealth = health; end

		if (targetIndex ~= self.targetIndex) then
			self.targetIndex = targetIndex
			if (targetIndex) then
				if (self.targetIcon == 1) then
					_G[FRAME_NAME.."_RankIcon"]:SetAlpha(FRAME_SETTINGS.alpha)
					SetRaidTargetIconTexture(_G[FRAME_NAME.."_RankIcon_Texture"], targetIndex)
				elseif (self.targetIcon == 2) then
					_G[FRAME_NAME.."_RaceIcon"]:SetAlpha(FRAME_SETTINGS.alpha)
					SetRaidTargetIconTexture(_G[FRAME_NAME.."_RaceIcon_Texture"], targetIndex)
				elseif (self.targetIcon == 3) then
					_G[FRAME_NAME.."_RankIcon"]:SetAlpha(FRAME_SETTINGS.alpha)
					_G[FRAME_NAME.."_RaceIcon"]:SetAlpha(FRAME_SETTINGS.alpha)
					SetRaidTargetIconTexture(_G[FRAME_NAME.."_RankIcon_Texture"], targetIndex)
					SetRaidTargetIconTexture(_G[FRAME_NAME.."_RaceIcon_Texture"], targetIndex)
				end
			else
				if (self.targetIcon == 1) then
					_G[FRAME_NAME.."_RankIcon"]:SetAlpha(0)
				elseif (self.targetIcon == 2) then
					_G[FRAME_NAME.."_RaceIcon"]:SetAlpha(0)
				elseif (self.targetIcon == 3) then
					_G[FRAME_NAME.."_RankIcon"]:SetAlpha(0)
					_G[FRAME_NAME.."_RaceIcon"]:SetAlpha(0)
				end
			end
		end
		if ((not inParty) or inParty == 0) then
			loot = nil;
		end
		local rank = UnitPVPRank(self.unit);
		if (health <= 0 or UnitIsGhost(self.unit)) then
			status = 1;
		elseif (self.unit == "player" and DL_ATTACKING) then
			status = 2;
		elseif (self.unit == "player" and DL_INCOMBAT) then
			status = 2;
		elseif (UnitAffectingCombat(self.unit)) then
			status = 2;
		elseif (self.unit == "player" and IsResting()) then
			status = 3;
		end

		if (reaction ~= self.reaction) then
			self.reaction = reaction;
			if (FRAME_SETTINGS.context == 2 or FRAME_SETTINGS.bgcontext == 2) then
				local r, g, b = DUF_Get_ReactionColor(self.unit, self.basecolor);
				_G[FRAME_NAME.."_Background"]:SetBackdropColor(r, g, b, FRAME_SETTINGS.bgalpha);
			end
			if (FRAME_SETTINGS.bordercontext == 2) then
				local r, g, b = DUF_Get_ReactionColor(self.unit, FRAME_SETTINGS.bordercolor);
				_G[FRAME_NAME.."_Background"]:SetBackdropBorderColor(r, g, b, FRAME_SETTINGS.borderalpha);
			end
		end
		if (self.health ~= health or self.healthmax ~= healthmax) then
			self.health = health;
			self.healthmax = healthmax;
			DUF_HealthBar_Update(self);
			if (FRAME_SETTINGS.context == 4 or FRAME_SETTINGS.bgcontext == 4) then
				local r, g, b = DUF_Get_HealthColor(self.unit, self.basecolor);
				_G[FRAME_NAME.."_Background"]:SetBackdropColor(r, g, b, FRAME_SETTINGS.bgalpha);
			end
			if (FRAME_SETTINGS.bordercontext == 4) then
				local r, g, b = DUF_Get_HealthColor(self.unit, FRAME_SETTINGS.bordercolor);
				_G[FRAME_NAME.."_Background"]:SetBackdropBorderColor(r, g, b, FRAME_SETTINGS.borderalpha);
			end
		end

		if (self.demopower ~= demopower or self.demopowermax ~= demopowermax) then
			self.demopower = demopower;
			self.demopowermax = demopowermax;
			DUF_DemonicBar_Update(self);
--			if (FRAME_SETTINGS.context == 4 or FRAME_SETTINGS.bgcontext == 4) then
--				local r, g, b = DUF_Get_HealthColor(self.unit, self.basecolor);
--				_G[FRAME_NAME.."_Background"]:SetBackdropColor(r, g, b, FRAME_SETTINGS.bgalpha);
--			end
--			if (FRAME_SETTINGS.bordercontext == 4) then
--				local r, g, b = DUF_Get_HealthColor(self.unit, FRAME_SETTINGS.bordercolor);
--				_G[FRAME_NAME.."_Background"]:SetBackdropBorderColor(r, g, b, FRAME_SETTINGS.borderalpha);
--			end
		end
		if (DUF_ISDRUID and DUF_ISSHAPESHIFTED	and self.unit == "player" and (self.druidmana ~= UnitPower(self.unit, SPELL_POWER_MANA) or self.druidmanamax ~= UnitPowerMax(self.unit, SPELL_POWER_MANA))) then 
			self.druidmana = UnitPower(self.unit, SPELL_POWER_MANA); 
			self.druidmanamax = UnitPowerMax(self.unit, SPELL_POWER_MANA);
			DUF_DruidManaBar_Update(self);
		end
		if (self.mana ~= mana or self.manamax ~= manamax) then
			self.mana = mana;
			self.manamax = manamax;
			DUF_ManaBar_Update(self);
			if (FRAME_SETTINGS.context == 5 or FRAME_SETTINGS.bgcontext == 5) then
				local r, g, b = DUF_Get_ManaColor(self.unit, self.basecolor);
				_G[FRAME_NAME.."_Background"]:SetBackdropColor(r, g, b, FRAME_SETTINGS.bgalpha);
			end
			if (FRAME_SETTINGS.bordercontext == 5) then
				local r, g, b = DUF_Get_ManaColor(self.unit, FRAME_SETTINGS.bordercolor);
				_G[FRAME_NAME.."_Background"]:SetBackdropBorderColor(r, g, b, FRAME_SETTINGS.borderalpha);
			end
			for i=1,10 do
				if (FRAME_SETTINGS.TextBox[i].hideifnomana) then
					if ((not self.mana) or (not self.manamax) or self.manamax == 0) then
						if (DUF_OPTIONS_VISIBLE and (not FRAME_SETTINGS.TextBox[i].hide) and (not FRAME_SETTINGS.TextBox[i].mouseover)) then
							_G[FRAME_NAME.."_TextBox_"..i]:SetAlpha(FRAME_SETTINGS.TextBox[i].alpha)
						else
							_G[FRAME_NAME.."_TextBox_"..i]:SetAlpha(0);
						end
					elseif ((not FRAME_SETTINGS.TextBox[i].hide) and (not FRAME_SETTINGS.TextBox[i].mouseover)) then
						_G[FRAME_NAME.."_TextBox_"..i]:SetAlpha(FRAME_SETTINGS.TextBox[i].alpha);
					end
				end
			end
		end
		if (self.cast ~= nil or cspell ~= nil) then
			self.cast = cspell;
			self.castrank = crank;
			self.castdisplayName = cdisplayName;
			self.casticon = cicon;
			self.caststartTime = cstartTime;
			self.castendTime = cendTime;
			self.castisTradeSkill = cisTradeSkill;
			self.castisChanneling = cisChanneling;
			DUF_CastBar_Update(self);
		end

		if (self.status ~= status or self.optionsvisible ~= optionsvisible) then
			self.status = status;
			DUF_StatusIcon_Update(self.unit);
		end
		if (leader ~= self.leader or self.optionsvisible ~= optionsvisible) then
			self.leader = leader;
			DUF_LeaderIcon_Update(self.unit);
		end
		if (self.pvp ~= pvp or self.pvpfree ~= pvpfree or self.optionsvisible ~= optionsvisible) then
			self.pvp = pvp;
			self.pvpfree = pvpfree;
			DUF_PVPIcon_Update(self.unit);
			if (self.unit == "player") then
				if (self.pvp or self.pvpfree) then
					PlaySound("igPVPUpdate");
				end
			end
		end
		if (self.loot ~= loot or self.optionsvisible ~= optionsvisible) then
			self.loot = loot;
			DUF_LootIcon_Update(self.unit);
		end
		if (self.role ~= role or self.optionsvisible ~= optionsvisible) then
			self.role = role;
			DUF_RoleIcon_Update(self.unit);
			local frame = DUF_FRAME_DATA[self.unit].frame;
			for i=1,10 do
				local tBox = _G[frame.."_TextBox_"..i];
				DUF_TextBox_Update(tBox);
			end
		end
		if (self.rank ~= rank or self.optionsvisible ~= optionsvisible) then
			self.rank = rank;
			DUF_Set_RankIcon(self.unit);
		end
		if (self.healthtarget ~= healthtarget or self.healthmaxtarget ~= healthmaxtarget) then
			self.healthtarget = healthtarget;
			self.healthmaxtarget = healthmaxtarget;
			DUF_TargetHealthBar_Update(self);
		end
		if (self.manatarget ~= manatarget or self.manamaxtarget ~= manamaxtarget) then
			self.manatarget = manatarget;
			self.manamaxtarget = manamaxtarget;
			DUF_TargetManaBar_Update(self);
		end
		if (self.manatype ~= manatype) then
			self.manatype = manatype;
			DUF_ManaBar_UpdateType(self);
		end
		if (self.manatypetarget ~= manatypetarget) then
			self.manatypetarget = manatypetarget;
			DUF_TargetManaBar_UpdateType(self);
		end
		if (self.unit == "player" and (self.updatetempenchants or _G[FRAME_NAME.."_TempEnchants"].tempenchantcount)) then
			self.updatetempenchants = false;
			DUF_UnitFrame_UpdateTempEnchants(self);
		end
		if ((self.updateauras) or (_G[FRAME_NAME.."_Buffs"].buffcount and _G[FRAME_NAME.."_Buffs"].buffcount > 0) or (_G[FRAME_NAME.."_Debuffs"].buffcount and _G[FRAME_NAME.."_Debuffs"].buffcount > 0)) then
			self.updateauras = nil;
			DUF_UnitFrame_UpdateBuffs(self, self.unit);
			DUF_UnitFrame_UpdateDebuffs(self, self.unit);
		end
		if (self.targetname ~= targetname) then
			self.targetname = targetname;
			local textbox;
			for i=1,10 do
				textbox = _G[FRAME_NAME.."_TextBox_"..i];
				if (textbox.checkname) then
					if (targetname and (not FRAME_SETTINGS.TextBox[i].hide) and (not FRAME_SETTINGS.TextBox[i].mouseover)) then
						textbox:SetAlpha(FRAME_SETTINGS.TextBox[i].alpha);
					elseif (not DUF_OPTIONS_VISIBLE) then
						textbox:SetAlpha(0);
					end
				end
			end
		end
		if (self.unit == "targettarget") then
			targettarget = true;
			for i=1,10 do
				self = _G["DUF_TargetOfTargetFrame_TextBox_"..i];
				DUF_TextBox_Update(self);
			end
			self = DUF_TargetOfTargetFrame;
			DUF_UnitFrame_UpdateBuffs(self, "targettarget");
			DUF_UnitFrame_UpdateDebuffs(self, "targettarget");
		end
		if (self.unit == "focus") then
			focus = true;
			local oldself = self;
			for i=1,10 do
				self = _G["DUF_FocusFrame_TextBox_"..i];
				DUF_TextBox_Update(self);
			end
			self = DUF_FocusFrame;
			DUF_UnitFrame_UpdateBuffs(self, "focus");
			DUF_UnitFrame_UpdateDebuffs(self, "focus");
			self = oldself;
		end
		self.optionsvisible = optionsvisible;

		if (targettarget) then
			self = DUF_TargetOfTargetFrame;
		end
		if (focus) then
			self = DUF_FocusFrame;
		end

		if (self.lastmanaalpha and self.lastmanaalpha > 0) then
			_G[FRAME_NAME.."_ManaBar_Bar2"]:SetAlpha(self.lastmanaalpha);
			self.lastmanaalpha = self.lastmanaalpha - elapsed;
		end
		if (self.lasthealthalpha and self.lasthealthalpha > 0) then
			_G[FRAME_NAME.."_HealthBar_Bar2"]:SetAlpha(self.lasthealthalpha);
			self.lasthealthalpha = self.lasthealthalpha - elapsed;
		end
		if (FRAME_SETTINGS.StatusBar[1].incombat or FRAME_SETTINGS.StatusBar[1].healthupdating or FRAME_SETTINGS.StatusBar[1].manaupdating) then
			local show;
			if (FRAME_SETTINGS.StatusBar[1].incombat and self.status == 2) then
				show = 1;
			end
			if (self.health and self.healthmax) then
				if (FRAME_SETTINGS.StatusBar[1].healthupdating and self.health < self.healthmax) then
					show = 1;
				end
			end
			if (self.mana and self.manamax and FRAME_SETTINGS.StatusBar[1].manaupdating) then
				local _, class = UnitClass(self.unit);
				if (class == "WARRIOR") then
					if (self.mana > 0) then
						show = 1;
					end
				else
					if (self.mana < self.manamax) then
						show = 1;
					end
				end
			end
			if (show) then
				_G[FRAME_NAME.."_HealthBar"]:SetAlpha(FRAME_SETTINGS.StatusBar[1].alpha);
			else
				_G[FRAME_NAME.."_HealthBar"]:SetAlpha(0);
			end
		end
		if (FRAME_SETTINGS.StatusBar[2].incombat or FRAME_SETTINGS.StatusBar[2].healthupdating or FRAME_SETTINGS.StatusBar[2].manaupdating) then
			local show;
			if (FRAME_SETTINGS.StatusBar[2].incombat and self.status == 2) then
				show = 1;
			end
			if (FRAME_SETTINGS.StatusBar[2].healthupdating and self.health < self.healthmax) then
				show = 1;
			end
			if (FRAME_SETTINGS.StatusBar[2].manaupdating and self.mana and self.manamax and self.mana < self.manamax) then
				show = 1;
			end
			if (show) then
				_G[FRAME_NAME.."_ManaBar"]:SetAlpha(FRAME_SETTINGS.StatusBar[2].alpha);
			else
				_G[FRAME_NAME.."_ManaBar"]:SetAlpha(0);
			end
		end
		for t=1,10 do
			local settings = FRAME_SETTINGS.TextBox[t];
			if (settings.incombat or settings.healthupdating or settings.manaupdating) then
				local show;
				if (settings.incombat and self.status == 2) then
					show = 1;
				end
				if (settings.healthupdating and self.health and self.healthmax and self.health < self.healthmax) then
					show = 1;
				end
				if (settings.manaupdating and self.mana and self.manamax and self.mana < self.manamax) then
					show = 1;
				end
				if (show) then
					_G[FRAME_NAME.."_TextBox_"..t]:SetAlpha(settings.alpha);
				else
					_G[FRAME_NAME.."_TextBox_"..t]:SetAlpha(0);
				end
			end
		end
		if (FRAME_SETTINGS.flash) then
-- Fizzlemizz: Comment: another divide by zero bug
			local crud
			if UnitHealthMax(self.unit) == 0 then
				crud = UnitHealth(self.unit)
			else
				crud = UnitHealth(self.unit) / UnitHealthMax(self.unit)
			end
-- Fizzlemizz part of divide by zero bug			if (UnitHealth(self.unit) / UnitHealthMax(self.unit) <= DUF_Settings[DUF_INDEX].flashthreshold and UnitHealth(self.unit) > 0 and (not UnitIsGhost(self.unit))) then
			if (crud <= DUF_Settings[DUF_INDEX].flashthreshold and UnitHealth(self.unit) > 0 and (not UnitIsGhost(self.unit))) then
				self.Flashing = true;
				if (not self.flashTimer) then
					self.flashTimer = .5;
				end
			elseif (self.Flashing) then
				self.Flashing = nil;
				_G[FRAME_NAME.."_Background"]:SetAlpha(1);
				return;
			else
				return;
			end
			self.flashTimer = self.flashTimer - 10;
			if (self.flashTimer < 0) then
				self.flashTimer = .5;
				if (self.Direction) then
					self.Direction = nil;
				else
					self.Direction = 1;
				end
			else
				if (self.Direction) then
					_G[FRAME_NAME.."_Background"]:SetAlpha(self.flashTimer * 2);
				else
					_G[FRAME_NAME.."_Background"]:SetAlpha(1 - self.flashTimer * 2);
				end
			end
		end
	end 
end

function DUF_UnitBuff(unit,id)
  local name, rank, icon, count, duration, timeLeft = UnitBuff(unit, id) 
  return name, rank, icon, count, duration, timeLeft
end

function DUF_UnitDebuff(unit,id)
	if not unit then return end
	local name, rank, icon, count, debuffType, duration, timeLeft = UnitDebuff(unit,id)
	return name, rank, icon, count, debuffType, duration, timeLeft
end

function DUF_UnitFrame_HookTempEnchants(te_index, duf_index, settings)
	local button = _G["TempEnchant" .. te_index];
	local icon, count, duration, border = button:GetRegions();
	local frame = _G[DUF_FRAME_DATA["player"].frame.."_TempEnchants"];
	duf_button = _G[frame:GetName().."_" .. duf_index];
	button:ClearAllPoints();
	button:SetPoint("TOPLEFT", duf_button, "TOPLEFT", 0, 0);
	button:SetWidth(settings.size);
	button:SetHeight(settings.size);
	border:SetWidth(settings.size);
	border:SetHeight(settings.size);
	duration:SetAlpha(0);
	duf_duration = _G[frame:GetName().."_"..duf_index.."_Text"];
	if (DUF_Settings[DUF_INDEX].custompaths) then
		duf_duration:SetFont(settings.durationfont, settings.durationheight);
	else
		duf_duration:SetFont("Interface\\AddOns\\DiscordUnitFrames\\CustomFonts\\"..settings.durationfont, settings.durationheight);
	end
	duf_duration:SetTextColor(settings.durationcolor.r, settings.durationcolor.g, settings.durationcolor.b, settings.durationalpha);
	duf_duration:ClearAllPoints();
	duf_duration:SetPoint("TOP", button, "BOTTOM", settings.durationx, settings.durationy);
	if (settings.showduration) then
		duf_duration:Show();
	else
		duf_duration:Hide();
	end
end

function DUF_UnitFrame_UpdateTempEnchants(self)
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA["player"].index].TempEnchants
	local tempenchantcount = 0;
	local tempenchant, frame,  expirationTime, handEnchanted;
	local hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges, hasThrownEnchant, thrownExpiration, thrownCharges = GetWeaponEnchantInfo()
	local enchantIndex = 0;
	local i
	for  i=3, 1, -1 do -- Fizzlemizz Blizz allocated TE buffs in reverse order Ranged then Offhand then Main
		frame = _G[DUF_FRAME_DATA["player"].frame.."_TempEnchants_" .. i];
		if (i == 1) then
			handEnchanted = hasMainHandEnchant;
			expirationTime = mainHandExpiration;
		elseif (i == 2) then
			handEnchanted = hasOffHandEnchant;
			expirationTime = offHandExpiration;
		else
			handEnchanted = hasThrownEnchant
			expirationTime = thrownExpiration;
		end
	
		if not expirationTime then
			timeLeft = 0;
		else
			timeLeft = expirationTime / 1000; 
		end
		if (handEnchanted) then
			enchantIndex = enchantIndex + 1;-- Fizzlemizz: alingn the dyanmic Blizz TE frame to the fixed DUF TE frame
			DUF_UnitFrame_HookTempEnchants(enchantIndex, i, settings);
			if (not frame:IsVisible()) then
				frame:Show();
			end
			tempenchantcount = i;
			DUF_Aura_timeLeft(self, DUF_FRAME_DATA["player"].frame.."_TempEnchants_"..i,timeLeft, settings);
		else
			if (not DUF_OPTIONS_VISIBLE and frame:IsVisible()) then
				frame:Hide();
			end
			tempenchantcount = i;
		end
	end
	frame = _G[DUF_FRAME_DATA["player"].frame.."_TempEnchants"];
	if (tempenchantcount == 0) then
		frame.tempenchantcount = nil;
	elseif (not settings.hide) then
		frame.tempenchantcount = tempenchantcount;
	end
end

function DUF_UnitFrame_UpdateBuffs(self, unit)
	local buffcount = 0;
	local BUFF_SETTINGS = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].Buffs
	local buff, button, icon, count;
	for j=1,DL_UNIT_BUFFCOUNT do
		local i = j;
		if (BUFF_SETTINGS.reverse) then
			i = DL_UNIT_BUFFCOUNT + 1 - j;
		end
		button = _G[DUF_FRAME_DATA[unit].frame.."_Buffs_"..i];
		if (j <= BUFF_SETTINGS.shown) then

			name, rank, buff, count, buffType, duration, expirationTime, isMine, isStealable = UnitBuff(unit, j);
			if not expirationTime then
				timeLeft = 0;
			else
				timeLeft = expirationTime - GetTime();
			end

			icon = _G[DUF_FRAME_DATA[unit].frame.."_Buffs_"..i.."_Texture"];
			if (buff) then
				icon:SetTexture(buff);
				button:Show();
				buffcount = j;
				DUF_Aura_timeLeft(self, DUF_FRAME_DATA[unit].frame.."_Buffs_"..i,timeLeft, BUFF_SETTINGS)
				if (count and count > 1) then 
					_G[DUF_FRAME_DATA[unit].frame.."_Buffs_"..i.."_Stack"]:Show()
					_G[DUF_FRAME_DATA[unit].frame.."_Buffs_"..i.."_Stack"]:SetText(count);
				else
					_G[DUF_FRAME_DATA[unit].frame.."_Buffs_"..i.."_Stack"]:Hide()
				end
			elseif (DUF_OPTIONS_VISIBLE) then
				icon:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Buff");
 				button:Show();
				buffcount = j;
			else
				button:Hide();
			end
		else
			button:Hide();
		end
	end
	local background = _G[DUF_FRAME_DATA[unit].frame.."_Buffs"];
	if (buffcount == 0) then
		background:Hide();
		background:SetHeight(.5);
		background:SetWidth(.5);
		background.buffcount = 0;
		return;
	elseif (not BUFF_SETTINGS.hide) then
		background.buffcount = buffcount;
		background:Show();
	else
		return;
	end
	local size = BUFF_SETTINGS.size;
	local hspacing = BUFF_SETTINGS.hspacing;
	local vspacing = BUFF_SETTINGS.vspacing;
	local height, width;
	if (BUFF_SETTINGS.tworows) then
		local row2start = math.ceil(BUFF_SETTINGS.shown / 2);
		local rows = 1;
		if (buffcount > row2start) then
			buffcount = row2start;
			rows = 2;
		end
		if (BUFF_SETTINGS.vertical) then
			height = size * buffcount + vspacing * (buffcount - 1);
			width = size * rows + hspacing * (rows - 1);
		else
			width = size * buffcount + hspacing * (buffcount - 1);
			height = size * rows + vspacing * (rows - 1);
		end
	else
		if (BUFF_SETTINGS.vertical) then
			height = size * buffcount + vspacing * (buffcount - 1);
			width = size;
		else
			width = size * buffcount + hspacing * (buffcount - 1);
			height = size;
		end
	end
	background:SetWidth(width);
	background:SetHeight(height);
	background = _G[DUF_FRAME_DATA[unit].frame.."_Buffs_Background"];
	background:SetWidth(width + BUFF_SETTINGS.bgpadding * 2);
	background:SetHeight(height + BUFF_SETTINGS.bgpadding * 2);
end

function DUF_UnitFrame_UpdateDebuffs(self, unit)
	local DEBUFF_SETTINGS = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].Debuffs
	local buffcount = 0;
	local buff, button, icon, debuffApplications, color, debuffType, border;
	for j=1,DL_UNIT_BUFFCOUNT do
		local i = j;
		if (DEBUFF_SETTINGS.reverse) then
			i = DL_UNIT_BUFFCOUNT + 1 - j;
		end
		button = _G[DUF_FRAME_DATA[unit].frame.."_Debuffs_"..i];
		border = _G[DUF_FRAME_DATA[unit].frame.."_Debuffs_"..i.."Border"];
		if (j <= DEBUFF_SETTINGS.shown) then

			name, rank, buff, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff(unit, j);
			if not expirationTime then
				timeLeft = 0;
			else
				timeLeft = expirationTime - GetTime();
			end
     
			if ( debuffType ) then
				color = DebuffTypeColor[debuffType];
			else
				color = DebuffTypeColor["none"];
			end
			border:SetVertexColor(color.r, color.g, color.b);

			icon = _G[DUF_FRAME_DATA[unit].frame.."_Debuffs_"..i.."_Texture"];
			if (buff) then
				icon:SetTexture(buff);
				button:Show();
				buffcount = j;
				DUF_Aura_timeLeft(self, DUF_FRAME_DATA[unit].frame.."_Debuffs_"..i,timeLeft, DEBUFF_SETTINGS)
			elseif (DUF_OPTIONS_VISIBLE) then
				icon:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Debuff");
				button:Show();
				buffcount = j;
				count = 5;		
			else
				button:Hide();
			end
			if (count ~= nil) and (count > 1) then 
				_G[DUF_FRAME_DATA[unit].frame.."_Debuffs_"..i.."_Stack"]:SetText(count);
			else
				_G[DUF_FRAME_DATA[unit].frame.."_Debuffs_"..i.."_Stack"]:SetText("");
			end
		else
			button:Hide();
		end
	end
	local background = _G[DUF_FRAME_DATA[unit].frame.."_Debuffs"];
	if (buffcount == 0) then
		background:Hide();
		background:SetHeight(.5);
		background:SetWidth(.5);
		background.buffcount = 0;
		return;
	elseif (not DEBUFF_SETTINGS.hide) then
		background.buffcount = buffcount;
		background:Show();
	else
		return;
	end
	local size = DEBUFF_SETTINGS.size;
	local hspacing = DEBUFF_SETTINGS.hspacing;
	local vspacing = DEBUFF_SETTINGS.vspacing;
	local height, width;
	if (DEBUFF_SETTINGS.tworows) then
		local row2start = math.ceil(DEBUFF_SETTINGS.shown / 2);
		local rows = 1;
		if (buffcount > row2start) then
			buffcount = row2start;
			rows = 2;
		end
		if (DEBUFF_SETTINGS.vertical) then
			height = size * buffcount + vspacing * (buffcount - 1);
			width = size * rows + hspacing * (rows - 1);
		else
			width = size * buffcount + hspacing * (buffcount - 1);
			height = size * rows + vspacing * (rows - 1);
		end
	else
		if (DEBUFF_SETTINGS.vertical) then
			height = size * buffcount + vspacing * (buffcount - 1);
			width = size;
		else
			width = size * buffcount + hspacing * (buffcount - 1);
			height = size;
		end
	end
	background:SetWidth(width);
	background:SetHeight(height);
	background = _G[DUF_FRAME_DATA[unit].frame.."_Debuffs_Background"];
	background:SetWidth(width + DEBUFF_SETTINGS.bgpadding * 2);
	background:SetHeight(height + DEBUFF_SETTINGS.bgpadding * 2);
end

function DUF_UnitPopup_OnLoad(self)
	local unit = "player";
	local frame = self:GetName();
	if (string.find(frame, "PartyFrame")) then
		unit = "party";
	elseif (string.find(frame, "PetFrame")) then
		unit = "pet";
	elseif (string.find(frame, "TargetFrame")) then
		unit = "target";
	end
	UIDropDownMenu_Initialize(self, _G["DUF_UnitPopup_"..unit.."_Initialize"], "MENU");
end

function DUF_UnitPopup_party_Initialize(dropdown)
	local unitid = "party" .. string.match(dropdown:GetName(), "%d");
	UnitPopup_ShowMenu(dropdown, "PARTY", unitid);
end

function DUF_UnitPopup_pet_Initialize()
	if ( UnitExists("pet") ) then
		UnitPopup_ShowMenu(DUF_PetFrame_DropDown, "PET", "pet");
	end
end

function DUF_UnitPopup_player_Initialize()
	UnitPopup_ShowMenu(DUF_PlayerFrame_DropDown, "SELF", "player");
end

function DUF_UnitPopup_target_Initialize()
	local menu;
	local name;
	if ( UnitExists("target") and UnitReaction("player", "target") and (((UnitReaction("player", "target") >= 4 and not UnitIsPlayer("target")) and not UnitIsUnit("player", "target")) or (UnitReaction("player", "target") < 4  and not UnitIsPlayer("target"))) ) then
		menu = "RAID_TARGET_ICON";
		name = RAID_TARGET_ICON;
	elseif ( UnitIsUnit("target", "player") ) then
		menu = "SELF";
	elseif ( UnitIsUnit("target", "pet") ) then
		menu = "PET";
	elseif ( UnitIsPlayer("target") ) then
		if ( UnitInParty("target") ) then
			menu = "PARTY";
		else
			menu = "PLAYER";
		end
	end
	if ( menu ) then
		UnitPopup_ShowMenu(DUF_TargetFrame_DropDown, menu, "target");
	end
end

function DUF_UnitPopup_focus_Initialize()
	local menu;
	local name;
	if ( UnitExists("focus") and UnitReaction("player", "focus") and (((UnitReaction("player", "focus") >= 4 and not UnitIsPlayer("focus")) and not UnitIsUnit("player", "focus")) or (UnitReaction("player", "focus") < 4  and not UnitIsPlayer("focus"))) ) then
		menu = "RAID_TARGET_ICON";
		name = RAID_TARGET_ICON;
	elseif ( UnitIsUnit("focus", "player") ) then
		menu = "SELF";
	elseif ( UnitIsUnit("focus", "pet") ) then
		menu = "PET";
	elseif ( UnitIsPlayer("focus") ) then
		if ( UnitInParty("focus") ) then
			menu = "PARTY";
		else
			menu = "PLAYER";
		end
	end
	if ( menu ) then
		UnitPopup_ShowMenu(DUF_TargetOfTargetFrame_DropDown, menu, "focus");
	end
end

function DUF_UnitPopup_ShowMenu(unit)
	if (unit == "targettarget" or unit == "focus" or string.find(unit, "partypet")) then return; end
	local popup = _G[DUF_FRAME_DATA[unit].frame.."_DropDown"];
	ToggleDropDownMenu(1, nil, popup, "cursor", 0, 0);
end

function DUF_ToggleDropDownMenu(level, value, dropDownFrame, anchorName, xOffset, yOffset)
	if ( not level ) then
		level = 1;
	end
	UIDROPDOWNMENU_MENU_LEVEL = level;
	UIDROPDOWNMENU_MENU_VALUE = value;
	local listFrame = _G["DropDownList"..level];
	local listFrameName = "DropDownList"..level;
	local tempFrame;
	local point, relativePoint, relativeTo;
	if ( not dropDownFrame ) then
		tempFrame = this:GetParent();
	else
		tempFrame = dropDownFrame;
	end
	if ( listFrame:IsVisible() and (UIDROPDOWNMENU_OPEN_MENU == tempFrame:GetName()) ) then
		listFrame:Hide();
	else
		local uiScale = 1.0;
		if ( GetCVar("useUiScale") == "1" ) then
			if ( tempFrame ~= WorldMapContinentDropDown and tempFrame ~= WorldMapZoneDropDown ) then
				uiScale = tonumber(GetCVar("uiscale"));
			end
		end
		listFrame:SetScale(uiScale);
		 
		listFrame:Hide();
		
		local anchorFrame;

		if ( level == 1 ) then
			if ( not dropDownFrame ) then
				dropDownFrame = this:GetParent();
			end
			UIDROPDOWNMENU_OPEN_MENU = dropDownFrame:GetName();
			listFrame:ClearAllPoints();
			if ( not anchorName ) then
				if ( dropDownFrame.xOffset ) then
					xOffset = dropDownFrame.xOffset;
				end
				if ( dropDownFrame.yOffset ) then
					yOffset = dropDownFrame.yOffset;
				end
				if ( dropDownFrame.point ) then
					point = dropDownFrame.point;
				end
				if ( dropDownFrame.relativeTo ) then
					relativeTo = dropDownFrame.relativeTo;
				else
					relativeTo = UIDROPDOWNMENU_OPEN_MENU.."Left";
				end
				if ( dropDownFrame.relativePoint ) then
					relativePoint = dropDownFrame.relativePoint;
				end
			elseif ( anchorName == "cursor" ) then
				relativeTo = "UIParent";
				local cursorX, cursorY = GetCursorPosition();
				cursorX = cursorX/uiScale;
				cursorY =  cursorY/uiScale;

				if ( not xOffset ) then
					xOffset = 0;
				end
				if ( not yOffset ) then
					yOffset = 0;
				end
				xOffset = cursorX + xOffset;
				yOffset = cursorY + yOffset;
			else
				relativeTo = anchorName;
			end
			if ( not xOffset or not yOffset ) then
				xOffset = 8;
				yOffset = 22;
			end
			if ( not point ) then
				point = "TOPLEFT";
			end
			if ( not relativePoint ) then
				relativePoint = "BOTTOMLEFT";
			end
			listFrame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);
		else
			if ( not dropDownFrame ) then
				dropDownFrame = _G[UIDROPDOWNMENU_OPEN_MENU];
			end
			listFrame:ClearAllPoints();
			
			if ( strsub(this:GetParent():GetName(), 0,12) == "DropDownList" and strlen(this:GetParent():GetName()) == 13 ) then
				anchorFrame = this:GetName();
			else
				anchorFrame = this:GetParent():GetName();
			end
			listFrame:SetPoint("TOPLEFT", anchorFrame, "TOPRIGHT", 0, 0);
		end
		
		
		if ( dropDownFrame and dropDownFrame.displayMode == "MENU" ) then
			_G[listFrameName.."Backdrop"]:Hide();
			_G[listFrameName.."MenuBackdrop"]:Show();
		else
			_G[listFrameName.."Backdrop"]:Show();
			_G[listFrameName.."MenuBackdrop"]:Hide();
		end

		UIDropDownMenu_Initialize(dropDownFrame, dropDownFrame.initialize, nil, level);
		
		if ( listFrame.numButtons == 0 ) then
			return;
		end

		
		listFrame:Show();
		
		local x, y = listFrame:GetCenter();
		if ( not x or not y ) then
			listFrame:Hide();
			return;
		end
		
		local offscreenY, offscreenX;
		if ( (y - listFrame:GetHeight()/2) < 0 ) then
			offscreenY = 1;
		end
		if ( listFrame:GetRight() > GetScreenWidth() ) then
			offscreenX = 1;	
		end
		
		
		if ( level == 1 ) then
			if ( offscreenY and offscreenX ) then
				anchorPoint = "BOTTOMRIGHT";
				relativePoint = "BOTTOMLEFT";
			elseif ( offscreenY ) then
				anchorPoint = "BOTTOMLEFT";
				relativePoint = "TOPLEFT";
			elseif ( offscreenX ) then
				anchorPoint = "TOPRIGHT";
				relativePoint = "TOPLEFT";
			else
				anchorPoint = "TOPLEFT";
			end
			
			listFrame:ClearAllPoints();
			if ( anchorName == "cursor" ) then
				listFrame:SetPoint(anchorPoint, relativeTo, "BOTTOMLEFT", xOffset, yOffset);
			else
				listFrame:SetPoint(anchorPoint, relativeTo, relativePoint, xOffset, yOffset);
			end
		else
			local anchorPoint, relativePoint, offsetX, offsetY;
			if ( offscreenY and offscreenX ) then
				anchorPoint = "BOTTOMRIGHT";
				relativePoint = "BOTTOMLEFT";
				offsetX = -11;
				offsetY = -14;
			elseif ( offscreenY ) then
				anchorPoint = "BOTTOMLEFT";
				relativePoint = "BOTTOMRIGHT";
				offsetX = 0;
				offsetY = -14;
			elseif ( offscreenX ) then
				anchorPoint = "TOPRIGHT";
				relativePoint = "TOPLEFT";
				offsetX = -11;
				offsetY = 14;
			else
				anchorPoint = "TOPLEFT";
				relativePoint = "TOPRIGHT";
				offsetX = 0;
				offsetY = 14;
			end
			
			listFrame:ClearAllPoints();
			listFrame:SetPoint(anchorPoint, anchorFrame, relativePoint, offsetX, offsetY);
		end
	end
end
