--[[ this file handles Voice functionality for Discord Unit Frames ]]--

function DUF_Update_VoiceIcon(unit,talking)
	local mode;
	local inInstance, instanceType = IsInInstance();

	if ( (instanceType == "pvp") or (instanceType == "arena") ) then
		mode = "Battleground";
--	elseif ( GetNumRaidMembers() > 0 ) then
	elseif (IsInRaid()) then
		mode = "raid";
	else
		mode = "party";
	end

	local status = GetVoiceStatus(unit, mode);
	local muted = GetMuteStatus(unit, mode);
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].VoiceIcon
	local frame = _G[DUF_FRAME_DATA[unit].frame.."_VoiceIcon"];
	local texture = _G[DUF_FRAME_DATA[unit].frame.."_VoiceIcon_Texture"];

	if (settings.hide and not DUF_OPTIONS_VISIBLE) then
		frame:Hide();
		return;
	end;
	
	if ( status == 2 ) then
		frame:Show();
		texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\CustomTextures\\VoiceChat-Muted");
	elseif ( status == 1 ) then
		frame:Show();
		texture:SetTexture("");
		if (talking == 1) then
			texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\CustomTextures\\VoiceChat-On");
		end;
	elseif ( not status or status == 0 ) then
		frame:Show();
		texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\CustomTextures\\VoiceChat-Speaker");
		texture:SetDesaturated(1);
	end
	if ( muted ) then
			texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\CustomTextures\\VoiceChat-Muted");
	end;
	
	if (status) then
	
	else
		
	end
end;

function DUF_OnClick_VoiceIcon(self, button)
--	DL_Debug(this.unit);

end;

function DUF_Voice_Event(event, ...)
	local arg1, arg2, arg3 = ...
	if ( event == "VOICE_START") then
		DUF_Update_VoiceIcon(arg1, 1);
	elseif ( event == "VOICE_STOP" ) then
		DUF_Update_VoiceIcon(arg1, 0);
	elseif ( event == "VOICE_LEFT_SESSION" ) then
		
	end;
end;

function DUF_Initialize_VoiceIcon(unit)
	local frame = _G[DUF_FRAME_DATA[unit].frame.."_VoiceIcon"];
	local texture = _G[DUF_FRAME_DATA[unit].frame.."_VoiceIcon_Texture"];
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].VoiceIcon;
	DUF_Initialize_Element(unit, frame, settings);
	texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\CustomTextures\\VoiceChat-Speaker")
	local state = UnitIsTalking(UnitName(unit))
	DUF_Update_VoiceIcon(unit,state);
end;
