function DUF_Options_OnLoad(self)
	tinsert(UISpecialFrames, "DUF_Options");
end

function DUF_CheckButton_OnClick(self)
 	DUF_Update_Setting(self:GetChecked(), self.index, self.subindex);
	DUF_Run_Functions(self);
end

function DUF_ColorPicker_OnClick(self)
	local basecolor = DUF_Options_GetSetting(self.index);
	local color = {};
	color.r = basecolor.r;
	color.g = basecolor.g;
	color.b = basecolor.b;
	ColorPickerFrame.previousValues = color;
	ColorPickerFrame.cancelFunc = DUF_ColorPicker_ColorCancelled;
	ColorPickerFrame.opacityFunc = DUF_ColorPicker_ColorChanged;
	ColorPickerFrame.func = DUF_ColorPicker_ColorChanged;
	ColorPickerFrame.initfunc = self:GetParent().initFunc;
	ColorPickerFrame.colorBox = self:GetName();
	ColorPickerFrame.index = self.index;
	ColorPickerFrame:SetColorRGB(color.r, color.g, color.b);
	ColorPickerFrame:ClearAllPoints();
	if (DUF_Options:GetRight() < UIParent:GetWidth() / 2) then
		ColorPickerFrame:SetPoint("LEFT", "DUF_Options", "RIGHT", 10, 0);
	else
		ColorPickerFrame:SetPoint("RIGHT", "DUF_Options", "LEFT", -10, 0);
	end
	ColorPickerFrame:Show();
end

function DUF_ColorPicker_ColorCancelled()
	local color = ColorPickerFrame.previousValues;
	DUF_Update_Setting(color, ColorPickerFrame.index, ColorPickerFrame.subindex);
	_G[ColorPickerFrame.colorBox]:SetBackdropColor(color.r, color.g, color.b);
	if (ColorPickerFrame.initfunc) then
		for _,unit in pairs(DUF_INIT_FRAMES) do
			ColorPickerFrame.initfunc(0, unit, DUF_ELEMENT_SUBINDEX);
		end
	end
end

function DUF_ColorPicker_ColorChanged(self)
	local r, g, b = ColorPickerFrame:GetColorRGB();
	local color = { r=r, g=g, b=b };
	DUF_Update_Setting(color, ColorPickerFrame.index, ColorPickerFrame.subindex);
	_G[ColorPickerFrame.colorBox]:SetBackdropColor(color.r, color.g, color.b);
	if (ColorPickerFrame.initfunc) then
		for _,unit in pairs(DUF_INIT_FRAMES) do
			ColorPickerFrame.initfunc(self, unit, DUF_ELEMENT_SUBINDEX);
		end
	end
end

function DUF_CopyFrame(self, source)
	if (not source) then return; end
	if (source == DUF_FRAME_INDEX) then return; end
	local oldXPBar, oldHonorBar, oldCombo, oldElite; 
	if (DUF_FRAME_INDEX == "player" or DUF_FRAME_INDEX == "pet") then
		oldXPBar = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].StatusBar[3], oldXPBar);
	end
	if (DUF_FRAME_INDEX == "player") then
		oldHonorBar = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].StatusBar[6], oldHonorBar);
	end
	if (DUF_FRAME_INDEX == "target") then
		oldCombo = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].ComboPoints, oldCombo);
		oldElite = {};
		DL_Copy_Table(DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].EliteTexture, oldElite);
	end
	local oldx = {};
	local oldy = {};
	DL_Copy_Table(DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].xos, oldx);
	DL_Copy_Table(DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].yos, oldy);
	DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX] = {};
	DL_Copy_Table(DUF_Settings[DUF_INDEX][source], DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX]);
	if (DUF_FRAME_INDEX ~= "player" and DUF_FRAME_INDEX ~= "pet") then
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].StatusBar[3] = nil;
	else
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].StatusBar[3] = {};
		DL_Copy_Table(oldXPBar, DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].StatusBar[3]);
	end
	if (DUF_FRAME_INDEX ~= "player") then
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].Buffs.durationheight = 6;
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].Buffs.durationcolor = {r=1, g=1, b=1};
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].Buffs.durationfont = "DUF_Font1.ttf";
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].Buffs.durationalpha = 1;
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].Buffs.durationx = 0;
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].Buffs.durationy = -5;
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].Debuffs.durationheight = 6;
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].Debuffs.durationcolor = {r=1, g=1, b=1};
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].Debuffs.durationfont = "DUF_Font1.ttf";
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].Debuffs.durationalpha = 1;
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].Debuffs.durationx = 0;
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].Debuffs.durationy = -5;
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].StatusBar[6] = nil;
	else
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].StatusBar[6] = {};
		DL_Copy_Table(oldHonorBar, DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].StatusBar[6]);
		DUF_Settings[DUF_INDEX].player.Buffs.durationheight = 6;
		DUF_Settings[DUF_INDEX].player.Buffs.durationcolor = {r=1, g=1, b=1};
		DUF_Settings[DUF_INDEX].player.Buffs.durationfont = "DUF_Font1.ttf";
		DUF_Settings[DUF_INDEX].player.Buffs.durationalpha = 1;
		DUF_Settings[DUF_INDEX].player.Buffs.durationx = 0;
		DUF_Settings[DUF_INDEX].player.Buffs.durationy = -5;
		DUF_Settings[DUF_INDEX].player.Debuffs.durationheight = 6;
		DUF_Settings[DUF_INDEX].player.Debuffs.durationcolor = {r=1, g=1, b=1};
		DUF_Settings[DUF_INDEX].player.Debuffs.durationfont = "DUF_Font1.ttf";
		DUF_Settings[DUF_INDEX].player.Debuffs.durationalpha = 1;
		DUF_Settings[DUF_INDEX].player.Debuffs.durationx = 0;
		DUF_Settings[DUF_INDEX].player.Debuffs.durationy = -5;
	end
	if (DUF_FRAME_INDEX ~= "target") then
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].ComboPoints = nil;
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].EliteTexture = nil;
	else
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].ComboPoints = {};
		DL_Copy_Table(oldCombo, DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].ComboPoints);
		DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].EliteTexture = {};
		DL_Copy_Table(oldElite, DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].EliteTexture);
	end
	DUF_Initialize_AllFrames(self);
	DUF_Init_BaseOptions();
end

function DUF_EditBox_Update(self)
	local value = self:GetText();
	if (not value) then value = ""; end
	if (self.number) then
		value = self:GetNumber();
		if (not value) then
			value = 0;
			self:SetText("0");
		end
	end
	self:ClearFocus();
	if (self.index == "FRAMELOC") then
		DUF_EditBox_UpdateFrameLoc(self.subindex, value)
	else
		DUF_Update_Setting(value, self.index, self.subindex);
		DUF_Run_Functions(self);
		if (DUF_FRAME_INDEX) then
			for i = 1,10 do
				if (DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].TextBox[i].label) then
					_G["DUF_Options_TextBox"..i]:SetText("["..i.."] "..DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].TextBox[i].label);
				else
					_G["DUF_Options_TextBox"..i]:SetText(DUF_TEXT["TextBox"..i]);
				end
			end
		end
	end
end

function DUF_EditBox_UpdateFrameLoc(locIndex, value)
	local index = tonumber(DUF_FrameOptions_FrameChooser_Setting:GetText())
	DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX][locIndex][index] = value
	if (string.find(DUF_FRAME_INDEX, "party")) then
		DUF_Initialize_FrameLoc(DUF_FRAME_INDEX..index)
	else
		DUF_Initialize_FrameLoc(DUF_FRAME_INDEX)
	end
end

function DUF_Init_BaseOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_EditBox(DUF_ElementOptions_Base_XOffset, settings.xoffset);
	DL_Init_EditBox(DUF_ElementOptions_Base_YOffset, settings.yoffset);
	DL_Init_EditBox(DUF_ElementOptions_Base_FrameLevel, settings.framelevel);
	DL_Init_EditBox(DUF_ElementOptions_Base_BGTexture, settings.bgtexture);
	DL_Init_MenuControl(DUF_ElementOptions_Base_FrameStrata, settings.framestrata);
	DL_Init_EditBox(DUF_ElementOptions_Base_CustomTooltip, settings.customtooltip);
	DL_Init_CheckBox(DUF_ElementOptions_Base_DisableMouse, settings.disablemouse);
	DL_Init_CheckBox(DUF_ElementOptions_Base_UseCustomTooltip, settings.usecustomtooltip);
	DL_Init_CheckBox(DUF_ElementOptions_Base_DisableTooltip, settings.disabletooltip);
	DL_Init_CheckBox(DUF_ElementOptions_Base_Flash, settings.flashlowhealth);
	DL_Init_MenuControl(DUF_ElementOptions_Base_MainColorContext, settings.context);
	DL_Init_MenuControl(DUF_ElementOptions_Base_BackgroundColorContext, settings.bgcontext);
	DL_Init_MenuControl(DUF_ElementOptions_Base_BorderColorContext, settings.bordercontext);
	DL_Init_MenuControl(DUF_ElementOptions_Base_LeftClick, settings.leftclick);
	DL_Init_MenuControl(DUF_ElementOptions_Base_RightClick, settings.rightclick);
	DL_Init_MenuControl(DUF_ElementOptions_Base_MiddleClick, settings.middleclick);
	DL_Init_MenuControl(DUF_ElementOptions_Base_AttachFrame, settings.attach);
	DL_Init_MenuControl(DUF_ElementOptions_Base_AttachPoint, settings.attachpoint);
	DL_Init_MenuControl(DUF_ElementOptions_Base_AttachTo, settings.attachto);
	DL_Init_CheckBox(DUF_ElementOptions_Base_Hide, settings.hide);
	DL_Init_CheckBox(DUF_ElementOptions_Base_Mouseover, settings.mouseover);
	DL_Init_CheckBox(DUF_ElementOptions_Base_HideOnMouseover, settings.hidemouseover);
	DL_Init_CheckBox(DUF_ElementOptions_Base_UseMouseoverColor, settings.usemouseovercolor);
	DL_Init_ColorPicker(DUF_ElementOptions_Base_MouseoverColor, settings.mouseovercolor);
	DL_Init_MenuControl(DUF_ElementOptions_Base_MouseoverGroup, settings.mouseovergroup);
	DL_Init_Slider(DUF_ElementOptions_Base_Alpha, settings.alpha);
	DL_Init_CheckBox(DUF_ElementOptions_Base_HideBG, settings.hidebg);
	DL_Init_ColorPicker(DUF_ElementOptions_Base_BGColor, settings.bgcolor);
	DL_Init_Slider(DUF_ElementOptions_Base_BGAlpha, settings.bgalpha);
	DL_Init_Slider(DUF_ElementOptions_Base_BGPadding, settings.bgpadding);
	DL_Init_ColorPicker(DUF_ElementOptions_Base_BorderColor, settings.bordercolor);
	DL_Init_MenuControl(DUF_ElementOptions_Base_BorderStyle, settings.backgroundstyle);
	DL_Init_Slider(DUF_ElementOptions_Base_BorderAlpha, settings.borderalpha);
end

function DUF_Init_BuffOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_BuffOptions_Size, settings.size);
	DL_Init_Slider(DUF_BuffOptions_HSpacing, settings.hspacing);
	DL_Init_Slider(DUF_BuffOptions_VSpacing, settings.vspacing);
	DL_Init_Slider(DUF_BuffOptions_Shown, settings.shown);
	DL_Init_CheckBox(DUF_BuffOptions_TwoRows, settings.tworows);
	DL_Init_CheckBox(DUF_BuffOptions_DurationFormat, settings.altformat);
	DL_Init_CheckBox(DUF_BuffOptions_Vertical, settings.vertical);
	DL_Init_CheckBox(DUF_BuffOptions_ReverseFill, settings.reverse);
	DL_Init_CheckBox(DUF_BuffOptions_ShowDuration, settings.showduration);
	DL_Init_CheckBox(DUF_BuffOptions_DurationFormat, settings.altformat);
	DL_Init_Slider(DUF_BuffOptions_DurationXOffset, settings.durationx);
	DL_Init_Slider(DUF_BuffOptions_DurationYOffset, settings.durationy);
	DL_Init_Slider(DUF_BuffOptions_DurationHeight, settings.durationheight);
	DL_Init_Slider(DUF_BuffOptions_DurationAlpha, settings.durationalpha);
	DL_Init_EditBox(DUF_BuffOptions_DurationFont, settings.durationfont);
	DL_Init_ColorPicker(DUF_BuffOptions_DurationColor, settings.durationcolor);
end

function DUF_Init_TempEnchantOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_TempEnchantOptions_Size, settings.size);
	DL_Init_Slider(DUF_TempEnchantOptions_HSpacing, settings.hspacing);
	DL_Init_Slider(DUF_TempEnchantOptions_VSpacing, settings.vspacing);
	DL_Init_CheckBox(DUF_TempEnchantOptions_DurationFormat, settings.altformat);
	DL_Init_CheckBox(DUF_TempEnchantOptions_Vertical, settings.vertical);
	DL_Init_CheckBox(DUF_TempEnchantOptions_ShowDuration, settings.showduration);
	DL_Init_CheckBox(DUF_TempEnchantOptions_DurationFormat, settings.altformat);
	DL_Init_Slider(DUF_TempEnchantOptions_DurationXOffset, settings.durationx);
	DL_Init_Slider(DUF_TempEnchantOptions_DurationYOffset, settings.durationy);
	DL_Init_Slider(DUF_TempEnchantOptions_DurationHeight, settings.durationheight);
	DL_Init_Slider(DUF_TempEnchantOptions_DurationAlpha, settings.durationalpha);
	DL_Init_EditBox(DUF_TempEnchantOptions_DurationFont, settings.durationfont);
	DL_Init_ColorPicker(DUF_TempEnchantOptions_DurationColor, settings.durationcolor);
end

function DUF_Init_ClassIconOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_ClassIconOptions_Size, settings.size);
	DL_Init_CheckBox(DUF_ClassIconOptions_UseRaceTexture, settings.userace);
end

function DUF_Init_VoiceIconOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_VoiceIconOptions_Size, settings.size);
end


function DUF_Init_ContextColors()
	for i = 1,6 do
		DL_Init_ColorPicker(_G["DUF_ColorContextOptions_Difficulty"..i], DUF_Settings[DUF_INDEX]["lvlcolor"..i]);
		DL_Init_ColorPicker(_G["DUF_ColorContextOptions_Reaction"..i], DUF_Settings[DUF_INDEX]["reactioncolor"..i]);
	end
	DL_Init_ColorPicker(DUF_ColorContextOptions_Health1, DUF_Settings[DUF_INDEX].healthcolor1);
	DL_Init_ColorPicker(DUF_ColorContextOptions_Health2, DUF_Settings[DUF_INDEX].healthcolor2);
	DL_Init_EditBox(DUF_ColorContextOptions_HealthThreshold1, DUF_Settings[DUF_INDEX].healththreshold1);
	DL_Init_EditBox(DUF_ColorContextOptions_HealthThreshold2, DUF_Settings[DUF_INDEX].healththreshold2);
	DL_Init_ColorPicker(DUF_ColorContextOptions_Mana1, DUF_Settings[DUF_INDEX].manacolor1);
	DL_Init_ColorPicker(DUF_ColorContextOptions_Mana2, DUF_Settings[DUF_INDEX].manacolor2);
	DL_Init_EditBox(DUF_ColorContextOptions_ManaThreshold1, DUF_Settings[DUF_INDEX].manathreshold1);
	DL_Init_EditBox(DUF_ColorContextOptions_ManaThreshold2, DUF_Settings[DUF_INDEX].manathreshold2);
	DL_Init_ColorPicker(DUF_ColorContextOptions_Monk, DUF_Settings[DUF_INDEX].classcolorMonk);
	DL_Init_ColorPicker(DUF_ColorContextOptions_DeathKnight, DUF_Settings[DUF_INDEX].classcolorDeathKnight);
	DL_Init_ColorPicker(DUF_ColorContextOptions_Druid, DUF_Settings[DUF_INDEX].classcolorDruid);
	DL_Init_ColorPicker(DUF_ColorContextOptions_Hunter, DUF_Settings[DUF_INDEX].classcolorHunter);
	DL_Init_ColorPicker(DUF_ColorContextOptions_Mage, DUF_Settings[DUF_INDEX].classcolorMage);
	DL_Init_ColorPicker(DUF_ColorContextOptions_Paladin, DUF_Settings[DUF_INDEX].classcolorPaladin);
	DL_Init_ColorPicker(DUF_ColorContextOptions_Priest, DUF_Settings[DUF_INDEX].classcolorPriest);
	DL_Init_ColorPicker(DUF_ColorContextOptions_Rogue, DUF_Settings[DUF_INDEX].classcolorRogue);
	DL_Init_ColorPicker(DUF_ColorContextOptions_Shaman, DUF_Settings[DUF_INDEX].classcolorShaman);
	DL_Init_ColorPicker(DUF_ColorContextOptions_Warlock, DUF_Settings[DUF_INDEX].classcolorWarlock);
	DL_Init_ColorPicker(DUF_ColorContextOptions_Warrior, DUF_Settings[DUF_INDEX].classcolorWarrior);
	DL_Init_CheckBox(DUF_ColorContextOptions_UseFor0, DUF_Settings[DUF_INDEX].usefor0);
	DL_Init_CheckBox(DUF_ColorContextOptions_UseFor1, DUF_Settings[DUF_INDEX].usefor1);
	DL_Init_CheckBox(DUF_ColorContextOptions_UseFor2, DUF_Settings[DUF_INDEX].usefor2);
	DL_Init_CheckBox(DUF_ColorContextOptions_UseFor3, DUF_Settings[DUF_INDEX].usefor3);
	DL_Init_CheckBox(DUF_ColorContextOptions_UseFor4, DUF_Settings[DUF_INDEX].usefor4);
end

function DUF_Init_ComboPointsOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_ComboPointsOptions_Size, settings.size);
	DL_Init_Slider(DUF_ComboPointsOptions_Spacing, settings.spacing);
	DL_Init_ColorPicker(DUF_ComboPointsOptions_Color, settings.color);
	DL_Init_CheckBox(DUF_ComboPointsOptions_Vertical, settings.vertical);
	DL_Init_EditBox(DUF_ComboPointsOptions_CustomTexture, settings.customtexture);
end

function DUF_Init_MonkHarmonyOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_MonkHarmonyOptions_Size, settings.size);
	DL_Init_Slider(DUF_MonkHarmonyOptions_Spacing, settings.spacing);
--	DL_Init_ColorPicker(DUF_MonkHarmonyOptions_Color, settings.color);
	DL_Init_CheckBox(DUF_MonkHarmonyOptions_Vertical, settings.vertical);
--	DL_Init_EditBox(DUF_MonkHarmonyOptions_CustomTexture, settings.customtexture);
end

function DUF_Init_PriestOrbFrameOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_PriestOrbFrameOptions_Size, settings.size);
	DL_Init_Slider(DUF_PriestOrbFrameOptions_Spacing, settings.spacing);
--	DL_Init_ColorPicker(DUF_PriestOrbFrameOptions_Color, settings.color);
	DL_Init_CheckBox(DUF_PriestOrbFrameOptions_Vertical, settings.vertical);
--	DL_Init_EditBox(DUF_PriestOrbFrameOptions_CustomTexture, settings.customtexture);
end

function DUF_Init_WarlockPowerFrameOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_WarlockPowerFrameOptions_Size, settings.size);
	DL_Init_Slider(DUF_WarlockPowerFrameOptions_Spacing, settings.spacing);
--	DL_Init_ColorPicker(DUF_WarlockPowerFrameOptions_Color, settings.color);
	DL_Init_CheckBox(DUF_WarlockPowerFrameOptions_Vertical, settings.vertical);
--	DL_Init_EditBox(DUF_WarlockPowerFrameOptions_CustomTexture, settings.customtexture);
end

function DUF_Init_PalyPowerFrameOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_PalyPowerFrameOptions_Size, settings.size);
	DL_Init_Slider(DUF_PalyPowerFrameOptions_Spacing, settings.spacing);
--	DL_Init_ColorPicker(DUF_PalyPowerFrameOptions_Color, settings.color);
	DL_Init_CheckBox(DUF_PalyPowerFrameOptions_Vertical, settings.vertical);
--	DL_Init_EditBox(DUF_PalyPowerFrameOptions_CustomTexture, settings.customtexture);
end

function DUF_Init_RuneFrameOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_RuneFrameOptions_Size, settings.size);
	DL_Init_Slider(DUF_RuneFrameOptions_Spacing, settings.spacing);
--	DL_Init_ColorPicker(DUF_RuneFrameOptions_Color, settings.color);
	DL_Init_CheckBox(DUF_RuneFrameOptions_Vertical, settings.vertical);
--	DL_Init_EditBox(DUF_RuneFrameOptions_CustomTexture, settings.customtexture);
end

function DUF_Init_DebuffOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_DebuffOptions_Size, settings.size);
	DL_Init_Slider(DUF_DebuffOptions_HSpacing, settings.hspacing);
	DL_Init_Slider(DUF_DebuffOptions_VSpacing, settings.vspacing);
	DL_Init_Slider(DUF_DebuffOptions_Shown, settings.shown);
	DL_Init_CheckBox(DUF_DebuffOptions_TwoRows, settings.tworows);
	DL_Init_CheckBox(DUF_DebuffOptions_Vertical, settings.vertical);
	DL_Init_CheckBox(DUF_DebuffOptions_Flash, settings.flash);
	DL_Init_CheckBox(DUF_DebuffOptions_ReverseFill, settings.reverse);
	DL_Init_CheckBox(DUF_DebuffOptions_ShowDuration, settings.showduration);
	DL_Init_CheckBox(DUF_DebuffOptions_DurationFormat, settings.altformat);
	DL_Init_Slider(DUF_DebuffOptions_DurationXOffset, settings.durationx);
	DL_Init_Slider(DUF_DebuffOptions_DurationYOffset, settings.durationy);
	DL_Init_Slider(DUF_DebuffOptions_DurationHeight, settings.durationheight);
	DL_Init_Slider(DUF_DebuffOptions_DurationAlpha, settings.durationalpha);
	DL_Init_EditBox(DUF_DebuffOptions_DurationFont, settings.durationfont);
	DL_Init_ColorPicker(DUF_DebuffOptions_DurationColor, settings.durationcolor);
end

function DUF_Init_Element(self, unit)
	if (DUF_ELEMENT_INDEX == "Buffs") then
		DUF_Initialize_Buffs(self, unit);
	elseif (DUF_ELEMENT_INDEX == "ClassIcon") then
		DUF_Initialize_ClassIcon(unit);
	elseif (DUF_ELEMENT_INDEX == "ComboPoints") then
		DUF_Initialize_ComboPoints();
	elseif (DUF_ELEMENT_INDEX == "Debuffs") then
		DUF_Initialize_Debuffs(self, unit);
	elseif (DUF_ELEMENT_INDEX == "LeaderIcon") then
		DUF_Initialize_LeaderIcon(unit);
	elseif (DUF_ELEMENT_INDEX == "LootIcon") then
		DUF_Initialize_LootIcon(unit);
	elseif (DUF_ELEMENT_INDEX == "Portrait") then
		DUF_Initialize_Portrait(unit);
	elseif (DUF_ELEMENT_INDEX == "PVPIcon") then
		DUF_Initialize_PVPIcon(unit);
	elseif (DUF_ELEMENT_INDEX == "RaceIcon") then
		DUF_Initialize_RaceIcon(unit);
	elseif (DUF_ELEMENT_INDEX == "RankIcon") then
		DUF_Initialize_RankIcon(unit);
	elseif (DUF_ELEMENT_INDEX == "RoleIcon") then
		DUF_Initialize_RoleIcon(unit);
	elseif (DUF_ELEMENT_INDEX == "StatusBar") then
		DUF_Initialize_StatusBar(0, unit, DUF_ELEMENT_SUBINDEX); 
	elseif (DUF_ELEMENT_INDEX == "StatusIcon") then
		DUF_Initialize_StatusIcon(unit);
	elseif (DUF_ELEMENT_INDEX == "TextBox") then
		DUF_Initialize_TextBox(0, unit, DUF_ELEMENT_SUBINDEX); 
	elseif (DUF_ELEMENT_INDEX == "VoiceIcon") then
		DUF_Initialize_VoiceIcon(unit);
	elseif (DUF_ELEMENT_INDEX == "EliteTexture") then
		DUF_Initialize_EliteTexture();
	elseif (DUF_ELEMENT_INDEX == "TempEnchants") then
		DUF_Initialize_TempEnchants();
	elseif (DUF_ELEMENT_INDEX == "MonkHarmony") then
		DUF_Initialize_MonkHarmony();
	elseif (DUF_ELEMENT_INDEX == "PalyPowerFrame") then
		DUF_Initialize_PalyPowerFrame();
	elseif (DUF_ELEMENT_INDEX == "RuneFrame") then
		DUF_Initialize_RuneFrame();
	elseif (DUF_ELEMENT_INDEX == "PriestOrbFrame") then
		DUF_Initialize_PriestOrbFrame();
	elseif (DUF_ELEMENT_INDEX == "WarlockPowerFrame") then
		DUF_Initialize_WarlockPowerFrame();
	end
end

function DUF_Init_EliteTextureOptions()
	local settings = DUF_Settings[DUF_INDEX].target.EliteTexture;
	DL_Init_Slider(DUF_EliteTextureOptions_Size, settings.size);
	DL_Init_CheckBox(DUF_EliteTextureOptions_FacesLeft, settings.faceleft);
	DL_Init_EditBox(DUF_EliteTextureOptions_CustomEliteTexture, settings.elitetexture);
	DL_Init_EditBox(DUF_EliteTextureOptions_CustomRareTexture, settings.raretexture);
end

function DUF_Init_FrameOptions()
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX];
	DL_Init_MenuControl(DUF_FrameOptions_MainColorContext, settings.context);
	DL_Init_MenuControl(DUF_FrameOptions_FrameChooser, 1);
	DL_Init_MenuControl(DUF_FrameOptions_BackgroundColorContext, settings.bgcontext);
	DL_Init_MenuControl(DUF_FrameOptions_BorderColorContext, settings.bordercontext);
	DL_Init_MenuControl(DUF_FrameOptions_LeftClick, settings.leftclick);
	DL_Init_MenuControl(DUF_FrameOptions_RightClick, settings.rightclick);
	DL_Init_MenuControl(DUF_FrameOptions_MiddleClick, settings.middleclick);
	DL_Init_CheckBox(DUF_FrameOptions_Hide, settings.hide);
	DL_Init_CheckBox(DUF_FrameOptions_DisableMouse, settings.disablemouse);
	DL_Init_CheckBox(DUF_FrameOptions_Flash, settings.flash);
	DL_Init_CheckBox(DUF_FrameOptions_ShowDefault, settings.showDefault);
	DL_Init_ColorPicker(DUF_FrameOptions_MouseoverColor, settings.mouseovercolor);
	DL_Init_CheckBox(DUF_FrameOptions_UseMouseoverColor, settings.usemouseovercolor);
	DL_Init_MenuControl(DUF_FrameOptions_MouseoverGroup, settings.mouseovergroup);
	DL_Init_Slider(DUF_FrameOptions_Height, settings.height);
	DL_Init_Slider(DUF_FrameOptions_Width, settings.width);
	DL_Init_Slider(DUF_FrameOptions_Scale, settings.scale);
	DL_Init_Slider(DUF_FrameOptions_Alpha, settings.alpha);
	DL_Init_CheckBox(DUF_FrameOptions_HideBG, settings.hidebg);
	DL_Init_ColorPicker(DUF_FrameOptions_BGColor, settings.bgcolor);
	DL_Init_Slider(DUF_FrameOptions_BGAlpha, settings.bgalpha);
	DL_Init_Slider(DUF_FrameOptions_BGPadding, settings.bgpadding);
	DL_Init_ColorPicker(DUF_FrameOptions_BorderColor, settings.bordercolor);
	DL_Init_MenuControl(DUF_FrameOptions_BorderStyle, settings.backgroundstyle);
	DL_Init_Slider(DUF_FrameOptions_BorderAlpha, settings.borderalpha);
	DL_Init_CheckBox(DUF_FrameOptions_DisableTooltip, settings.disabletooltip);
	DL_Init_CheckBox(DUF_FrameOptions_UseCustomTooltip, settings.usecustomtooltip);
	DL_Init_EditBox(DUF_FrameOptions_CustomTooltip, settings.customtooltip);
	DL_Init_EditBox(DUF_FrameOptions_XOffset, settings.xos[1]);
	DL_Init_EditBox(DUF_FrameOptions_YOffset, settings.yos[1]);
	DL_Init_CheckBox(DUF_FrameOptions_Connect, settings.connect);
	DL_Init_MenuControl(DUF_FrameOptions_ConnectMethod, settings.connectmethod);
	DL_Init_Slider(DUF_FrameOptions_Spacing, settings.spacing);
end

function DUF_Init_HealthBarOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_HealthBarOptions_Height, settings.height);
	DL_Init_Slider(DUF_HealthBarOptions_Width, settings.width);
	DL_Init_ColorPicker(DUF_HealthBarOptions_Color, settings.color);
	DL_Init_ColorPicker(DUF_HealthBarOptions_SecondaryColor, settings.color2);
	DL_Init_CheckBox(DUF_HealthBarOptions_Fill, settings.fill);
	DL_Init_CheckBox(DUF_HealthBarOptions_Fade, settings.fade);
	DL_Init_CheckBox(DUF_HealthBarOptions_ResizeMax, settings.resizemax);
	DL_Init_CheckBox(DUF_HealthBarOptions_InCombat, settings.incombat);
	DL_Init_CheckBox(DUF_HealthBarOptions_HealthUpdating, settings.healthupdating);
	DL_Init_CheckBox(DUF_HealthBarOptions_ManaUpdating, settings.manaupdating);
	DL_Init_EditBox(DUF_HealthBarOptions_CustomTexture, settings.customtexture);
	DL_Init_EditBox(DUF_HealthBarOptions_CustomTexture2, settings.customtexture2);
	DL_Init_MenuControl(DUF_HealthBarOptions_Direction, settings.direction);
end

function DUF_Init_IconOptions()
	local settings = DUF_Options_GetAllSettings();
	if (DUF_ELEMENT_INDEX == "RaceIcon" or DUF_ELEMENT_INDEX == "RankIcon") then
		DUF_IconOptions_TargetIcon:Show()
	else
		DUF_IconOptions_TargetIcon:Hide()
	end
	DL_Init_Slider(DUF_IconOptions_Size, settings.size);
	DL_Init_CheckBox(DUF_IconOptions_Circle, settings.circle);
	DL_Init_CheckBox(DUF_IconOptions_TargetIcon, settings.targetIcon);
end

function DUF_Init_WarlockDemoBarOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_WarlockDemonicBarOptions_Height, settings.height);
	DL_Init_Slider(DUF_WarlockDemonicBarOptions_Width, settings.width);
	DL_Init_ColorPicker(DUF_WarlockDemonicBarOptions_Color, settings.color);
	DL_Init_ColorPicker(DUF_WarlockDemonicBarOptions_SecondaryColor, settings.color2);
	DL_Init_CheckBox(DUF_WarlockDemonicBarOptions_Fill, settings.fill);
	DL_Init_CheckBox(DUF_WarlockDemonicBarOptions_Fade, settings.fade);
	DL_Init_CheckBox(DUF_WarlockDemonicBarOptions_ResizeMax, settings.resizemax);
	DL_Init_CheckBox(DUF_WarlockDemonicBarOptions_InCombat, settings.incombat);
	DL_Init_CheckBox(DUF_WarlockDemonicBarOptions_HealthUpdating, settings.healthupdating);
	DL_Init_CheckBox(DUF_WarlockDemonicBarOptions_ManaUpdating, settings.manaupdating);
	DL_Init_EditBox(DUF_WarlockDemonicBarOptions_CustomTexture, settings.customtexture);
	DL_Init_EditBox(DUF_WarlockDemonicBarOptions_CustomTexture2, settings.customtexture2);
	DL_Init_MenuControl(DUF_WarlockDemonicBarOptions_Direction, settings.direction);
end
function DUF_Init_ManaBarOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_ManaBarOptions_Height, settings.height);
	DL_Init_Slider(DUF_ManaBarOptions_Width, settings.width);
	DL_Init_ColorPicker(DUF_ManaBarOptions_ManaColor, settings.manacolor);
	DL_Init_ColorPicker(DUF_ManaBarOptions_RageColor, settings.ragecolor);
	DL_Init_ColorPicker(DUF_ManaBarOptions_FocusColor, settings.focuscolor);
	DL_Init_ColorPicker(DUF_ManaBarOptions_EnergyColor, settings.energycolor);
	DL_Init_ColorPicker(DUF_ManaBarOptions_SecondaryColor, settings.color2);
	DL_Init_ColorPicker(DUF_ManaBarOptions_RunicPowerColor, settings.runicpowercolor);
	DL_Init_CheckBox(DUF_ManaBarOptions_Fill, settings.fill);
	DL_Init_CheckBox(DUF_ManaBarOptions_Fade, settings.fade);
	DL_Init_CheckBox(DUF_ManaBarOptions_InCombat, settings.incombat);
	DL_Init_CheckBox(DUF_ManaBarOptions_HealthUpdating, settings.healthupdating);
	DL_Init_CheckBox(DUF_ManaBarOptions_ManaUpdating, settings.manaupdating);
	DL_Init_CheckBox(DUF_ManaBarOptions_HideIfNoMana, settings.hideifnomana);
	DL_Init_CheckBox(DUF_ManaBarOptions_ResizeMax, settings.resizemax);
	DL_Init_EditBox(DUF_ManaBarOptions_CustomTexture, settings.customtexture);
	DL_Init_EditBox(DUF_ManaBarOptions_CustomTexture2, settings.customtexture2);
	DL_Init_MenuControl(DUF_ManaBarOptions_Direction, settings.direction);
end

function DUF_Init_DruidManaBarOptions() 
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_DruidManaBarOptions_Height, settings.height);
	DL_Init_Slider(DUF_DruidManaBarOptions_Width, settings.width);
	DL_Init_ColorPicker(DUF_DruidManaBarOptions_ManaColor, settings.manacolor);
	DL_Init_ColorPicker(DUF_DruidManaBarOptions_SecondaryColor, settings.color2);
	DL_Init_CheckBox(DUF_DruidManaBarOptions_Fill, settings.fill);
	DL_Init_CheckBox(DUF_DruidManaBarOptions_Fade, settings.fade);
	DL_Init_CheckBox(DUF_DruidManaBarOptions_InCombat, settings.incombat);
	DL_Init_CheckBox(DUF_DruidManaBarOptions_HealthUpdating, settings.healthupdating);
	DL_Init_CheckBox(DUF_DruidManaBarOptions_ManaUpdating, settings.manaupdating);
	DL_Init_CheckBox(DUF_DruidManaBarOptions_HideIfNoMana, settings.hideifnomana);
	DL_Init_CheckBox(DUF_DruidManaBarOptions_ResizeMax, settings.resizemax);
	DL_Init_EditBox(DUF_DruidManaBarOptions_CustomTexture, settings.customtexture);
	DL_Init_EditBox(DUF_DruidManaBarOptions_CustomTexture2, settings.customtexture2);
	DL_Init_MenuControl(DUF_DruidManaBarOptions_Direction, settings.direction);
end

function DUF_Init_MiscOptions()
	DL_Init_CheckBox(DUF_MiscOptions_HidePartyInRaid, DUF_Settings[DUF_INDEX].hidepartyinraid);
	DL_Init_CheckBox(DUF_MiscOptions_HideTargetTarget, DUF_Settings[DUF_INDEX].hidetargettarget);
	DL_Init_CheckBox(DUF_MiscOptions_HideBuffFrame, DUF_Settings[DUF_INDEX].hidebuffframe);
	DL_Init_Slider(DUF_MiscOptions_UpdateSpeed, DUF_Settings[DUF_INDEX].updatespeedbase);
	DL_Init_CheckBox(DUF_MiscOptions_LimitDurationUpdates, DUF_Settings[DUF_INDEX].limitdurationupdates); 
	DL_Init_CheckBox(DUF_MiscOptions_CustomPaths, DUF_Settings[DUF_INDEX].custompaths); 
	DL_Init_EditBox(DUF_MiscOptions_LowHealthThreshold, DUF_Settings[DUF_INDEX].flashthreshold);
	DL_Init_MenuControl(DUF_MiscOptions_OptionsScale, DUF_Settings[DUF_INDEX].optionscale);
end

function DUF_Init_PortraitOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_PortraitOptions_Size, settings.size);
	DL_Init_CheckBox(DUF_PortraitOptions_UseClassTexture, settings.useclass);
	DL_Init_CheckBox(DUF_PortraitOptions_ShowBorder, settings.showborder);
	DL_Init_CheckBox(DUF_PortraitOptions_Use3DPortrait, settings.use3D);
	DL_Init_CheckBox(DUF_PortraitOptions_Use3DFace, settings.use3Dface);
	DL_Init_ColorPicker(DUF_PortraitOptions_BorderColor, settings.bordcolor);
end

function DUF_Init_TextBoxOptions()
	local settings = DUF_Options_GetAllSettings();
	if (not settings) then return; end
	DL_Init_Slider(DUF_TextBoxOptions_Height, settings.height);
	DL_Init_Slider(DUF_TextBoxOptions_Width, settings.width);
	DL_Init_EditBox(DUF_TextBoxOptions_Text, settings.text);
	DL_Init_EditBox(DUF_TextBoxOptions_Label, settings.label);
	DL_Init_EditBox(DUF_TextBoxOptions_MaxCharacters, settings.maxcharacters);
	DL_Init_MenuControl(DUF_TextBoxOptions_JustifyH, settings.justify);
	DL_Init_MenuControl(DUF_TextBoxOptions_JustifyV, settings.justifyV);
	DL_Init_MenuControl(DUF_TextBoxOptions_TextOutline, settings.outline);
	DL_Init_EditBox(DUF_TextBoxOptions_Font, settings.font);
	DL_Init_ColorPicker(DUF_TextBoxOptions_Color, settings.textcolor);
	DL_Init_Slider(DUF_TextBoxOptions_FontHeight, settings.textheight);
	DL_Init_CheckBox(DUF_TextBoxOptions_HideIfNoMana, settings.hideifnomana);
	DL_Init_CheckBox(DUF_TextBoxOptions_HideIfNoText, settings.hideifnotext);
	DL_Init_CheckBox(DUF_TextBoxOptions_InCombat, settings.incombat);
	DL_Init_CheckBox(DUF_TextBoxOptions_HealthUpdating, settings.healthupdating);
	DL_Init_CheckBox(DUF_TextBoxOptions_ManaUpdating, settings.manaupdating);
	DL_Init_CheckBox(DUF_TextBoxOptions_VerticalText, settings.verttext);
end

function DUF_Init_XPBarOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_XPBarOptions_Height, settings.height);
	DL_Init_Slider(DUF_XPBarOptions_Width, settings.width);
	DL_Init_ColorPicker(DUF_XPBarOptions_Color, settings.color);
	DL_Init_ColorPicker(DUF_XPBarOptions_SecondaryColor, settings.color2);
	DL_Init_EditBox(DUF_XPBarOptions_CustomTexture, settings.customtexture);
	DL_Init_EditBox(DUF_XPBarOptions_CustomTexture2, settings.customtexture2);
	DL_Init_MenuControl(DUF_XPBarOptions_Direction, settings.direction);
	DL_Init_CheckBox(DUF_XPBarOptions_Reputation, settings.trackRep);
	if (DUF_FRAME_INDEX == "player") then
		DUF_XPBarOptions_Reputation:Show()
	else
		DUF_XPBarOptions_Reputation:Hide()
	end
end

function DUF_Init_CastBarOptions()
	local settings = DUF_Options_GetAllSettings();
	DL_Init_Slider(DUF_CastBarOptions_Height, settings.height);
	DL_Init_Slider(DUF_CastBarOptions_Width, settings.width);
	DL_Init_ColorPicker(DUF_CastBarOptions_ManaColor, settings.manacolor);
	DL_Init_ColorPicker(DUF_CastBarOptions_RageColor, settings.ragecolor);
	DL_Init_ColorPicker(DUF_CastBarOptions_FocusColor, settings.focuscolor);
	DL_Init_ColorPicker(DUF_CastBarOptions_EnergyColor, settings.energycolor);
	DL_Init_ColorPicker(DUF_CastBarOptions_SecondaryColor, settings.color2);
	DL_Init_CheckBox(DUF_CastBarOptions_Fill, settings.fill);
	DL_Init_CheckBox(DUF_CastBarOptions_Fade, settings.fade);
	DL_Init_CheckBox(DUF_CastBarOptions_InCombat, settings.incombat);
	DL_Init_CheckBox(DUF_CastBarOptions_HealthUpdating, settings.healthupdating);
	DL_Init_CheckBox(DUF_CastBarOptions_ManaUpdating, settings.manaupdating);
	DL_Init_CheckBox(DUF_CastBarOptions_HideIfNoMana, settings.hideifnomana);
	DL_Init_CheckBox(DUF_CastBarOptions_ResizeMax, settings.resizemax);
	DL_Init_EditBox(DUF_CastBarOptions_CustomTexture, settings.customtexture);
	DL_Init_EditBox(DUF_CastBarOptions_CustomTexture2, settings.customtexture2);
	DL_Init_MenuControl(DUF_CastBarOptions_Direction, settings.direction);
end


function DUF_Menu_OnClick(self)
	_G[DUF_DropMenu.controlbox]:SetText(_G[self:GetName().."_Text"]:GetText());
	DUF_DropMenu:Hide();
	if (DUF_DropMenu.index == "attach") then
		if (self.value and DUF_FRAME_DATA[DUF_FRAME_INDEX] and _G[DUF_FRAME_DATA[DUF_FRAME_INDEX].frame..self.value]) then
			local otherindex = _G[DUF_FRAME_DATA[DUF_FRAME_INDEX].frame..self.value].index;
			local othersubindex = _G[DUF_FRAME_DATA[DUF_FRAME_INDEX].frame..self.value].subindex;
			local otherattach;
			if (othersubindex) then
				otherattach = DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX][otherindex][othersubindex].attach;
			else
				otherattach = DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX][otherindex].attach;
			end
			otherattach = DUF_FRAME_DATA[DUF_FRAME_INDEX].frame..otherattach;
			local elemext = "_"..DUF_ELEMENT_INDEX;
			if (DUF_ELEMENT_SUBINDEX) then
				if (DUF_ELEMENT_INDEX == "StatusBar") then
					elemext = DUF_STATUSBARS[DUF_ELEMENT_SUBINDEX];
				elseif (DUF_ELEMENT_INDEX == "TextBox") then
					elemext = "_TextBox_"..DUF_ELEMENT_SUBINDEX;
				end
			end
			local element = DUF_FRAME_DATA[DUF_FRAME_INDEX].frame..elemext;
			if (element == otherattach ) then
				-- DL_Debug("That element is already attached to self element.  Cross-attaching the elements will crash WoW.  Attach option not applied.");
				return;
			end
		end
	end
	if (DUF_DropMenu.index) then
		DUF_Update_Setting(self.value, DUF_DropMenu.index);
	end
	DUF_Run_Functions(self, DUF_DropMenu.initFunc);
end

function DUF_Nudge_Down(self, button)
	local yoffset = DUF_Options_GetSetting("yoffset");
	if (button == "RightButton") then
		yoffset = yoffset - 10;
	elseif (self.moving) then
		yoffset = yoffset - 3;
	else
		yoffset = yoffset - 1;
	end
	DUF_ElementOptions_Base_YOffset:SetText(yoffset);
	DUF_Update_Setting(yoffset, "yoffset");
	DUF_Run_Functions(self);
end

function DUF_Nudge_Left(self, button)
	local xoffset = DUF_Options_GetSetting("xoffset");
	if (button == "RightButton") then
		xoffset = xoffset - 10;
	elseif (self.moving) then
		xoffset = xoffset - 3;
	else
		xoffset = xoffset - 1;
	end
	DUF_ElementOptions_Base_XOffset:SetText(xoffset);
	DUF_Update_Setting(xoffset, "xoffset");
	DUF_Run_Functions(self);
end

function DUF_Nudge_OnUpdate(self, elapsed)
	if (not self.timer) then
		self.timer = .05;
	end
	self.timer = self.timer - elapsed;
	if (self.timer < 0) then
		self.timer = .05;
		if (self.moving) then
			self.func(self);
		end
	end
end

function DUF_Nudge_Right(self, button)
	local xoffset = DUF_Options_GetSetting("xoffset");
	if (button == "RightButton") then
		xoffset = xoffset + 10;
	elseif (self.moving) then
		xoffset = xoffset + 3;
	else
		xoffset = xoffset + 1;
	end
	DUF_ElementOptions_Base_XOffset:SetText(xoffset);
	DUF_Update_Setting(xoffset, "xoffset");
	DUF_Run_Functions(self);
end

function DUF_Nudge_Up(self, button)
	local yoffset = DUF_Options_GetSetting("yoffset");
	if (button == "RightButton") then
		yoffset = yoffset + 10;
	elseif (self.moving) then
		yoffset = yoffset + 3;
	else
		yoffset = yoffset + 1;
	end
	DUF_ElementOptions_Base_YOffset:SetText(yoffset);
	DUF_Update_Setting(yoffset, "yoffset");
	DUF_Run_Functions(self);
end

function DUF_UnitFrame_Nudge_Up(self, button)
	local index = tonumber(DUF_FrameOptions_FrameChooser_Setting:GetText())
	local yoffset = DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].yos[index]
	if (button == "RightButton") then
		yoffset = yoffset + 10;
	elseif (self.moving) then
		yoffset = yoffset + 3;
	else
		yoffset = yoffset + 1;
	end
	DUF_FrameOptions_YOffset:SetText(yoffset);
	DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].yos[index] = yoffset
	if (string.find(DUF_FRAME_INDEX, "party")) then
		DUF_Initialize_FrameLoc(DUF_FRAME_INDEX..index)
	else
		DUF_Initialize_FrameLoc(DUF_FRAME_INDEX)
	end
end

function DUF_UnitFrame_Nudge_Down(self, button)
	local index = tonumber(DUF_FrameOptions_FrameChooser_Setting:GetText())
	local yoffset = DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].yos[index]
	if (button == "RightButton") then
		yoffset = yoffset - 10;
	elseif (self.moving) then
		yoffset = yoffset - 3;
	else
		yoffset = yoffset - 1;
	end
	DUF_FrameOptions_YOffset:SetText(yoffset);
	DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].yos[index] = yoffset
	if (string.find(DUF_FRAME_INDEX, "party")) then
		DUF_Initialize_FrameLoc(DUF_FRAME_INDEX..index)
	else
		DUF_Initialize_FrameLoc(DUF_FRAME_INDEX)
	end
end

function DUF_UnitFrame_Nudge_Left(self, button)
	local index = tonumber(DUF_FrameOptions_FrameChooser_Setting:GetText())
	local xoffset = DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].xos[index]
	if (button == "RightButton") then
		xoffset = xoffset - 10;
	elseif (self.moving) then
		xoffset = xoffset - 3;
	else
		xoffset = xoffset - 1;
	end
	DUF_FrameOptions_XOffset:SetText(xoffset);
	DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].xos[index] = xoffset
	if (string.find(DUF_FRAME_INDEX, "party")) then
		DUF_Initialize_FrameLoc(DUF_FRAME_INDEX..index)
	else
		DUF_Initialize_FrameLoc(DUF_FRAME_INDEX)
	end
end

function DUF_UnitFrame_Nudge_Right(self, button)
	local index = tonumber(DUF_FrameOptions_FrameChooser_Setting:GetText())
	local xoffset = DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].xos[index]
	if (button == "RightButton") then
		xoffset = xoffset + 10;
	elseif (self.moving) then
		xoffset = xoffset + 3;
	else
		xoffset = xoffset + 1;
	end
	DUF_FrameOptions_XOffset:SetText(xoffset);
	DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].xos[index] = xoffset
	if (string.find(DUF_FRAME_INDEX, "party")) then
		DUF_Initialize_FrameLoc(DUF_FRAME_INDEX..index)
	else
		DUF_Initialize_FrameLoc(DUF_FRAME_INDEX)
	end
end

function DUF_Options_UpdateFrameLoc()
	local index = tonumber(DUF_FrameOptions_FrameChooser_Setting:GetText())
	local yoffset = DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].yos[index]
	local xoffset = DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].xos[index]
	DUF_FrameOptions_YOffset:SetText(yoffset)
	DUF_FrameOptions_XOffset:SetText(xoffset)
end

function DUF_Options_DeleteSettings(index)
	if (not index) then
		index = DUF_LOADINDEX;
	end
	if (index == "" or (not index)) then
		return;
	end
	if (index == DUF_INDEX) then
		DL_Error("You cannot delete the profile you're currently using.");
		return;
	end
	if (not DUF_Settings[index]) then
		DL_Feedback(DUF_TEXT.NoSettingsFound);
		return;
	end
	DUF_Settings[index] = nil;
	DUF_Update_SavedSettings();
	DUF_MiscOptions_LoadSettings_Setting:SetText("");
	DL_Feedback(DUF_TEXT.SettingsDeleted);
end

function DUF_Options_FrameLevelMinus(self)
	local level = DUF_Options_GetSetting("framelevel");
	level = level - 1;
	DUF_Update_Setting(level, "framelevel");
	DL_Init_EditBox(DUF_ElementOptions_Base_FrameLevel, level);
	DUF_Run_Functions(self, DUF_ElementOptions_Base_FrameLevel.initFunc);
end

function DUF_Options_FrameLevelPlus(self)
	local level = DUF_Options_GetSetting("framelevel");
	level = level + 1;
	DUF_Update_Setting(level, "framelevel");
	DL_Init_EditBox(DUF_ElementOptions_Base_FrameLevel, level);
	DUF_Run_Functions(self, DUF_ElementOptions_Base_FrameLevel.initFunc);
end

function DUF_Options_GetAllSettings()
	if (DUF_ELEMENT_SUBINDEX) then
		return DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX][DUF_ELEMENT_INDEX][DUF_ELEMENT_SUBINDEX];
	elseif (DUF_ELEMENT_INDEX) then
		return DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX][DUF_ELEMENT_INDEX];
	else
		return DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX];
	end
end

function DUF_Options_GetSetting(index)
	if (not DUF_FRAME_INDEX) then
		return DUF_Settings[DUF_INDEX][index];
	end
	if (DUF_ELEMENT_SUBINDEX) then
		return DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX][DUF_ELEMENT_INDEX][DUF_ELEMENT_SUBINDEX][index];
	elseif (DUF_ELEMENT_INDEX) then
		return DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX][DUF_ELEMENT_INDEX][index];
	else
		return DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX][index];
	end
end

function DUF_Options_OnHide(self)
	DUF_OPTIONS_VISIBLE = nil;
	DUF_Initialize_AllFrames(self);
	for unit, value in pairs(DUF_FRAME_DATA) do
		if (not DUF_Settings[DUF_INDEX][value.index].hide) then
      			local frame = _G[value.frame];
			DUF_SetFrameUnitWatch(frame, true)
		end
	end
	DUF_Main_UpdatePartyMembers();

	if (DUF_Settings[DUF_INDEX].autolock) then
		if (DUF_FRAMES_UNLOCKED) then
			DUF_Toggle_FramesLock();
		end
		if (DUF_ELEMENTS_UNLOCKED) then
			DUF_Toggle_ElementsLock();
		end
	end
end

function DUF_Options_OnShow(self)
	if (not DUF_INITIALIZED) then return; end
	DUF_OPTIONS_VISIBLE = true;
	DUF_Initialize_AllFrames(self);
	DUF_Options_ShowFrames()
end

function DUF_Options_ShowFrames()
	for unit, value in pairs(DUF_FRAME_DATA) do
		if (not DUF_Settings[DUF_INDEX][value.index].hide) then
			local frame = _G[value.frame]
			DUF_SetFrameUnitWatch(frame, false)
			frame:Show()
		end
	end
end

function DUF_Options_OnUpdate(self)
	if (not DUF_INITIALIZED) then return; end
	if (not self.scale) then
		self.scale = self:GetScale();
	end
	if (self.scale ~= self:GetScale()) then
		DUF_Options:SetScale(DUF_Settings[DUF_INDEX].optionscale);
		self.scale = self:GetScale();
	end
end

function DUF_Options_ResetIndices()
	if (DUF_OLD_ELEM_SUBINDEX) then
		DUF_ELEMENT_SUBINDEX = DUF_OLD_ELEM_SUBINDEX;
		DUF_OLD_ELEM_SUBINDEX = nil;
	end
	if (DUF_OLD_ELEM_INDEX) then
		DUF_ELEMENT_INDEX = DUF_OLD_ELEM_INDEX;
		DUF_OLD_ELEM_INDEX = nil;
	end
	if (DUF_OLD_FRAME_INDEX) then
		DUF_FRAME_INDEX = DUF_OLD_FRAME_INDEX;
		DUF_OLD_FRAME_INDEX = nil;
	end
end

function DUF_Options_SaveSettings(index)
	if (not index) then
		index = DUF_MiscOptions_SaveSettings:GetText();
	end
	DUF_MiscOptions_SaveSettings:ClearFocus();
	DUF_MiscOptions_SaveSettings:SetText("");
	if (index == "" or (not index)) then
		return;
	end
	if (DUF_Settings[index]) then
		DL_Error("You are attempting to create a new profile using the same name as an existing profile.  You must delete the existing profile first.");
		return;
	end
	DUF_Settings[index] = {};
	DL_Copy_Table(DUF_Settings[DUF_INDEX], DUF_Settings[index]);
	DUF_INDEX = index;
	DUF_Settings[DUF_PLAYER_INDEX] = index;
	DUF_Update_SavedSettings();
	DL_Feedback(DUF_TEXT.ProfileCreated);
end

function DUF_Options_SelectFrameOptions()
	DUF_Options_ResetIndices();
	DUF_MiscOptions:Hide();
	DUF_ColorContextOptions:Hide();
	DUF_ElementOptions:Hide();
	if (DUF_ELEMENT_SELECTED) then
		local button = _G[DUF_ELEMENT_SELECTED];
		button:SetNormalFontObject(GameFontNormal);		
		button:GetNormalFontObject():SetTextColor(1, 1, 0);
		button:SetBackdropColor(0, 0, 0);
		button:SetBackdropBorderColor(.8, 0, 0);
	end
	DUF_ELEMENT_INDEX = nil;
	DUF_ELEMENT_SUBINDEX = nil;
	DUF_ELEMENT_SELECTED = "DUF_Options_FrameOptions";
	DUF_Options_FrameOptions:SetNormalFontObject(GameFontNormal);
	DUF_Options_FrameOptions:GetNormalFontObject():SetTextColor(1, 0, 0);
	DUF_Options_FrameOptions:SetBackdropColor(1, 1, 0);
	DUF_Options_FrameOptions:SetBackdropBorderColor(1, 1, 1);
end

function DUF_Options_SetLoadIndex()
	DUF_LOADINDEX = DUF_MiscOptions_LoadSettings_Setting:GetText();
end

function DUF_Options_SetOldIndices()
	if (not DUF_OLD_ELEM_INDEX) then
		DUF_OLD_ELEM_INDEX = DUF_ELEMENT_INDEX;
	end
	DUF_ELEMENT_INDEX = nil;
	if (not DUF_OLD_ELEM_SUBINDEX) then
		DUF_OLD_ELEM_SUBINDEX = DUF_ELEMENT_SUBINDEX;
	end
	DUF_ELEMENT_SUBINDEX = nil;
	if (not DUF_OLD_FRAME_INDEX) then
		DUF_OLD_FRAME_INDEX = DUF_FRAME_INDEX;
	end
	DUF_FRAME_INDEX = nil;
end

function DUF_Options_SetScale()
	DUF_Options:SetScale(DUF_Settings[DUF_INDEX].optionscale);
	DUF_Options.scale = DUF_Options:GetScale();
	DUF_Options:ClearAllPoints();
	DUF_Options:SetPoint("CENTER", "UIParent", "CENTER", 0, 0);
end

function DUF_OptionsSelect_OnClick(self)
	if (DUF_OPTIONS_SELECTED) then
		local button = _G[DUF_OPTIONS_SELECTED];
		button:SetNormalFontObject(GameFontNormal);		
		button:GetNormalFontObject():SetTextColor(1, 1, 0);
		button:SetBackdropColor(0, 0, 0);
		button:SetBackdropBorderColor(.8, 0, 0);
	end
	DUF_OPTIONS_SELECTED = self:GetName();
	self:SetNormalFontObject(GameFontNormal);	
	self:GetNormalFontObject():SetTextColor(1, 0, 0);
	self:SetBackdropColor(1, 1, 0);
	self:SetBackdropBorderColor(1, 1, 1);
end

function DUF_Run_Functions(self, initFunc)
	if (not DUF_INITIALIZED) then return; end
	if (not initFunc) then
		initFunc = self:GetParent().initFunc;
	end
	if (not initFunc) then
		initFunc = self.initFunc;
	end
	if (initFunc) then
		if (DUF_INIT_FRAMES) then
			for _,unit in pairs(DUF_INIT_FRAMES) do
				initFunc(self, unit, DUF_ELEMENT_SUBINDEX);
			end
		else
			initFunc(self);
		end
	end
end

function DUF_SelectButton_OnLoad(self, passive)
	self:SetNormalFontObject(GameFontNormal);	
	self:GetNormalFontObject():SetTextColor(1, 1, 0);
	self:SetBackdropColor(0, 0, 0);
	self:SetBackdropBorderColor(.8, 0, 0);
end

function DUF_SelectElement_OnClick(self, index, subindex)
	DUF_Options_ResetIndices();
	DUF_MiscOptions:Hide();
	DUF_ColorContextOptions:Hide();
	if (DUF_ELEMENT_SELECTED) then
		local button = _G[DUF_ELEMENT_SELECTED];
		button:SetNormalFontObject(GameFontNormal);		
		button:GetNormalFontObject():SetTextColor(1, 1, 0);
		button:SetBackdropColor(0, 0, 0);
		button:SetBackdropBorderColor(.8, 0, 0);
	end
	DUF_ELEMENT_SELECTED = self:GetName();
	self:SetNormalFontObject(GameFontNormal);	
	self:GetNormalFontObject():SetTextColor(1, 0, 0);
	self:SetBackdropColor(1, 1, 0);
	self:SetBackdropBorderColor(1, 1, 1);
	DUF_ELEMENT_INDEX = index;
	DUF_ELEMENT_SUBINDEX = subindex;
	if (DUF_ELEMENT_INDEX) then
		DUF_ElementOptions:Show();
		DUF_FrameOptions:Hide();
		DUF_Init_BaseOptions();
		DUF_Show_SpecialOptions();
	else
		DUF_ElementOptions:Hide();
		DUF_FrameOptions:Show();
		DUF_Init_FrameOptions();
	end
end

function DUF_SelectFrame_OnClick(self, index, bttn)
	if (not bttn) then
		bttn = self
	end
	DUF_Options_ResetIndices();
	DUF_MiscOptions:Hide();
	DUF_ColorContextOptions:Hide();
	if (DUF_FRAME_SELECTED) then
		local button = _G[DUF_FRAME_SELECTED];
		button:SetNormalFontObject(GameFontNormal);
		button:GetNormalFontObject():SetTextColor(1, 1, 0);
		button:SetBackdropColor(0, 0, 0);
		button:SetBackdropBorderColor(.8, 0, 0);
	end
	DUF_FRAME_SELECTED = bttn:GetName();
	bttn:SetNormalFontObject(GameFontNormal);	
	bttn:GetNormalFontObject():SetTextColor(1, 0, 0);
	bttn:SetBackdropColor(1, 1, 0);
	bttn:SetBackdropBorderColor(1, 1, 1);
	DUF_FRAME_INDEX = index;
	DUF_INIT_FRAMES = { index };
	DUF_SetMenu(nil)
	DUF_Options_ComboPoints:Hide();
	DUF_Options_XPBar:Hide();
	DUF_Options_HonorBar:Hide();
	DUF_Options_EliteTexture:Hide();
	DUF_MiscOptions:Hide();
	DUF_Options_ClassProperties:Hide();
	DUF_Options_GeneralProperties:Hide();
	DUF_ColorContextOptions:Hide();
	if (index == "party") then
		DUF_INIT_FRAMES = { "party1", "party2", "party3", "party4" };
	elseif (index == "partypet") then
		DUF_INIT_FRAMES = { "partypet1", "partypet2", "partypet3", "partypet4" };
	elseif (index == "player") then
		DUF_Options_XPBar:Show();
		DUF_Options_HonorBar:Show();
		DUF_Options_ClassProperties:Show();
	elseif (index == "pet") then
		DUF_Options_XPBar:Show();
	elseif (index == "target") then
		DUF_Options_ComboPoints:Show();
		DUF_Options_EliteTexture:Show();
	end
	if (index == "party" or index == "partypet") then
		DUF_FRAME_CHOICES = {
			{value = 1, text = 1},
			{value = 2, text = 2},
			{value = 3, text = 3},
			{value = 4, text = 4}
		}
	else
		DUF_FRAME_CHOICES = {
			{value = 1, text = 1}
		}
	end
	if (DUF_ELEMENT_INDEX == "StatusBar" and DUF_ELEMENT_SUBINDEX == 3 and DUF_FRAME_INDEX ~= "player" and DUF_FRAME_INDEX ~= "pet") then
		DUF_Options_SelectFrameOptions();
	elseif (DUF_ELEMENT_INDEX == "StatusBar" and (DUF_ELEMENT_SUBINDEX == 6 or DUF_ELEMENT_SUBINDEX == 8) and DUF_FRAME_INDEX ~= "player") then -- Druid Mana is DUF_ELEMENT_SUBINDEX 8
		DUF_Options_SelectFrameOptions();
	elseif ((DUF_ELEMENT_INDEX == "TempEnchants" or DUF_ELEMENT_INDEX == "MonkHarmony" or DUF_ELEMENT_INDEX == "PalyPowerFrame" or DUF_ELEMENT_INDEX == "PriestOrbFrame" or DUF_ELEMENT_INDEX == "RuneFrame"or DUF_ELEMENT_INDEX == "WarlockPowerFrame") and DUF_FRAME_INDEX ~= "player") then
		DUF_Options_SelectFrameOptions();
	elseif (DUF_ELEMENT_INDEX == "ComboPoints" and DUF_FRAME_INDEX ~= "target") then
		DUF_Options_SelectFrameOptions();
	elseif (DUF_ELEMENT_INDEX == "EliteTexture" and DUF_FRAME_INDEX ~= "target") then
		DUF_Options_SelectFrameOptions();
	end
	DUF_Show_SpecialOptions();
	if (DUF_ELEMENT_INDEX) then
		DUF_Init_BaseOptions();
	else
		DUF_Init_FrameOptions();
	end
	for i = 1,10 do
		_G["DUF_Options_TextBox"..i]:SetText("["..i.."] "..DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX].TextBox[i].label);
	end
end

function DUF_SetCopyFrame(self)
	DUF_FrameOptions_CopyButton.index = self.value;
	DUF_FrameOptions_SafeCopyButton.index = self.value;
end

function DUF_Show_ContextColors()
	DUF_MiscOptions:Hide();
	DUF_ColorContextOptions:Show();
	DUF_ElementOptions:Hide();
	DUF_FrameOptions:Hide();
	DUF_Options_SetOldIndices();
end

function DUF_Show_MiscOptions()
	DUF_MiscOptions:Show();
	DUF_ColorContextOptions:Hide();
	DUF_ElementOptions:Hide();
	DUF_FrameOptions:Hide();
	DUF_Options_SetOldIndices();
end

function DUF_Show_SpecialOptions()
	if (DUF_SPECIAL_OPTIONS) then
		_G[DUF_SPECIAL_OPTIONS]:Hide();
	end
	if (DUF_ELEMENT_INDEX == "StatusBar") then
		if (DUF_ELEMENT_SUBINDEX == 1 or DUF_ELEMENT_SUBINDEX == 4) then
			DUF_SPECIAL_OPTIONS = "DUF_HealthBarOptions";
			DUF_Init_HealthBarOptions();
		elseif (DUF_ELEMENT_SUBINDEX == 2 or DUF_ELEMENT_SUBINDEX == 5) then
			DUF_SPECIAL_OPTIONS = "DUF_ManaBarOptions";
			DUF_Init_ManaBarOptions();
		elseif (DUF_ELEMENT_SUBINDEX == 6 or DUF_ELEMENT_SUBINDEX == 3) then
			DUF_SPECIAL_OPTIONS = "DUF_XPBarOptions";
			DUF_Init_XPBarOptions();
		elseif(DUF_ELEMENT_SUBINDEX == 7)  then
			DUF_SPECIAL_OPTIONS = "DUF_CastBarOptions";
			DUF_Init_CastBarOptions();
		elseif (DUF_ELEMENT_SUBINDEX == 8) then 
			DUF_SPECIAL_OPTIONS = "DUF_DruidManaBarOptions";
			DUF_Init_DruidManaBarOptions();
		elseif (DUF_ELEMENT_SUBINDEX == 9) then 
			DUF_SPECIAL_OPTIONS = "DUF_WarlockDemonicBarOptions";
			DUF_Init_WarlockDemoBarOptions();
		end
	elseif (DUF_ELEMENT_INDEX == "StatusIcon" or DUF_ELEMENT_INDEX == "RankIcon" or DUF_ELEMENT_INDEX == "RaceIcon" or DUF_ELEMENT_INDEX == "PVPIcon" or DUF_ELEMENT_INDEX == "LootIcon" or DUF_ELEMENT_INDEX == "LeaderIcon" or DUF_ELEMENT_INDEX == "RoleIcon") then
		DUF_SPECIAL_OPTIONS = "DUF_IconOptions";
		DUF_Init_IconOptions();
	elseif (DUF_ELEMENT_INDEX == "Portrait") then
		DUF_SPECIAL_OPTIONS = "DUF_PortraitOptions";
		DUF_Init_PortraitOptions();
	elseif (DUF_ELEMENT_INDEX == "ClassIcon") then
		DUF_SPECIAL_OPTIONS = "DUF_ClassIconOptions";
		DUF_Init_ClassIconOptions();
	elseif (DUF_ELEMENT_INDEX == "VoiceIcon") then
		DUF_SPECIAL_OPTIONS = "DUF_VoiceIconOptions";
		DUF_Init_VoiceIconOptions();
	elseif (DUF_ELEMENT_INDEX == "TextBox") then
		DUF_SPECIAL_OPTIONS = "DUF_TextBoxOptions";
		DUF_Init_TextBoxOptions();
	elseif (DUF_ELEMENT_INDEX == "ComboPoints") then
		DUF_SPECIAL_OPTIONS = "DUF_ComboPointsOptions";
		DUF_Init_ComboPointsOptions();
	elseif (DUF_ELEMENT_INDEX == "Buffs") then
		DUF_SPECIAL_OPTIONS = "DUF_BuffOptions";
		DUF_Init_BuffOptions();
	elseif (DUF_ELEMENT_INDEX == "Debuffs") then
		DUF_SPECIAL_OPTIONS = "DUF_DebuffOptions";
		DUF_Init_DebuffOptions();
	elseif (DUF_ELEMENT_INDEX == "EliteTexture") then
		DUF_SPECIAL_OPTIONS = "DUF_EliteTextureOptions";
		DUF_Init_EliteTextureOptions();
	elseif (not DUF_ELEMENT_INDEX) then
		DUF_SPECIAL_OPTIONS = "DUF_FrameOptions";
		DUF_FrameOptions:Show();
		DUF_Init_FrameOptions();
	elseif (DUF_ELEMENT_INDEX == "TempEnchants") then
		DUF_SPECIAL_OPTIONS = "DUF_TempEnchantOptions";
		DUF_Init_TempEnchantOptions();
	elseif (DUF_ELEMENT_INDEX == "MonkHarmony") then
		DUF_SPECIAL_OPTIONS = "DUF_MonkHarmonyOptions";
		DUF_Init_MonkHarmonyOptions();
	elseif (DUF_ELEMENT_INDEX == "PalyPowerFrame") then
		DUF_SPECIAL_OPTIONS = "DUF_PalyPowerFrameOptions";
		DUF_Init_PalyPowerFrameOptions();
	elseif (DUF_ELEMENT_INDEX == "PriestOrbFrame") then
		DUF_SPECIAL_OPTIONS = "DUF_PriestOrbFrameOptions";
		DUF_Init_PriestOrbFrameOptions();
	elseif (DUF_ELEMENT_INDEX == "RuneFrame") then
		DUF_SPECIAL_OPTIONS = "DUF_RuneFrameOptions";
		DUF_Init_RuneFrameOptions();
	elseif (DUF_ELEMENT_INDEX == "WarlockPowerFrame") then
		DUF_SPECIAL_OPTIONS = "DUF_WarlockPowerFrameOptions";
		DUF_Init_WarlockPowerFrameOptions();
	end
	if (DUF_OPTIONS_SELECTED == "DUF_ElementOptions_SpecialSelect") then
		_G[DUF_SPECIAL_OPTIONS]:Show();
	end
end

function DUF_Slider_Update(self)
	if (not DUF_INITIALIZED) then return; end
	local setting = DUF_Options_GetSetting(self.index);
	if (self.scale) then
		setting = setting * self.scale;
	end
	local min, max = self:GetMinMaxValues();
	if (setting and (setting < min or setting > max)) then
		return;
	end
	local value = self:GetValue();
	_G[self:GetName().."_Display"]:SetText(value);
	if (self.scale) then
		value = value / self.scale;
	end
	DUF_Update_Setting(value, self.index, self.subindex);
	DUF_Run_Functions(self);
end

function DUF_Slider_UpdateFromEditBox(self)
	if (DUF_NOSLIDEREDIT) then return; end
	local value = self:GetNumber();
	if (not value) then value = 0; end
	local min, max = self:GetParent():GetMinMaxValues();
	if (self:GetParent().minlocked and value < min) then value = min; end
	if (self:GetParent().maxlocked and value > max) then value = max; end
	self:SetText(value);
	if (value >= min and value <= max) then
		self:GetParent():SetValue(value);
	end
	self:ClearFocus();
	if (self:GetParent().scale) then
		value = value / self:GetParent().scale;
	end
	DUF_Update_Setting(value, self:GetParent().index, self:GetParent().subindex);
	if (self:GetParent().initFunc) then
		DUF_Run_Functions(self, self:GetParent().initFunc);
	else
		DUF_Run_Functions(self, self:GetParent():GetParent().initFunc);
	end
end

function DUF_Update_SavedSettings()
	DUF_SAVED_SETTINGS = {};
	for setting in pairs(DUF_Settings) do
		if ((not string.find(setting, "INITIALIZED")) and (not string.find(setting, " :: "))) then
			DUF_SAVED_SETTINGS[setting] = { text=setting, value=setting };
		end
	end
	DUF_MiscOptions_CurrentProfile:SetText(DUF_TEXT.CurrentProfile..":  "..DUF_INDEX);
end

function DUF_Update_Setting(value, index, subindex)
	if (not index) then
		return;
	end
	if (not DUF_FRAME_INDEX) then
		if (subindex) then
			DUF_Settings[DUF_INDEX][index][subindex] = value;
		else
			DUF_Settings[DUF_INDEX][index] = value;
		end
	else
		if (DUF_ELEMENT_SUBINDEX) then
			DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX][DUF_ELEMENT_INDEX][DUF_ELEMENT_SUBINDEX][index] = value;
		elseif (DUF_ELEMENT_INDEX) then
			DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX][DUF_ELEMENT_INDEX][index] = value;
		else
			DUF_Settings[DUF_INDEX][DUF_FRAME_INDEX][index] = value;
		end
	end
end

function DUF_ShowProperties_OnClick(self)
	if (self:GetName() == "DUF_Options_GeneralProperties") then
		DUF_SetMenu(nil);
	else
		DUF_SetMenu(true);
	end
end

function DUF_SetMenu(index)
	if (index) then
		DUF_GENERALPROPERTIES = true;
		DUF_Options_FrameOptions:Hide()
		DUF_Options_Buffs:Hide()
		DUF_Options_ClassIcon:Hide()
		DUF_Options_Debuffs:Hide()
		DUF_Options_HealthBar:Hide()
		DUF_Options_LeaderIcon:Hide()
		DUF_Options_LootIcon:Hide()
		DUF_Options_ManaBar:Hide()
		DUF_Options_Portrait:Hide()
		DUF_Options_PVPIcon:Hide()
		DUF_Options_RaceIcon:Hide()
		DUF_Options_RankIcon:Hide()
		DUF_Options_RoleIcon:Hide()
		DUF_Options_StatusIcon:Hide()
		DUF_Options_TargetHealthBar:Hide()
		DUF_Options_TargetManaBar:Hide()
		DUF_Options_CastBar:Hide()
		DUF_Options_TextBox1:Hide()
		DUF_Options_TextBox2:Hide()
		DUF_Options_TextBox3:Hide()
		DUF_Options_TextBox4:Hide()
		DUF_Options_TextBox5:Hide()
		DUF_Options_TextBox6:Hide()
		DUF_Options_TextBox7:Hide()
		DUF_Options_TextBox8:Hide()
		DUF_Options_TextBox9:Hide()
		DUF_Options_TextBox10:Hide()
		DUF_Options_VoiceIcon:Hide()
		DUF_Options_XPBar:Hide()
		DUF_Options_HonorBar:Hide()
--		DUF_Options_EliteTexture:Hide()
		DUF_Options_ClassProperties:Hide()

		DUF_Options_GeneralProperties:Show()
		DUF_Options_TempEnchantBar:Show()
		DUF_Options_DruidManaBar:Show()
		DUF_Options_DruidManaBarTxt:Show()
		DUF_Options_MonkHarmony:Show()
		DUF_Options_PalyPowerFrame:Show()
		DUF_Options_PriestOrbFrame:Show()
		DUF_Options_RuneFrame:Show()
		DUF_Options_WarlockPowerFrame:Show()
		DUF_Options_WarlockDemoFrame:Show()
		DUF_Options_WarlockDemoFrameTxt:Show()
--		DUF_Options_ComboPoints:Show()
	else
		DUF_GENERALPROPERTIES = nil;
		DUF_Options_FrameOptions:Show()
		DUF_Options_Buffs:Show()
		DUF_Options_ClassIcon:Show()
		DUF_Options_Debuffs:Show()
		DUF_Options_HealthBar:Show()
		DUF_Options_LeaderIcon:Show()
		DUF_Options_LootIcon:Show()
		DUF_Options_ManaBar:Show()
		DUF_Options_Portrait:Show()
		DUF_Options_PVPIcon:Show()
		DUF_Options_RaceIcon:Show()
		DUF_Options_RankIcon:Show()
		DUF_Options_RoleIcon:Show()
		DUF_Options_StatusIcon:Show()
		DUF_Options_TargetHealthBar:Show()
		DUF_Options_TargetManaBar:Show()
		DUF_Options_CastBar:Show()
		DUF_Options_TextBox1:Show()
		DUF_Options_TextBox2:Show()
		DUF_Options_TextBox3:Show()
		DUF_Options_TextBox4:Show()
		DUF_Options_TextBox5:Show()
		DUF_Options_TextBox6:Show()
		DUF_Options_TextBox7:Show()
		DUF_Options_TextBox8:Show()
		DUF_Options_TextBox9:Show()
		DUF_Options_TextBox10:Show()
		DUF_Options_VoiceIcon:Show()
		DUF_Options_XPBar:Show()
		DUF_Options_HonorBar:Show()
--		DUF_Options_EliteTexture:Show()
		DUF_Options_ClassProperties:Show()

		DUF_Options_GeneralProperties:Hide()
		DUF_Options_DruidManaBar:Hide()
		DUF_Options_DruidManaBarTxt:Hide()
		DUF_Options_MonkHarmony:Hide()
		DUF_Options_PalyPowerFrame:Hide()
		DUF_Options_PriestOrbFrame:Hide()
		DUF_Options_RuneFrame:Hide()
		DUF_Options_TempEnchantBar:Hide()
		DUF_Options_WarlockPowerFrame:Hide()
		DUF_Options_WarlockDemoFrame:Hide()
		DUF_Options_WarlockDemoFrameTxt:Hide()
--		DUF_Options_ComboPoints:Hide()
	end
end
